/* UndoNodeResize.c generated by valac 0.56.3, the Vala compiler
 * generated from UndoNodeResize.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_NODE_RESIZE (undo_node_resize_get_type ())
#define UNDO_NODE_RESIZE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_NODE_RESIZE, UndoNodeResize))
#define UNDO_NODE_RESIZE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_NODE_RESIZE, UndoNodeResizeClass))
#define IS_UNDO_NODE_RESIZE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_NODE_RESIZE))
#define IS_UNDO_NODE_RESIZE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_NODE_RESIZE))
#define UNDO_NODE_RESIZE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_NODE_RESIZE, UndoNodeResizeClass))

typedef struct _UndoNodeResize UndoNodeResize;
typedef struct _UndoNodeResizeClass UndoNodeResizeClass;
typedef struct _UndoNodeResizePrivate UndoNodeResizePrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	UNDO_NODE_RESIZE_0_PROPERTY,
	UNDO_NODE_RESIZE_NUM_PROPERTIES
};
static GParamSpec* undo_node_resize_properties[UNDO_NODE_RESIZE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoNodeResize {
	UndoItem parent_instance;
	UndoNodeResizePrivate * priv;
};

struct _UndoNodeResizeClass {
	UndoItemClass parent_class;
};

struct _UndoNodeResizePrivate {
	Node* _node;
	gint _old_width;
	gint _new_width;
};

static gint UndoNodeResize_private_offset;
static gpointer undo_node_resize_parent_class = NULL;

VALA_EXTERN GType undo_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN GType undo_node_resize_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoNodeResize, g_object_unref)
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN void undo_item_undo (UndoItem* self,
                     DrawArea* da);
VALA_EXTERN void undo_item_redo (UndoItem* self,
                     DrawArea* da);
VALA_EXTERN UndoNodeResize* undo_node_resize_new (Node* n,
                                      gint old_width);
VALA_EXTERN UndoNodeResize* undo_node_resize_construct (GType object_type,
                                            Node* n,
                                            gint old_width);
VALA_EXTERN UndoItem* undo_item_new (const gchar* name);
VALA_EXTERN UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
VALA_EXTERN gpointer style_ref (gpointer instance);
VALA_EXTERN void style_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_style (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_style (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_style (const GValue* value);
VALA_EXTERN GType style_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
VALA_EXTERN Style* node_get_style (Node* self);
VALA_EXTERN gint* style_get_node_width (Style* self);
static void undo_node_resize_real_undo (UndoItem* base,
                                 DrawArea* da);
VALA_EXTERN void node_resize (Node* self,
                  gdouble diff);
VALA_EXTERN void draw_area_auto_save (DrawArea* self);
static void undo_node_resize_real_redo (UndoItem* base,
                                 DrawArea* da);
static void undo_node_resize_finalize (GObject * obj);
static GType undo_node_resize_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
undo_node_resize_get_instance_private (UndoNodeResize* self)
{
	return G_STRUCT_MEMBER_P (self, UndoNodeResize_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	return self ? g_object_ref (self) : NULL;
#line 194 "UndoNodeResize.c"
}

UndoNodeResize*
undo_node_resize_construct (GType object_type,
                            Node* n,
                            gint old_width)
{
	UndoNodeResize * self = NULL;
	Node* _tmp0_;
	Style* _tmp1_;
	Style* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 32 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) undo_item_construct (object_type, _ ("node resize"));
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = _g_object_ref0 (n);
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	_g_object_unref0 (self->priv->_node);
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_node = _tmp0_;
#line 34 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_old_width = old_width;
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	_tmp1_ = node_get_style (n);
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	_tmp3_ = style_get_node_width (_tmp2_);
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_new_width = *_tmp4_;
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	return self;
#line 232 "UndoNodeResize.c"
}

UndoNodeResize*
undo_node_resize_new (Node* n,
                      gint old_width)
{
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	return undo_node_resize_construct (TYPE_UNDO_NODE_RESIZE, n, old_width);
#line 241 "UndoNodeResize.c"
}

static void
undo_node_resize_real_undo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeResize * self;
	Node* _tmp0_;
#line 39 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) base;
#line 39 "../src/undo_actions/UndoNodeResize.vala"
	g_return_if_fail (da != NULL);
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = self->priv->_node;
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	node_resize (_tmp0_, (gdouble) (self->priv->_old_width - self->priv->_new_width));
#line 41 "../src/undo_actions/UndoNodeResize.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 42 "../src/undo_actions/UndoNodeResize.vala"
	draw_area_auto_save (da);
#line 262 "UndoNodeResize.c"
}

static void
undo_node_resize_real_redo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeResize * self;
	Node* _tmp0_;
#line 46 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) base;
#line 46 "../src/undo_actions/UndoNodeResize.vala"
	g_return_if_fail (da != NULL);
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = self->priv->_node;
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	node_resize (_tmp0_, (gdouble) (self->priv->_new_width - self->priv->_old_width));
#line 48 "../src/undo_actions/UndoNodeResize.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 49 "../src/undo_actions/UndoNodeResize.vala"
	draw_area_auto_save (da);
#line 283 "UndoNodeResize.c"
}

static void
undo_node_resize_class_init (UndoNodeResizeClass * klass,
                             gpointer klass_data)
{
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	undo_node_resize_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	g_type_class_adjust_private_offset (klass, &UndoNodeResize_private_offset);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_node_resize_real_undo;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_node_resize_real_redo;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_node_resize_finalize;
#line 300 "UndoNodeResize.c"
}

static void
undo_node_resize_instance_init (UndoNodeResize * self,
                                gpointer klass)
{
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	self->priv = undo_node_resize_get_instance_private (self);
#line 309 "UndoNodeResize.c"
}

static void
undo_node_resize_finalize (GObject * obj)
{
	UndoNodeResize * self;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_NODE_RESIZE, UndoNodeResize);
#line 26 "../src/undo_actions/UndoNodeResize.vala"
	_g_object_unref0 (self->priv->_node);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	G_OBJECT_CLASS (undo_node_resize_parent_class)->finalize (obj);
#line 322 "UndoNodeResize.c"
}

static GType
undo_node_resize_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UndoNodeResizeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_node_resize_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoNodeResize), 0, (GInstanceInitFunc) undo_node_resize_instance_init, NULL };
	GType undo_node_resize_type_id;
	undo_node_resize_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoNodeResize", &g_define_type_info, 0);
	UndoNodeResize_private_offset = g_type_add_instance_private (undo_node_resize_type_id, sizeof (UndoNodeResizePrivate));
	return undo_node_resize_type_id;
}

GType
undo_node_resize_get_type (void)
{
	static volatile gsize undo_node_resize_type_id__once = 0;
	if (g_once_init_enter (&undo_node_resize_type_id__once)) {
		GType undo_node_resize_type_id;
		undo_node_resize_type_id = undo_node_resize_get_type_once ();
		g_once_init_leave (&undo_node_resize_type_id__once, undo_node_resize_type_id);
	}
	return undo_node_resize_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

