/* Connection.c generated by valac 0.56.3, the Vala compiler
 * generated from Connection.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gtk/gtk.h>
#include <libxml/tree.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CONN_MODE_NONE = 0,
	CONN_MODE_LINKING,
	CONN_MODE_CONNECTING,
	CONN_MODE_SELECTED,
	CONN_MODE_ADJUSTING,
	CONN_MODE_EDITABLE,
	CONN_MODE_DROPPABLE
} ConnMode;

#define TYPE_CONN_MODE (conn_mode_get_type ())

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;
typedef struct _ConnectionPrivate ConnectionPrivate;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

#define TYPE_BEZIER (bezier_get_type ())
#define BEZIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BEZIER, Bezier))
#define BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BEZIER, BezierClass))
#define IS_BEZIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BEZIER))
#define IS_BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BEZIER))
#define BEZIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BEZIER, BezierClass))

typedef struct _Bezier Bezier;
typedef struct _BezierClass BezierClass;

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
enum  {
	CONNECTION_0_PROPERTY,
	CONNECTION_TITLE_PROPERTY,
	CONNECTION_NOTE_PROPERTY,
	CONNECTION_MODE_PROPERTY,
	CONNECTION_FROM_NODE_PROPERTY,
	CONNECTION_TO_NODE_PROPERTY,
	CONNECTION_STYLE_PROPERTY,
	CONNECTION_ALPHA_PROPERTY,
	CONNECTION_COLOR_PROPERTY,
	CONNECTION_STICKER_PROPERTY,
	CONNECTION_EXTENT_X1_PROPERTY,
	CONNECTION_EXTENT_Y1_PROPERTY,
	CONNECTION_EXTENT_X2_PROPERTY,
	CONNECTION_EXTENT_Y2_PROPERTY,
	CONNECTION_NUM_PROPERTIES
};
static GParamSpec* connection_properties[CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _style_unref0(var) ((var == NULL) ? NULL : (var = (style_unref (var), NULL)))
#define _bezier_unref0(var) ((var == NULL) ? NULL : (var = (bezier_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_STYLES (styles_get_type ())
#define STYLES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLES, Styles))
#define STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLES, StylesClass))
#define IS_STYLES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLES))
#define IS_STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLES))
#define STYLES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLES, StylesClass))

typedef struct _Styles Styles;
typedef struct _StylesClass StylesClass;

#define TYPE_FORMATTED_TEXT (formatted_text_get_type ())
#define FORMATTED_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FORMATTED_TEXT, FormattedText))
#define FORMATTED_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FORMATTED_TEXT, FormattedTextClass))
#define IS_FORMATTED_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FORMATTED_TEXT))
#define IS_FORMATTED_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FORMATTED_TEXT))
#define FORMATTED_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FORMATTED_TEXT, FormattedTextClass))

typedef struct _FormattedText FormattedText;
typedef struct _FormattedTextClass FormattedTextClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _Connection {
	GObject parent_instance;
	ConnectionPrivate * priv;
};

struct _ConnectionClass {
	GObjectClass parent_class;
	void (*draw) (Connection* self, cairo_t* ctx, Theme* theme);
};

struct _ConnectionPrivate {
	gint RADIUS;
	ConnMode _mode;
	Node* _from_node;
	Node* _to_node;
	gdouble _posx;
	gdouble _posy;
	gdouble _dragx;
	gdouble _dragy;
	Style* _style;
	Bezier* _curve;
	CanvasText* _title;
	gchar* _note;
	gdouble _max_width;
	GdkRGBA* _color;
	gchar* _sticker;
	GdkPixbuf* _sticker_buf;
	gdouble _alpha;
	gdouble _extent_x1;
	gdouble _extent_y1;
	gdouble _extent_x2;
	gdouble _extent_y2;
};

static gint Connection_private_offset;
static gpointer connection_parent_class = NULL;
VALA_EXTERN Styles* style_inspector_styles;

VALA_EXTERN GType conn_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType connection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Connection, g_object_unref)
VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType node_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
VALA_EXTERN gpointer style_ref (gpointer instance);
VALA_EXTERN void style_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
VALA_EXTERN void value_set_style (GValue* value,
                      gpointer v_object);
VALA_EXTERN void value_take_style (GValue* value,
                       gpointer v_object);
VALA_EXTERN gpointer value_get_style (const GValue* value);
VALA_EXTERN GType style_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Style, style_unref)
VALA_EXTERN gpointer bezier_ref (gpointer instance);
VALA_EXTERN void bezier_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_bezier (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_bezier (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_bezier (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_bezier (const GValue* value);
VALA_EXTERN GType bezier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bezier, bezier_unref)
VALA_EXTERN GType canvas_text_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CanvasText, g_object_unref)
VALA_EXTERN void connection_draw (Connection* self,
                      cairo_t* ctx,
                      Theme* theme);
VALA_EXTERN Style* style_new (void);
VALA_EXTERN Style* style_construct (GType object_type);
static void _vala_GdkRGBA_free (GdkRGBA* self);
VALA_EXTERN GType draw_area_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
VALA_EXTERN Connection* connection_new (DrawArea* da,
                            Node* from_node);
VALA_EXTERN Connection* connection_construct (GType object_type,
                                  DrawArea* da,
                                  Node* from_node);
VALA_EXTERN void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
VALA_EXTERN void connection_connect_node (Connection* self,
                              Node* node);
static void connection_position_title (Connection* self);
VALA_EXTERN Bezier* bezier_new_with_endpoints (gdouble x0,
                                   gdouble y0,
                                   gdouble x1,
                                   gdouble y1);
VALA_EXTERN Bezier* bezier_construct_with_endpoints (GType object_type,
                                         gdouble x0,
                                         gdouble y0,
                                         gdouble x1,
                                         gdouble y1);
VALA_EXTERN gpointer styles_ref (gpointer instance);
VALA_EXTERN void styles_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_styles (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
VALA_EXTERN void value_set_styles (GValue* value,
                       gpointer v_object);
VALA_EXTERN void value_take_styles (GValue* value,
                        gpointer v_object);
VALA_EXTERN gpointer value_get_styles (const GValue* value);
VALA_EXTERN GType styles_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Styles, styles_unref)
VALA_EXTERN Style* styles_get_global_style (Styles* self);
VALA_EXTERN void connection_set_style (Connection* self,
                           Style* value);
VALA_EXTERN Connection* connection_new_from_connection (DrawArea* da,
                                            Connection* conn);
VALA_EXTERN Connection* connection_construct_from_connection (GType object_type,
                                                  DrawArea* da,
                                                  Connection* conn);
VALA_EXTERN Bezier* bezier_new (void);
VALA_EXTERN Bezier* bezier_construct (GType object_type);
VALA_EXTERN void connection_copy (Connection* self,
                      DrawArea* da,
                      Connection* conn);
VALA_EXTERN Connection* connection_new_from_xml (DrawArea* da,
                                     xmlNode* n,
                                     GArray* nodes);
VALA_EXTERN Connection* connection_construct_from_xml (GType object_type,
                                           DrawArea* da,
                                           xmlNode* n,
                                           GArray* nodes);
static void connection_load (Connection* self,
                      DrawArea* da,
                      xmlNode* node,
                      GArray* nodes);
VALA_EXTERN void bezier_copy (Bezier* self,
                  Bezier* b);
VALA_EXTERN CanvasText* connection_get_title (Connection* self);
static void _connection_position_title_canvas_text_resized (CanvasText* _sender,
                                                     gpointer self);
VALA_EXTERN CanvasText* canvas_text_new (DrawArea* da);
VALA_EXTERN CanvasText* canvas_text_construct (GType object_type,
                                   DrawArea* da);
VALA_EXTERN void canvas_text_copy (CanvasText* self,
                       CanvasText* ct);
VALA_EXTERN ConnMode connection_get_mode (Connection* self);
VALA_EXTERN void connection_set_mode (Connection* self,
                          ConnMode value);
VALA_EXTERN Style* connection_get_style (Connection* self);
VALA_EXTERN GdkRGBA* connection_get_color (Connection* self);
VALA_EXTERN void connection_set_color (Connection* self,
                           GdkRGBA* value);
static gint connection_sticker_width (Connection* self,
                               gboolean add_padding);
VALA_EXTERN gint* style_get_connection_padding (Style* self);
static gint* _int_dup (gint* self);
static gint connection_sticker_height (Connection* self);
static gint connection_title_width (Connection* self,
                             gboolean add_padding);
VALA_EXTERN gdouble canvas_text_get_width (CanvasText* self);
static gint connection_title_height (Connection* self);
VALA_EXTERN gdouble canvas_text_get_height (CanvasText* self);
static gint connection_note_width (Connection* self,
                            gboolean add_padding);
VALA_EXTERN const gchar* connection_get_note (Connection* self);
static gint connection_note_height (Connection* self);
static gint connection_get_width (Connection* self);
static gint connection_get_height (Connection* self);
VALA_EXTERN void connection_bbox (Connection* self,
                      gdouble* x,
                      gdouble* y,
                      gdouble* w,
                      gdouble* h);
VALA_EXTERN void connection_edit_title_begin (Connection* self,
                                  DrawArea* da);
VALA_EXTERN CanvasText* canvas_text_new_with_text (DrawArea* da,
                                       const gchar* txt);
VALA_EXTERN CanvasText* canvas_text_construct_with_text (GType object_type,
                                             DrawArea* da,
                                             const gchar* txt);
VALA_EXTERN void canvas_text_set_font (CanvasText* self,
                           const gchar* family,
                           gint* size,
                           gdouble zoom_factor);
VALA_EXTERN PangoFontDescription* style_get_connection_font (Style* self);
VALA_EXTERN void connection_edit_title_end (Connection* self);
VALA_EXTERN gpointer formatted_text_ref (gpointer instance);
VALA_EXTERN void formatted_text_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_formatted_text (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_formatted_text (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_formatted_text (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_formatted_text (const GValue* value);
VALA_EXTERN GType formatted_text_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FormattedText, formatted_text_unref)
VALA_EXTERN FormattedText* canvas_text_get_text (CanvasText* self);
VALA_EXTERN const gchar* formatted_text_get_text (FormattedText* self);
VALA_EXTERN void connection_change_title (Connection* self,
                              DrawArea* da,
                              const gchar* title,
                              gboolean allow_empty);
VALA_EXTERN void formatted_text_set_text (FormattedText* self,
                              const gchar* str);
VALA_EXTERN void canvas_text_set_posx (CanvasText* self,
                           gdouble value);
VALA_EXTERN void canvas_text_set_posy (CanvasText* self,
                           gdouble value);
static void connection_end_moved (Connection* self,
                           Node* node,
                           gdouble diffx,
                           gdouble diffy);
static void _connection_end_moved_node_moved (Node* _sender,
                                       gdouble diffx,
                                       gdouble diffy,
                                       gpointer self);
static void connection_end_resized (Connection* self,
                             Node* node,
                             gdouble diffw,
                             gdouble diffh);
static void _connection_end_resized_node_resized (Node* _sender,
                                           gdouble diffw,
                                           gdouble diffh,
                                           gpointer self);
VALA_EXTERN void connection_disconnect_node (Connection* self,
                                 Node* node);
VALA_EXTERN Connection* node_get_last_selected_connection (Node* self);
VALA_EXTERN void node_set_last_selected_connection (Node* self,
                                        Connection* value);
VALA_EXTERN void connection_connect_to (Connection* self,
                            Node* node);
VALA_EXTERN void bezier_set_point (Bezier* self,
                       gint pindex,
                       gdouble x,
                       gdouble y);
VALA_EXTERN void bezier_get_point (Bezier* self,
                       gint pindex,
                       gdouble* x,
                       gdouble* y);
VALA_EXTERN void bezier_update_control_from_drag_handle (Bezier* self,
                                             gdouble x,
                                             gdouble y);
static void connection_set_connect_point (Connection* self,
                                   Node* node);
VALA_EXTERN void connection_disconnect_from_node (Connection* self,
                                      gboolean from);
VALA_EXTERN void bezier_get_from_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
VALA_EXTERN void bezier_get_to_point (Bezier* self,
                          gdouble* x,
                          gdouble* y);
VALA_EXTERN void connection_draw_to (Connection* self,
                         gdouble x,
                         gdouble y);
VALA_EXTERN gboolean connection_attached_to_node (Connection* self,
                                      Node* node);
VALA_EXTERN Style* node_get_style (Node* self);
VALA_EXTERN gint* style_get_node_borderwidth (Style* self);
VALA_EXTERN gint* style_get_connection_line_width (Style* self);
VALA_EXTERN gint* style_get_node_margin (Style* self);
VALA_EXTERN void bezier_set_connect_point (Bezier* self,
                               gboolean from,
                               gdouble top,
                               gdouble bottom,
                               gdouble left,
                               gdouble right);
VALA_EXTERN gboolean connection_on_curve (Connection* self,
                              gdouble x,
                              gdouble y);
VALA_EXTERN gboolean bezier_within_range (Bezier* self,
                              gdouble x,
                              gdouble y);
static gboolean connection_within_handle (Connection* self,
                                   gdouble hx,
                                   gdouble hy,
                                   gdouble x,
                                   gdouble y);
VALA_EXTERN gboolean connection_within_drag_handle (Connection* self,
                                        gdouble x,
                                        gdouble y);
static void connection_title_bbox (Connection* self,
                            gdouble* x,
                            gdouble* y,
                            gdouble* w,
                            gdouble* h);
VALA_EXTERN gboolean connection_within_from_handle (Connection* self,
                                        gdouble x,
                                        gdouble y);
static gboolean connection_within_endpoint_handle (Connection* self,
                                            gboolean from,
                                            gdouble x,
                                            gdouble y);
VALA_EXTERN gboolean connection_within_to_handle (Connection* self,
                                      gdouble x,
                                      gdouble y);
VALA_EXTERN gboolean connection_within_title_box (Connection* self,
                                      gdouble x,
                                      gdouble y);
VALA_EXTERN gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
VALA_EXTERN gboolean connection_within_title (Connection* self,
                                  gdouble x,
                                  gdouble y);
VALA_EXTERN gboolean canvas_text_is_within (CanvasText* self,
                                gdouble x,
                                gdouble y);
VALA_EXTERN gboolean connection_within_note (Connection* self,
                                 gdouble x,
                                 gdouble y);
static void connection_note_bbox (Connection* self,
                           gdouble* x,
                           gdouble* y,
                           gdouble* w,
                           gdouble* h);
VALA_EXTERN gboolean connection_within_sticker (Connection* self,
                                    gdouble x,
                                    gdouble y);
static void connection_sticker_bbox (Connection* self,
                              gdouble* x,
                              gdouble* y,
                              gdouble* w,
                              gdouble* h);
VALA_EXTERN void connection_move_drag_handle (Connection* self,
                                  gdouble x,
                                  gdouble y);
VALA_EXTERN Node* draw_area_get_node (DrawArea* self,
                          GArray* nodes,
                          gint id);
VALA_EXTERN void connection_set_note (Connection* self,
                          const gchar* value);
VALA_EXTERN Theme* draw_area_get_theme (DrawArea* self);
VALA_EXTERN GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
VALA_EXTERN void connection_set_sticker (Connection* self,
                             const gchar* value);
VALA_EXTERN void style_load_connection (Style* self,
                            xmlNode* node);
VALA_EXTERN void connection_save (Connection* self,
                      xmlNode* parent);
VALA_EXTERN gint node_id (Node* self);
VALA_EXTERN gchar* utils_color_from_rgba (GdkRGBA* rgba);
VALA_EXTERN void style_save_connection (Style* self,
                            xmlNode* parent);
VALA_EXTERN void connection_get_match_items (Connection* self,
                                 const gchar* tabname,
                                 const gchar* pattern,
                                 gboolean* search_opts,
                                 gint search_opts_length1,
                                 GtkListStore** matches);
VALA_EXTERN gchar* utils_rootname (const gchar* filename);
VALA_EXTERN gchar* utils_match_string (const gchar* pattern,
                           const gchar* value);
static void connection_real_draw (Connection* self,
                           cairo_t* ctx,
                           Theme* theme);
VALA_EXTERN gboolean node_is_root (Node* self);
VALA_EXTERN Node* node_get_parent (Node* self);
VALA_EXTERN gboolean node_get_folded (Node* self);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
VALA_EXTERN void style_draw_connection (Style* self,
                            cairo_t* ctx);
VALA_EXTERN void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
VALA_EXTERN gdouble connection_get_alpha (Connection* self);
static void connection_set_extent_x1 (Connection* self,
                               gdouble value);
static void connection_set_extent_y1 (Connection* self,
                               gdouble value);
static void connection_set_extent_x2 (Connection* self,
                               gdouble value);
static void connection_set_extent_y2 (Connection* self,
                               gdouble value);
VALA_EXTERN const gchar* style_get_connection_arrow (Style* self);
VALA_EXTERN void connection_draw_arrow (cairo_t* ctx,
                            gint line_width,
                            gdouble tipx,
                            gdouble tipy,
                            gdouble tailx,
                            gdouble taily,
                            gdouble arrowLength);
static void connection_draw_title (Connection* self,
                            cairo_t* ctx,
                            Theme* theme);
VALA_EXTERN void utils_color_from_string (const gchar* value,
                              GdkRGBA* result);
static void connection_draw_sticker (Connection* self,
                              cairo_t* ctx,
                              Theme* theme);
VALA_EXTERN gdouble connection_get_extent_x1 (Connection* self);
VALA_EXTERN gdouble connection_get_extent_y1 (Connection* self);
VALA_EXTERN gdouble connection_get_extent_x2 (Connection* self);
VALA_EXTERN gdouble connection_get_extent_y2 (Connection* self);
VALA_EXTERN void canvas_text_draw (CanvasText* self,
                       cairo_t* ctx,
                       Theme* theme,
                       GdkRGBA* fg,
                       gdouble alpha,
                       gboolean copy_layout);
static void connection_draw_note (Connection* self,
                           cairo_t* ctx,
                           GdkRGBA* color);
VALA_EXTERN cairo_surface_t* connection_make_arrow_icon (const gchar* type);
VALA_EXTERN void canvas_text_set_edit (CanvasText* self,
                           gboolean value);
VALA_EXTERN void canvas_text_set_cursor_all (CanvasText* self,
                                 gboolean motion);
VALA_EXTERN void canvas_text_clear_selection (CanvasText* self,
                                  const gchar* msg);
VALA_EXTERN Node* connection_get_from_node (Connection* self);
VALA_EXTERN void connection_set_from_node (Connection* self,
                               Node* value);
VALA_EXTERN Node* connection_get_to_node (Connection* self);
VALA_EXTERN void connection_set_to_node (Connection* self,
                             Node* value);
VALA_EXTERN gboolean style_copy (Style* self,
                     Style* s);
VALA_EXTERN gint* style_get_connection_title_width (Style* self);
VALA_EXTERN void canvas_text_set_max_width (CanvasText* self,
                                gdouble value);
VALA_EXTERN void connection_set_alpha (Connection* self,
                           gdouble value);
VALA_EXTERN void node_set_alpha_only (Node* self,
                          gdouble value);
VALA_EXTERN const gchar* connection_get_sticker (Connection* self);
static void connection_finalize (GObject * obj);
static GType connection_get_type_once (void);
static void _vala_connection_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_connection_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
conn_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{CONN_MODE_NONE, "CONN_MODE_NONE", "none"}, {CONN_MODE_LINKING, "CONN_MODE_LINKING", "linking"}, {CONN_MODE_CONNECTING, "CONN_MODE_CONNECTING", "connecting"}, {CONN_MODE_SELECTED, "CONN_MODE_SELECTED", "selected"}, {CONN_MODE_ADJUSTING, "CONN_MODE_ADJUSTING", "adjusting"}, {CONN_MODE_EDITABLE, "CONN_MODE_EDITABLE", "editable"}, {CONN_MODE_DROPPABLE, "CONN_MODE_DROPPABLE", "droppable"}, {0, NULL, NULL}};
	GType conn_mode_type_id;
	conn_mode_type_id = g_enum_register_static ("ConnMode", values);
	return conn_mode_type_id;
}

GType
conn_mode_get_type (void)
{
	static volatile gsize conn_mode_type_id__once = 0;
	if (g_once_init_enter (&conn_mode_type_id__once)) {
		GType conn_mode_type_id;
		conn_mode_type_id = conn_mode_get_type_once ();
		g_once_init_leave (&conn_mode_type_id__once, conn_mode_type_id);
	}
	return conn_mode_type_id__once;
}

static inline gpointer
connection_get_instance_private (Connection* self)
{
	return G_STRUCT_MEMBER_P (self, Connection_private_offset);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
#line 55 "../src/Connection.vala"
	g_boxed_free (gdk_rgba_get_type (), self);
#line 665 "Connection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 178 "../src/Connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 673 "Connection.c"
}

Connection*
connection_construct (GType object_type,
                      DrawArea* da,
                      Node* from_node)
{
	Connection * self = NULL;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Node* _tmp4_;
	Node* _tmp5_;
	Bezier* _tmp6_;
	Styles* _tmp7_;
	Style* _tmp8_;
	Style* _tmp9_;
#line 173 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 173 "../src/Connection.vala"
	g_return_val_if_fail (from_node != NULL, NULL);
#line 173 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 175 "../src/Connection.vala"
	node_bbox (from_node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 175 "../src/Connection.vala"
	x = _tmp0_;
#line 175 "../src/Connection.vala"
	y = _tmp1_;
#line 175 "../src/Connection.vala"
	w = _tmp2_;
#line 175 "../src/Connection.vala"
	h = _tmp3_;
#line 176 "../src/Connection.vala"
	self->priv->_posx = x + (w / 2);
#line 177 "../src/Connection.vala"
	self->priv->_posy = y + (h / 2);
#line 178 "../src/Connection.vala"
	_tmp4_ = _g_object_ref0 (from_node);
#line 178 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 178 "../src/Connection.vala"
	self->priv->_from_node = _tmp4_;
#line 179 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 179 "../src/Connection.vala"
	connection_connect_node (self, _tmp5_);
#line 180 "../src/Connection.vala"
	self->priv->_dragx = self->priv->_posx;
#line 181 "../src/Connection.vala"
	self->priv->_dragy = self->priv->_posy;
#line 182 "../src/Connection.vala"
	connection_position_title (self);
#line 183 "../src/Connection.vala"
	_tmp6_ = bezier_new_with_endpoints (self->priv->_posx, self->priv->_posy, self->priv->_posx, self->priv->_posy);
#line 183 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 183 "../src/Connection.vala"
	self->priv->_curve = _tmp6_;
#line 184 "../src/Connection.vala"
	_tmp7_ = style_inspector_styles;
#line 184 "../src/Connection.vala"
	_tmp8_ = styles_get_global_style (_tmp7_);
#line 184 "../src/Connection.vala"
	_tmp9_ = _tmp8_;
#line 184 "../src/Connection.vala"
	connection_set_style (self, _tmp9_);
#line 184 "../src/Connection.vala"
	_style_unref0 (_tmp9_);
#line 173 "../src/Connection.vala"
	return self;
#line 750 "Connection.c"
}

Connection*
connection_new (DrawArea* da,
                Node* from_node)
{
#line 173 "../src/Connection.vala"
	return connection_construct (TYPE_CONNECTION, da, from_node);
#line 759 "Connection.c"
}

Connection*
connection_construct_from_connection (GType object_type,
                                      DrawArea* da,
                                      Connection* conn)
{
	Connection * self = NULL;
	Bezier* _tmp0_;
#line 188 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 188 "../src/Connection.vala"
	g_return_val_if_fail (conn != NULL, NULL);
#line 188 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 189 "../src/Connection.vala"
	_tmp0_ = bezier_new ();
#line 189 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 189 "../src/Connection.vala"
	self->priv->_curve = _tmp0_;
#line 190 "../src/Connection.vala"
	connection_copy (self, da, conn);
#line 188 "../src/Connection.vala"
	return self;
#line 785 "Connection.c"
}

Connection*
connection_new_from_connection (DrawArea* da,
                                Connection* conn)
{
#line 188 "../src/Connection.vala"
	return connection_construct_from_connection (TYPE_CONNECTION, da, conn);
#line 794 "Connection.c"
}

Connection*
connection_construct_from_xml (GType object_type,
                               DrawArea* da,
                               xmlNode* n,
                               GArray* nodes)
{
	Connection * self = NULL;
	Styles* _tmp0_;
	Style* _tmp1_;
	Style* _tmp2_;
#line 194 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 194 "../src/Connection.vala"
	g_return_val_if_fail (nodes != NULL, NULL);
#line 194 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 195 "../src/Connection.vala"
	_tmp0_ = style_inspector_styles;
#line 195 "../src/Connection.vala"
	_tmp1_ = styles_get_global_style (_tmp0_);
#line 195 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 195 "../src/Connection.vala"
	connection_set_style (self, _tmp2_);
#line 195 "../src/Connection.vala"
	_style_unref0 (_tmp2_);
#line 196 "../src/Connection.vala"
	connection_load (self, da, n, nodes);
#line 194 "../src/Connection.vala"
	return self;
#line 827 "Connection.c"
}

Connection*
connection_new_from_xml (DrawArea* da,
                         xmlNode* n,
                         GArray* nodes)
{
#line 194 "../src/Connection.vala"
	return connection_construct_from_xml (TYPE_CONNECTION, da, n, nodes);
#line 837 "Connection.c"
}

static void
_connection_position_title_canvas_text_resized (CanvasText* _sender,
                                                gpointer self)
{
#line 209 "../src/Connection.vala"
	connection_position_title ((Connection*) self);
#line 846 "Connection.c"
}

void
connection_copy (Connection* self,
                 DrawArea* da,
                 Connection* conn)
{
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	Bezier* _tmp4_;
	Bezier* _tmp5_;
	CanvasText* _tmp6_;
	CanvasText* _tmp7_;
	ConnMode _tmp18_;
	ConnMode _tmp19_;
	Style* _tmp20_;
	Style* _tmp21_;
	GdkRGBA* _tmp22_;
	GdkRGBA* _tmp23_;
#line 200 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 200 "../src/Connection.vala"
	g_return_if_fail (conn != NULL);
#line 201 "../src/Connection.vala"
	_tmp0_ = conn->priv->_from_node;
#line 201 "../src/Connection.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 201 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 201 "../src/Connection.vala"
	self->priv->_from_node = _tmp1_;
#line 202 "../src/Connection.vala"
	_tmp2_ = conn->priv->_to_node;
#line 202 "../src/Connection.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 202 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 202 "../src/Connection.vala"
	self->priv->_to_node = _tmp3_;
#line 203 "../src/Connection.vala"
	self->priv->_dragx = conn->priv->_dragx;
#line 204 "../src/Connection.vala"
	self->priv->_dragy = conn->priv->_dragy;
#line 205 "../src/Connection.vala"
	connection_position_title (self);
#line 206 "../src/Connection.vala"
	_tmp4_ = self->priv->_curve;
#line 206 "../src/Connection.vala"
	_tmp5_ = conn->priv->_curve;
#line 206 "../src/Connection.vala"
	bezier_copy (_tmp4_, _tmp5_);
#line 207 "../src/Connection.vala"
	_tmp6_ = connection_get_title (conn);
#line 207 "../src/Connection.vala"
	_tmp7_ = _tmp6_;
#line 207 "../src/Connection.vala"
	if (_tmp7_ == NULL) {
#line 908 "Connection.c"
		CanvasText* _tmp8_;
#line 208 "../src/Connection.vala"
		_tmp8_ = self->priv->_title;
#line 208 "../src/Connection.vala"
		if (_tmp8_ != NULL) {
#line 914 "Connection.c"
			CanvasText* _tmp9_;
			guint _tmp10_;
#line 209 "../src/Connection.vala"
			_tmp9_ = self->priv->_title;
#line 209 "../src/Connection.vala"
			g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp10_, NULL, FALSE);
#line 209 "../src/Connection.vala"
			g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 923 "Connection.c"
		}
#line 211 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_title);
#line 211 "../src/Connection.vala"
		self->priv->_title = NULL;
#line 929 "Connection.c"
	} else {
		CanvasText* _tmp11_;
		CanvasText* _tmp12_;
		CanvasText* _tmp15_;
		CanvasText* _tmp16_;
		CanvasText* _tmp17_;
#line 213 "../src/Connection.vala"
		_tmp11_ = connection_get_title (self);
#line 213 "../src/Connection.vala"
		_tmp12_ = _tmp11_;
#line 213 "../src/Connection.vala"
		if (_tmp12_ == NULL) {
#line 942 "Connection.c"
			CanvasText* _tmp13_;
			CanvasText* _tmp14_;
#line 214 "../src/Connection.vala"
			_tmp13_ = canvas_text_new (da);
#line 214 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_title);
#line 214 "../src/Connection.vala"
			self->priv->_title = _tmp13_;
#line 215 "../src/Connection.vala"
			_tmp14_ = self->priv->_title;
#line 215 "../src/Connection.vala"
			g_signal_connect_object (_tmp14_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 955 "Connection.c"
		}
#line 217 "../src/Connection.vala"
		_tmp15_ = self->priv->_title;
#line 217 "../src/Connection.vala"
		_tmp16_ = connection_get_title (conn);
#line 217 "../src/Connection.vala"
		_tmp17_ = _tmp16_;
#line 217 "../src/Connection.vala"
		canvas_text_copy (_tmp15_, _tmp17_);
#line 965 "Connection.c"
	}
#line 219 "../src/Connection.vala"
	_tmp18_ = connection_get_mode (conn);
#line 219 "../src/Connection.vala"
	_tmp19_ = _tmp18_;
#line 219 "../src/Connection.vala"
	connection_set_mode (self, _tmp19_);
#line 220 "../src/Connection.vala"
	_tmp20_ = connection_get_style (conn);
#line 220 "../src/Connection.vala"
	_tmp21_ = _tmp20_;
#line 220 "../src/Connection.vala"
	connection_set_style (self, _tmp21_);
#line 221 "../src/Connection.vala"
	_tmp22_ = connection_get_color (conn);
#line 221 "../src/Connection.vala"
	_tmp23_ = _tmp22_;
#line 221 "../src/Connection.vala"
	connection_set_color (self, _tmp23_);
#line 985 "Connection.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 225 "../src/Connection.vala"
	dup = g_new0 (gint, 1);
#line 225 "../src/Connection.vala"
	memcpy (dup, self, sizeof (gint));
#line 225 "../src/Connection.vala"
	return dup;
#line 998 "Connection.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 225 "../src/Connection.vala"
	return self ? _int_dup (self) : NULL;
#line 1006 "Connection.c"
}

static gint
connection_sticker_width (Connection* self,
                          gboolean add_padding)
{
	gint* _tmp0_ = NULL;
	gint* padding = NULL;
	gint* _tmp12_;
	gint _tmp13_ = 0;
	GdkPixbuf* _tmp14_;
	gint result;
#line 224 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 225 "../src/Connection.vala"
	if (add_padding) {
#line 1023 "Connection.c"
		gint* _tmp1_ = NULL;
		Style* _tmp2_;
		Style* _tmp3_;
		gint* _tmp4_;
		gint* _tmp5_;
		gint* _tmp6_;
		gint* _tmp9_;
#line 225 "../src/Connection.vala"
		_tmp2_ = connection_get_style (self);
#line 225 "../src/Connection.vala"
		_tmp3_ = _tmp2_;
#line 225 "../src/Connection.vala"
		_tmp4_ = style_get_connection_padding (_tmp3_);
#line 225 "../src/Connection.vala"
		_tmp5_ = _tmp4_;
#line 225 "../src/Connection.vala"
		_tmp6_ = __int_dup0 (_tmp5_);
#line 225 "../src/Connection.vala"
		_tmp1_ = _tmp6_;
#line 225 "../src/Connection.vala"
		if (_tmp1_ == NULL) {
#line 1045 "Connection.c"
			gint _tmp7_;
			gint* _tmp8_;
#line 225 "../src/Connection.vala"
			_tmp7_ = 0;
#line 225 "../src/Connection.vala"
			_tmp8_ = __int_dup0 (&_tmp7_);
#line 225 "../src/Connection.vala"
			_g_free0 (_tmp1_);
#line 225 "../src/Connection.vala"
			_tmp1_ = _tmp8_;
#line 1056 "Connection.c"
		}
#line 225 "../src/Connection.vala"
		_tmp9_ = _tmp1_;
#line 225 "../src/Connection.vala"
		_tmp1_ = NULL;
#line 225 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 225 "../src/Connection.vala"
		_tmp0_ = _tmp9_;
#line 225 "../src/Connection.vala"
		_g_free0 (_tmp1_);
#line 1068 "Connection.c"
	} else {
		gint _tmp10_;
		gint* _tmp11_;
#line 225 "../src/Connection.vala"
		_tmp10_ = 0;
#line 225 "../src/Connection.vala"
		_tmp11_ = __int_dup0 (&_tmp10_);
#line 225 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 225 "../src/Connection.vala"
		_tmp0_ = _tmp11_;
#line 1080 "Connection.c"
	}
#line 225 "../src/Connection.vala"
	_tmp12_ = __int_dup0 (_tmp0_);
#line 225 "../src/Connection.vala"
	padding = _tmp12_;
#line 226 "../src/Connection.vala"
	_tmp14_ = self->priv->_sticker_buf;
#line 226 "../src/Connection.vala"
	if (_tmp14_ != NULL) {
#line 1090 "Connection.c"
		GdkPixbuf* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint* _tmp18_;
#line 226 "../src/Connection.vala"
		_tmp15_ = self->priv->_sticker_buf;
#line 226 "../src/Connection.vala"
		_tmp16_ = gdk_pixbuf_get_width (_tmp15_);
#line 226 "../src/Connection.vala"
		_tmp17_ = _tmp16_;
#line 226 "../src/Connection.vala"
		_tmp18_ = padding;
#line 226 "../src/Connection.vala"
		_tmp13_ = _tmp17_ + (*_tmp18_);
#line 1105 "Connection.c"
	} else {
#line 226 "../src/Connection.vala"
		_tmp13_ = 0;
#line 1109 "Connection.c"
	}
#line 226 "../src/Connection.vala"
	result = _tmp13_;
#line 226 "../src/Connection.vala"
	_g_free0 (padding);
#line 226 "../src/Connection.vala"
	_g_free0 (_tmp0_);
#line 226 "../src/Connection.vala"
	return result;
#line 1119 "Connection.c"
}

static gint
connection_sticker_height (Connection* self)
{
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_;
	gint result;
#line 229 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../src/Connection.vala"
	_tmp1_ = self->priv->_sticker_buf;
#line 230 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 1134 "Connection.c"
		GdkPixbuf* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 230 "../src/Connection.vala"
		_tmp2_ = self->priv->_sticker_buf;
#line 230 "../src/Connection.vala"
		_tmp3_ = gdk_pixbuf_get_height (_tmp2_);
#line 230 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 230 "../src/Connection.vala"
		_tmp0_ = _tmp4_;
#line 1146 "Connection.c"
	} else {
#line 230 "../src/Connection.vala"
		_tmp0_ = 0;
#line 1150 "Connection.c"
	}
#line 230 "../src/Connection.vala"
	result = _tmp0_;
#line 230 "../src/Connection.vala"
	return result;
#line 1156 "Connection.c"
}

static gint
connection_title_width (Connection* self,
                        gboolean add_padding)
{
	gint* _tmp0_ = NULL;
	gint* padding = NULL;
	gint* _tmp12_;
	gint _tmp13_ = 0;
	CanvasText* _tmp14_;
	gint result;
#line 233 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 234 "../src/Connection.vala"
	if (add_padding) {
#line 1173 "Connection.c"
		gint* _tmp1_ = NULL;
		Style* _tmp2_;
		Style* _tmp3_;
		gint* _tmp4_;
		gint* _tmp5_;
		gint* _tmp6_;
		gint* _tmp9_;
#line 234 "../src/Connection.vala"
		_tmp2_ = connection_get_style (self);
#line 234 "../src/Connection.vala"
		_tmp3_ = _tmp2_;
#line 234 "../src/Connection.vala"
		_tmp4_ = style_get_connection_padding (_tmp3_);
#line 234 "../src/Connection.vala"
		_tmp5_ = _tmp4_;
#line 234 "../src/Connection.vala"
		_tmp6_ = __int_dup0 (_tmp5_);
#line 234 "../src/Connection.vala"
		_tmp1_ = _tmp6_;
#line 234 "../src/Connection.vala"
		if (_tmp1_ == NULL) {
#line 1195 "Connection.c"
			gint _tmp7_;
			gint* _tmp8_;
#line 234 "../src/Connection.vala"
			_tmp7_ = 0;
#line 234 "../src/Connection.vala"
			_tmp8_ = __int_dup0 (&_tmp7_);
#line 234 "../src/Connection.vala"
			_g_free0 (_tmp1_);
#line 234 "../src/Connection.vala"
			_tmp1_ = _tmp8_;
#line 1206 "Connection.c"
		}
#line 234 "../src/Connection.vala"
		_tmp9_ = _tmp1_;
#line 234 "../src/Connection.vala"
		_tmp1_ = NULL;
#line 234 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 234 "../src/Connection.vala"
		_tmp0_ = _tmp9_;
#line 234 "../src/Connection.vala"
		_g_free0 (_tmp1_);
#line 1218 "Connection.c"
	} else {
		gint _tmp10_;
		gint* _tmp11_;
#line 234 "../src/Connection.vala"
		_tmp10_ = 0;
#line 234 "../src/Connection.vala"
		_tmp11_ = __int_dup0 (&_tmp10_);
#line 234 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 234 "../src/Connection.vala"
		_tmp0_ = _tmp11_;
#line 1230 "Connection.c"
	}
#line 234 "../src/Connection.vala"
	_tmp12_ = __int_dup0 (_tmp0_);
#line 234 "../src/Connection.vala"
	padding = _tmp12_;
#line 235 "../src/Connection.vala"
	_tmp14_ = self->priv->_title;
#line 235 "../src/Connection.vala"
	if (_tmp14_ != NULL) {
#line 1240 "Connection.c"
		CanvasText* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gint* _tmp18_;
#line 235 "../src/Connection.vala"
		_tmp15_ = self->priv->_title;
#line 235 "../src/Connection.vala"
		_tmp16_ = canvas_text_get_width (_tmp15_);
#line 235 "../src/Connection.vala"
		_tmp17_ = _tmp16_;
#line 235 "../src/Connection.vala"
		_tmp18_ = padding;
#line 235 "../src/Connection.vala"
		_tmp13_ = ((gint) _tmp17_) + (*_tmp18_);
#line 1255 "Connection.c"
	} else {
#line 235 "../src/Connection.vala"
		_tmp13_ = 0;
#line 1259 "Connection.c"
	}
#line 235 "../src/Connection.vala"
	result = _tmp13_;
#line 235 "../src/Connection.vala"
	_g_free0 (padding);
#line 235 "../src/Connection.vala"
	_g_free0 (_tmp0_);
#line 235 "../src/Connection.vala"
	return result;
#line 1269 "Connection.c"
}

static gint
connection_title_height (Connection* self)
{
	gint _tmp0_ = 0;
	CanvasText* _tmp1_;
	gint result;
#line 238 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 239 "../src/Connection.vala"
	_tmp1_ = self->priv->_title;
#line 239 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 1284 "Connection.c"
		CanvasText* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
#line 239 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 239 "../src/Connection.vala"
		_tmp3_ = canvas_text_get_height (_tmp2_);
#line 239 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 239 "../src/Connection.vala"
		_tmp0_ = (gint) _tmp4_;
#line 1296 "Connection.c"
	} else {
#line 239 "../src/Connection.vala"
		_tmp0_ = 0;
#line 1300 "Connection.c"
	}
#line 239 "../src/Connection.vala"
	result = _tmp0_;
#line 239 "../src/Connection.vala"
	return result;
#line 1306 "Connection.c"
}

static gint
connection_note_width (Connection* self,
                       gboolean add_padding)
{
	gint* _tmp0_ = NULL;
	gint* padding = NULL;
	gint* _tmp12_;
	gint _tmp13_ = 0;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint result;
#line 242 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 243 "../src/Connection.vala"
	if (add_padding) {
#line 1326 "Connection.c"
		gint* _tmp1_ = NULL;
		Style* _tmp2_;
		Style* _tmp3_;
		gint* _tmp4_;
		gint* _tmp5_;
		gint* _tmp6_;
		gint* _tmp9_;
#line 243 "../src/Connection.vala"
		_tmp2_ = connection_get_style (self);
#line 243 "../src/Connection.vala"
		_tmp3_ = _tmp2_;
#line 243 "../src/Connection.vala"
		_tmp4_ = style_get_connection_padding (_tmp3_);
#line 243 "../src/Connection.vala"
		_tmp5_ = _tmp4_;
#line 243 "../src/Connection.vala"
		_tmp6_ = __int_dup0 (_tmp5_);
#line 243 "../src/Connection.vala"
		_tmp1_ = _tmp6_;
#line 243 "../src/Connection.vala"
		if (_tmp1_ == NULL) {
#line 1348 "Connection.c"
			gint _tmp7_;
			gint* _tmp8_;
#line 243 "../src/Connection.vala"
			_tmp7_ = 0;
#line 243 "../src/Connection.vala"
			_tmp8_ = __int_dup0 (&_tmp7_);
#line 243 "../src/Connection.vala"
			_g_free0 (_tmp1_);
#line 243 "../src/Connection.vala"
			_tmp1_ = _tmp8_;
#line 1359 "Connection.c"
		}
#line 243 "../src/Connection.vala"
		_tmp9_ = _tmp1_;
#line 243 "../src/Connection.vala"
		_tmp1_ = NULL;
#line 243 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 243 "../src/Connection.vala"
		_tmp0_ = _tmp9_;
#line 243 "../src/Connection.vala"
		_g_free0 (_tmp1_);
#line 1371 "Connection.c"
	} else {
		gint _tmp10_;
		gint* _tmp11_;
#line 243 "../src/Connection.vala"
		_tmp10_ = 0;
#line 243 "../src/Connection.vala"
		_tmp11_ = __int_dup0 (&_tmp10_);
#line 243 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 243 "../src/Connection.vala"
		_tmp0_ = _tmp11_;
#line 1383 "Connection.c"
	}
#line 243 "../src/Connection.vala"
	_tmp12_ = __int_dup0 (_tmp0_);
#line 243 "../src/Connection.vala"
	padding = _tmp12_;
#line 244 "../src/Connection.vala"
	_tmp14_ = connection_get_note (self);
#line 244 "../src/Connection.vala"
	_tmp15_ = _tmp14_;
#line 244 "../src/Connection.vala"
	_tmp16_ = strlen (_tmp15_);
#line 244 "../src/Connection.vala"
	_tmp17_ = _tmp16_;
#line 244 "../src/Connection.vala"
	if (_tmp17_ > 0) {
#line 1399 "Connection.c"
		gint* _tmp18_;
#line 244 "../src/Connection.vala"
		_tmp18_ = padding;
#line 244 "../src/Connection.vala"
		_tmp13_ = 11 + (*_tmp18_);
#line 1405 "Connection.c"
	} else {
#line 244 "../src/Connection.vala"
		_tmp13_ = 0;
#line 1409 "Connection.c"
	}
#line 244 "../src/Connection.vala"
	result = _tmp13_;
#line 244 "../src/Connection.vala"
	_g_free0 (padding);
#line 244 "../src/Connection.vala"
	_g_free0 (_tmp0_);
#line 244 "../src/Connection.vala"
	return result;
#line 1419 "Connection.c"
}

static gint
connection_note_height (Connection* self)
{
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint result;
#line 247 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 248 "../src/Connection.vala"
	_tmp1_ = connection_get_note (self);
#line 248 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 248 "../src/Connection.vala"
	_tmp3_ = strlen (_tmp2_);
#line 248 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 248 "../src/Connection.vala"
	if (_tmp4_ > 0) {
#line 248 "../src/Connection.vala"
		_tmp0_ = 11;
#line 1445 "Connection.c"
	} else {
#line 248 "../src/Connection.vala"
		_tmp0_ = 0;
#line 1449 "Connection.c"
	}
#line 248 "../src/Connection.vala"
	result = _tmp0_;
#line 248 "../src/Connection.vala"
	return result;
#line 1455 "Connection.c"
}

static gint
connection_get_width (Connection* self)
{
	gint sw = 0;
	gint tw = 0;
	gint nw = 0;
	gint result;
#line 251 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 252 "../src/Connection.vala"
	sw = connection_sticker_width (self, FALSE);
#line 253 "../src/Connection.vala"
	tw = connection_title_width (self, sw > 0);
#line 254 "../src/Connection.vala"
	nw = connection_note_width (self, (sw + tw) > 0);
#line 255 "../src/Connection.vala"
	result = (sw + tw) + nw;
#line 255 "../src/Connection.vala"
	return result;
#line 1477 "Connection.c"
}

static gint
connection_get_height (Connection* self)
{
	gint sh = 0;
	gint th = 0;
	gint nh = 0;
	gboolean _tmp0_ = FALSE;
	gint result;
#line 258 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../src/Connection.vala"
	sh = connection_sticker_height (self);
#line 260 "../src/Connection.vala"
	th = connection_title_height (self);
#line 261 "../src/Connection.vala"
	nh = connection_note_height (self);
#line 262 "../src/Connection.vala"
	if (sh <= th) {
#line 262 "../src/Connection.vala"
		_tmp0_ = nh <= th;
#line 1500 "Connection.c"
	} else {
#line 262 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 1504 "Connection.c"
	}
#line 262 "../src/Connection.vala"
	if (_tmp0_) {
#line 262 "../src/Connection.vala"
		result = th;
#line 262 "../src/Connection.vala"
		return result;
#line 1512 "Connection.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 263 "../src/Connection.vala"
		if (th <= sh) {
#line 263 "../src/Connection.vala"
			_tmp1_ = nh <= sh;
#line 1519 "Connection.c"
		} else {
#line 263 "../src/Connection.vala"
			_tmp1_ = FALSE;
#line 1523 "Connection.c"
		}
#line 263 "../src/Connection.vala"
		if (_tmp1_) {
#line 263 "../src/Connection.vala"
			result = sh;
#line 263 "../src/Connection.vala"
			return result;
#line 1531 "Connection.c"
		} else {
#line 264 "../src/Connection.vala"
			result = nh;
#line 264 "../src/Connection.vala"
			return result;
#line 1537 "Connection.c"
		}
	}
}

void
connection_bbox (Connection* self,
                 gdouble* x,
                 gdouble* y,
                 gdouble* w,
                 gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fw = 0.0;
	gdouble fh = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble tw = 0.0;
	gdouble th = 0.0;
	gboolean _tmp0_ = FALSE;
	Node* _tmp1_;
#line 268 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 271 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 271 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 1569 "Connection.c"
		Node* _tmp2_;
#line 271 "../src/Connection.vala"
		_tmp2_ = self->priv->_to_node;
#line 271 "../src/Connection.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1575 "Connection.c"
	} else {
#line 271 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 1579 "Connection.c"
	}
#line 271 "../src/Connection.vala"
	if (_tmp0_) {
#line 1583 "Connection.c"
		Node* _tmp3_;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		Node* _tmp8_;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
#line 272 "../src/Connection.vala"
		_tmp3_ = self->priv->_from_node;
#line 272 "../src/Connection.vala"
		node_bbox (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 272 "../src/Connection.vala"
		fx = _tmp4_;
#line 272 "../src/Connection.vala"
		fy = _tmp5_;
#line 272 "../src/Connection.vala"
		fw = _tmp6_;
#line 272 "../src/Connection.vala"
		fh = _tmp7_;
#line 273 "../src/Connection.vala"
		_tmp8_ = self->priv->_to_node;
#line 273 "../src/Connection.vala"
		node_bbox (_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 273 "../src/Connection.vala"
		tx = _tmp9_;
#line 273 "../src/Connection.vala"
		ty = _tmp10_;
#line 273 "../src/Connection.vala"
		tw = _tmp11_;
#line 273 "../src/Connection.vala"
		th = _tmp12_;
#line 274 "../src/Connection.vala"
		if (fx < tx) {
#line 274 "../src/Connection.vala"
			_tmp13_ = fx;
#line 1626 "Connection.c"
		} else {
#line 274 "../src/Connection.vala"
			_tmp13_ = tx;
#line 1630 "Connection.c"
		}
#line 274 "../src/Connection.vala"
		_vala_x = _tmp13_;
#line 275 "../src/Connection.vala"
		if (fy < ty) {
#line 275 "../src/Connection.vala"
			_tmp14_ = fy;
#line 1638 "Connection.c"
		} else {
#line 275 "../src/Connection.vala"
			_tmp14_ = ty;
#line 1642 "Connection.c"
		}
#line 275 "../src/Connection.vala"
		_vala_y = _tmp14_;
#line 276 "../src/Connection.vala"
		if ((fx + fw) > (tx + tw)) {
#line 276 "../src/Connection.vala"
			_tmp15_ = (fx + fw) - _vala_x;
#line 1650 "Connection.c"
		} else {
#line 276 "../src/Connection.vala"
			_tmp15_ = (tx + tw) - _vala_x;
#line 1654 "Connection.c"
		}
#line 276 "../src/Connection.vala"
		_vala_w = _tmp15_;
#line 277 "../src/Connection.vala"
		if ((fy + fh) > (ty + th)) {
#line 277 "../src/Connection.vala"
			_tmp16_ = (fy + fh) - _vala_y;
#line 1662 "Connection.c"
		} else {
#line 277 "../src/Connection.vala"
			_tmp16_ = (ty + th) - _vala_y;
#line 1666 "Connection.c"
		}
#line 277 "../src/Connection.vala"
		_vala_h = _tmp16_;
#line 1670 "Connection.c"
	} else {
		Node* _tmp17_;
#line 278 "../src/Connection.vala"
		_tmp17_ = self->priv->_from_node;
#line 278 "../src/Connection.vala"
		if (_tmp17_ != NULL) {
#line 1677 "Connection.c"
			Node* _tmp18_;
			gdouble _tmp19_ = 0.0;
			gdouble _tmp20_ = 0.0;
			gdouble _tmp21_ = 0.0;
			gdouble _tmp22_ = 0.0;
#line 279 "../src/Connection.vala"
			_tmp18_ = self->priv->_from_node;
#line 279 "../src/Connection.vala"
			node_bbox (_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_, &_tmp22_);
#line 279 "../src/Connection.vala"
			_vala_x = _tmp19_;
#line 279 "../src/Connection.vala"
			_vala_y = _tmp20_;
#line 279 "../src/Connection.vala"
			_vala_w = _tmp21_;
#line 279 "../src/Connection.vala"
			_vala_h = _tmp22_;
#line 1695 "Connection.c"
		} else {
			Node* _tmp23_;
#line 280 "../src/Connection.vala"
			_tmp23_ = self->priv->_to_node;
#line 280 "../src/Connection.vala"
			if (_tmp23_ != NULL) {
#line 1702 "Connection.c"
				Node* _tmp24_;
				gdouble _tmp25_ = 0.0;
				gdouble _tmp26_ = 0.0;
				gdouble _tmp27_ = 0.0;
				gdouble _tmp28_ = 0.0;
#line 281 "../src/Connection.vala"
				_tmp24_ = self->priv->_to_node;
#line 281 "../src/Connection.vala"
				node_bbox (_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_, &_tmp28_);
#line 281 "../src/Connection.vala"
				_vala_x = _tmp25_;
#line 281 "../src/Connection.vala"
				_vala_y = _tmp26_;
#line 281 "../src/Connection.vala"
				_vala_w = _tmp27_;
#line 281 "../src/Connection.vala"
				_vala_h = _tmp28_;
#line 1720 "Connection.c"
			} else {
#line 283 "../src/Connection.vala"
				_vala_x = (gdouble) 0;
#line 284 "../src/Connection.vala"
				_vala_y = (gdouble) 0;
#line 285 "../src/Connection.vala"
				_vala_w = (gdouble) 0;
#line 286 "../src/Connection.vala"
				_vala_h = (gdouble) 0;
#line 1730 "Connection.c"
			}
		}
	}
#line 268 "../src/Connection.vala"
	if (x) {
#line 268 "../src/Connection.vala"
		*x = _vala_x;
#line 1738 "Connection.c"
	}
#line 268 "../src/Connection.vala"
	if (y) {
#line 268 "../src/Connection.vala"
		*y = _vala_y;
#line 1744 "Connection.c"
	}
#line 268 "../src/Connection.vala"
	if (w) {
#line 268 "../src/Connection.vala"
		*w = _vala_w;
#line 1750 "Connection.c"
	}
#line 268 "../src/Connection.vala"
	if (h) {
#line 268 "../src/Connection.vala"
		*h = _vala_h;
#line 1756 "Connection.c"
	}
}

void
connection_edit_title_begin (Connection* self,
                             DrawArea* da)
{
	CanvasText* _tmp0_;
	CanvasText* _tmp1_;
	CanvasText* _tmp2_;
	CanvasText* _tmp3_;
	Style* _tmp4_;
	Style* _tmp5_;
	PangoFontDescription* _tmp6_;
	PangoFontDescription* _tmp7_;
	const gchar* _tmp8_;
	Style* _tmp9_;
	Style* _tmp10_;
	PangoFontDescription* _tmp11_;
	PangoFontDescription* _tmp12_;
	gint _tmp13_;
#line 291 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 291 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 292 "../src/Connection.vala"
	_tmp0_ = self->priv->_title;
#line 292 "../src/Connection.vala"
	if (_tmp0_ != NULL) {
#line 292 "../src/Connection.vala"
		return;
#line 1788 "Connection.c"
	}
#line 293 "../src/Connection.vala"
	_tmp1_ = canvas_text_new_with_text (da, "");
#line 293 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 293 "../src/Connection.vala"
	self->priv->_title = _tmp1_;
#line 294 "../src/Connection.vala"
	_tmp2_ = self->priv->_title;
#line 294 "../src/Connection.vala"
	g_signal_connect_object (_tmp2_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 295 "../src/Connection.vala"
	_tmp3_ = self->priv->_title;
#line 295 "../src/Connection.vala"
	_tmp4_ = connection_get_style (self);
#line 295 "../src/Connection.vala"
	_tmp5_ = _tmp4_;
#line 295 "../src/Connection.vala"
	_tmp6_ = style_get_connection_font (_tmp5_);
#line 295 "../src/Connection.vala"
	_tmp7_ = _tmp6_;
#line 295 "../src/Connection.vala"
	_tmp8_ = pango_font_description_get_family (_tmp7_);
#line 295 "../src/Connection.vala"
	_tmp9_ = connection_get_style (self);
#line 295 "../src/Connection.vala"
	_tmp10_ = _tmp9_;
#line 295 "../src/Connection.vala"
	_tmp11_ = style_get_connection_font (_tmp10_);
#line 295 "../src/Connection.vala"
	_tmp12_ = _tmp11_;
#line 295 "../src/Connection.vala"
	_tmp13_ = pango_font_description_get_size (_tmp12_) / PANGO_SCALE;
#line 295 "../src/Connection.vala"
	canvas_text_set_font (_tmp3_, _tmp8_, &_tmp13_, 1.0);
#line 296 "../src/Connection.vala"
	connection_position_title (self);
#line 1826 "Connection.c"
}

void
connection_edit_title_end (Connection* self)
{
	gboolean _tmp0_ = FALSE;
	CanvasText* _tmp1_;
	CanvasText* _tmp7_;
	guint _tmp8_;
#line 300 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Connection.vala"
	_tmp1_ = self->priv->_title;
#line 301 "../src/Connection.vala"
	if (_tmp1_ == NULL) {
#line 301 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 1844 "Connection.c"
	} else {
		CanvasText* _tmp2_;
		FormattedText* _tmp3_;
		FormattedText* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 301 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 301 "../src/Connection.vala"
		_tmp3_ = canvas_text_get_text (_tmp2_);
#line 301 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 301 "../src/Connection.vala"
		_tmp5_ = formatted_text_get_text (_tmp4_);
#line 301 "../src/Connection.vala"
		_tmp6_ = _tmp5_;
#line 301 "../src/Connection.vala"
		_tmp0_ = g_strcmp0 (_tmp6_, "") != 0;
#line 1863 "Connection.c"
	}
#line 301 "../src/Connection.vala"
	if (_tmp0_) {
#line 301 "../src/Connection.vala"
		return;
#line 1869 "Connection.c"
	}
#line 302 "../src/Connection.vala"
	_tmp7_ = self->priv->_title;
#line 302 "../src/Connection.vala"
	g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp8_, NULL, FALSE);
#line 302 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 303 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 303 "../src/Connection.vala"
	self->priv->_title = NULL;
#line 1881 "Connection.c"
}

void
connection_change_title (Connection* self,
                         DrawArea* da,
                         const gchar* title,
                         gboolean allow_empty)
{
	gboolean _tmp0_ = FALSE;
#line 307 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 307 "../src/Connection.vala"
	g_return_if_fail (title != NULL);
#line 308 "../src/Connection.vala"
	if (g_strcmp0 (title, "") == 0) {
#line 308 "../src/Connection.vala"
		_tmp0_ = !allow_empty;
#line 1901 "Connection.c"
	} else {
#line 308 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 1905 "Connection.c"
	}
#line 308 "../src/Connection.vala"
	if (_tmp0_) {
#line 1909 "Connection.c"
		CanvasText* _tmp1_;
#line 309 "../src/Connection.vala"
		_tmp1_ = self->priv->_title;
#line 309 "../src/Connection.vala"
		if (_tmp1_ != NULL) {
#line 1915 "Connection.c"
			CanvasText* _tmp2_;
			guint _tmp3_;
#line 310 "../src/Connection.vala"
			_tmp2_ = self->priv->_title;
#line 310 "../src/Connection.vala"
			g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp3_, NULL, FALSE);
#line 310 "../src/Connection.vala"
			g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 1924 "Connection.c"
		}
#line 312 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_title);
#line 312 "../src/Connection.vala"
		self->priv->_title = NULL;
#line 1930 "Connection.c"
	} else {
		CanvasText* _tmp4_;
#line 313 "../src/Connection.vala"
		_tmp4_ = self->priv->_title;
#line 313 "../src/Connection.vala"
		if (_tmp4_ == NULL) {
#line 1937 "Connection.c"
			CanvasText* _tmp5_;
			CanvasText* _tmp6_;
			CanvasText* _tmp7_;
			Style* _tmp8_;
			Style* _tmp9_;
			PangoFontDescription* _tmp10_;
			PangoFontDescription* _tmp11_;
			const gchar* _tmp12_;
			Style* _tmp13_;
			Style* _tmp14_;
			PangoFontDescription* _tmp15_;
			PangoFontDescription* _tmp16_;
			gint _tmp17_;
#line 314 "../src/Connection.vala"
			_tmp5_ = canvas_text_new_with_text (da, title);
#line 314 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_title);
#line 314 "../src/Connection.vala"
			self->priv->_title = _tmp5_;
#line 315 "../src/Connection.vala"
			_tmp6_ = self->priv->_title;
#line 315 "../src/Connection.vala"
			g_signal_connect_object (_tmp6_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 316 "../src/Connection.vala"
			_tmp7_ = self->priv->_title;
#line 316 "../src/Connection.vala"
			_tmp8_ = connection_get_style (self);
#line 316 "../src/Connection.vala"
			_tmp9_ = _tmp8_;
#line 316 "../src/Connection.vala"
			_tmp10_ = style_get_connection_font (_tmp9_);
#line 316 "../src/Connection.vala"
			_tmp11_ = _tmp10_;
#line 316 "../src/Connection.vala"
			_tmp12_ = pango_font_description_get_family (_tmp11_);
#line 316 "../src/Connection.vala"
			_tmp13_ = connection_get_style (self);
#line 316 "../src/Connection.vala"
			_tmp14_ = _tmp13_;
#line 316 "../src/Connection.vala"
			_tmp15_ = style_get_connection_font (_tmp14_);
#line 316 "../src/Connection.vala"
			_tmp16_ = _tmp15_;
#line 316 "../src/Connection.vala"
			_tmp17_ = pango_font_description_get_size (_tmp16_) / PANGO_SCALE;
#line 316 "../src/Connection.vala"
			canvas_text_set_font (_tmp7_, _tmp12_, &_tmp17_, 1.0);
#line 317 "../src/Connection.vala"
			connection_position_title (self);
#line 1987 "Connection.c"
		} else {
			CanvasText* _tmp18_;
			FormattedText* _tmp19_;
			FormattedText* _tmp20_;
#line 319 "../src/Connection.vala"
			_tmp18_ = self->priv->_title;
#line 319 "../src/Connection.vala"
			_tmp19_ = canvas_text_get_text (_tmp18_);
#line 319 "../src/Connection.vala"
			_tmp20_ = _tmp19_;
#line 319 "../src/Connection.vala"
			formatted_text_set_text (_tmp20_, title);
#line 2000 "Connection.c"
		}
	}
}

static void
connection_position_title (Connection* self)
{
	CanvasText* _tmp0_;
	CanvasText* _tmp1_;
#line 324 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 325 "../src/Connection.vala"
	_tmp0_ = connection_get_title (self);
#line 325 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 325 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 2018 "Connection.c"
		gint width = 0;
		gint swidth = 0;
		gint theight = 0;
		CanvasText* _tmp2_;
		CanvasText* _tmp3_;
#line 326 "../src/Connection.vala"
		width = connection_get_width (self);
#line 327 "../src/Connection.vala"
		swidth = connection_sticker_width (self, TRUE);
#line 328 "../src/Connection.vala"
		theight = connection_title_height (self);
#line 330 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 330 "../src/Connection.vala"
		canvas_text_set_posx (_tmp2_, self->priv->_dragx - ((width / 2) - swidth));
#line 331 "../src/Connection.vala"
		_tmp3_ = self->priv->_title;
#line 331 "../src/Connection.vala"
		canvas_text_set_posy (_tmp3_, self->priv->_dragy - (theight / 2));
#line 2038 "Connection.c"
	}
}

static void
_connection_end_moved_node_moved (Node* _sender,
                                  gdouble diffx,
                                  gdouble diffy,
                                  gpointer self)
{
#line 337 "../src/Connection.vala"
	connection_end_moved ((Connection*) self, _sender, diffx, diffy);
#line 2050 "Connection.c"
}

static void
_connection_end_resized_node_resized (Node* _sender,
                                      gdouble diffw,
                                      gdouble diffh,
                                      gpointer self)
{
#line 338 "../src/Connection.vala"
	connection_end_resized ((Connection*) self, _sender, diffw, diffh);
#line 2061 "Connection.c"
}

void
connection_connect_node (Connection* self,
                         Node* node)
{
#line 336 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 337 "../src/Connection.vala"
	g_signal_connect_object (node, "moved", (GCallback) _connection_end_moved_node_moved, self, 0);
#line 338 "../src/Connection.vala"
	g_signal_connect_object (node, "resized", (GCallback) _connection_end_resized_node_resized, self, 0);
#line 2076 "Connection.c"
}

void
connection_disconnect_node (Connection* self,
                            Node* node)
{
	guint _tmp0_;
	guint _tmp1_;
	Connection* _tmp2_;
	Connection* _tmp3_;
#line 342 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 343 "../src/Connection.vala"
	g_signal_parse_name ("moved", TYPE_NODE, &_tmp0_, NULL, FALSE);
#line 343 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (node, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _connection_end_moved_node_moved, self);
#line 344 "../src/Connection.vala"
	g_signal_parse_name ("resized", TYPE_NODE, &_tmp1_, NULL, FALSE);
#line 344 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (node, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _connection_end_resized_node_resized, self);
#line 345 "../src/Connection.vala"
	_tmp2_ = node_get_last_selected_connection (node);
#line 345 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 345 "../src/Connection.vala"
	if (_tmp3_ == self) {
#line 346 "../src/Connection.vala"
		node_set_last_selected_connection (node, NULL);
#line 2107 "Connection.c"
	}
}

void
connection_connect_to (Connection* self,
                       Node* node)
{
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Node* _tmp4_;
	gint _tmp7_ = 0;
	Node* _tmp8_;
	Bezier* _tmp9_;
	Bezier* _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	Bezier* _tmp13_;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	Bezier* _tmp16_;
#line 351 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 354 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 354 "../src/Connection.vala"
	x = _tmp0_;
#line 354 "../src/Connection.vala"
	y = _tmp1_;
#line 354 "../src/Connection.vala"
	w = _tmp2_;
#line 354 "../src/Connection.vala"
	h = _tmp3_;
#line 355 "../src/Connection.vala"
	_tmp4_ = self->priv->_from_node;
#line 355 "../src/Connection.vala"
	if (_tmp4_ == NULL) {
#line 2156 "Connection.c"
		Node* _tmp5_;
#line 356 "../src/Connection.vala"
		_tmp5_ = _g_object_ref0 (node);
#line 356 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 356 "../src/Connection.vala"
		self->priv->_from_node = _tmp5_;
#line 2164 "Connection.c"
	} else {
		Node* _tmp6_;
#line 358 "../src/Connection.vala"
		_tmp6_ = _g_object_ref0 (node);
#line 358 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 358 "../src/Connection.vala"
		self->priv->_to_node = _tmp6_;
#line 2173 "Connection.c"
	}
#line 360 "../src/Connection.vala"
	connection_connect_node (self, node);
#line 361 "../src/Connection.vala"
	_tmp8_ = self->priv->_from_node;
#line 361 "../src/Connection.vala"
	if (_tmp8_ == node) {
#line 361 "../src/Connection.vala"
		_tmp7_ = 0;
#line 2183 "Connection.c"
	} else {
#line 361 "../src/Connection.vala"
		_tmp7_ = 2;
#line 2187 "Connection.c"
	}
#line 361 "../src/Connection.vala"
	_tmp9_ = self->priv->_curve;
#line 361 "../src/Connection.vala"
	bezier_set_point (_tmp9_, _tmp7_, x + (w / 2), y + (h / 2));
#line 362 "../src/Connection.vala"
	_tmp10_ = self->priv->_curve;
#line 362 "../src/Connection.vala"
	bezier_get_point (_tmp10_, 0, &_tmp11_, &_tmp12_);
#line 362 "../src/Connection.vala"
	fx = _tmp11_;
#line 362 "../src/Connection.vala"
	fy = _tmp12_;
#line 363 "../src/Connection.vala"
	_tmp13_ = self->priv->_curve;
#line 363 "../src/Connection.vala"
	bezier_get_point (_tmp13_, 2, &_tmp14_, &_tmp15_);
#line 363 "../src/Connection.vala"
	tx = _tmp14_;
#line 363 "../src/Connection.vala"
	ty = _tmp15_;
#line 364 "../src/Connection.vala"
	self->priv->_dragx = (fx + tx) / 2;
#line 365 "../src/Connection.vala"
	self->priv->_dragy = (fy + ty) / 2;
#line 366 "../src/Connection.vala"
	connection_position_title (self);
#line 367 "../src/Connection.vala"
	_tmp16_ = self->priv->_curve;
#line 367 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp16_, self->priv->_dragx, self->priv->_dragy);
#line 368 "../src/Connection.vala"
	connection_set_connect_point (self, node);
#line 2221 "Connection.c"
}

void
connection_disconnect_from_node (Connection* self,
                                 gboolean from)
{
#line 372 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/Connection.vala"
	if (from) {
#line 2232 "Connection.c"
		Bezier* _tmp0_;
		gdouble _tmp1_ = 0.0;
		gdouble _tmp2_ = 0.0;
		Node* _tmp3_;
#line 374 "../src/Connection.vala"
		_tmp0_ = self->priv->_curve;
#line 374 "../src/Connection.vala"
		bezier_get_from_point (_tmp0_, &_tmp1_, &_tmp2_);
#line 374 "../src/Connection.vala"
		self->priv->_posx = _tmp1_;
#line 374 "../src/Connection.vala"
		self->priv->_posy = _tmp2_;
#line 375 "../src/Connection.vala"
		_tmp3_ = self->priv->_from_node;
#line 375 "../src/Connection.vala"
		connection_disconnect_node (self, _tmp3_);
#line 376 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 376 "../src/Connection.vala"
		self->priv->_from_node = NULL;
#line 2253 "Connection.c"
	} else {
		Bezier* _tmp4_;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		Node* _tmp7_;
#line 378 "../src/Connection.vala"
		_tmp4_ = self->priv->_curve;
#line 378 "../src/Connection.vala"
		bezier_get_to_point (_tmp4_, &_tmp5_, &_tmp6_);
#line 378 "../src/Connection.vala"
		self->priv->_posx = _tmp5_;
#line 378 "../src/Connection.vala"
		self->priv->_posy = _tmp6_;
#line 379 "../src/Connection.vala"
		_tmp7_ = self->priv->_to_node;
#line 379 "../src/Connection.vala"
		connection_disconnect_node (self, _tmp7_);
#line 380 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 380 "../src/Connection.vala"
		self->priv->_to_node = NULL;
#line 2275 "Connection.c"
	}
#line 382 "../src/Connection.vala"
	connection_set_mode (self, CONN_MODE_CONNECTING);
#line 2279 "Connection.c"
}

void
connection_draw_to (Connection* self,
                    gdouble x,
                    gdouble y)
{
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	Node* _tmp0_ = NULL;
	Node* _tmp1_;
	Node* node = NULL;
	Node* _tmp4_;
	gint _tmp5_ = 0;
	Node* _tmp6_;
	Node* _tmp7_;
	Bezier* _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	Bezier* _tmp11_;
	Node* _tmp12_;
#line 386 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 388 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 388 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 2307 "Connection.c"
		Node* _tmp2_;
#line 388 "../src/Connection.vala"
		_tmp2_ = self->priv->_from_node;
#line 388 "../src/Connection.vala"
		_tmp0_ = _tmp2_;
#line 2313 "Connection.c"
	} else {
		Node* _tmp3_;
#line 388 "../src/Connection.vala"
		_tmp3_ = self->priv->_to_node;
#line 388 "../src/Connection.vala"
		_tmp0_ = _tmp3_;
#line 2320 "Connection.c"
	}
#line 388 "../src/Connection.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 388 "../src/Connection.vala"
	node = _tmp4_;
#line 389 "../src/Connection.vala"
	self->priv->_posx = x;
#line 390 "../src/Connection.vala"
	self->priv->_posy = y;
#line 391 "../src/Connection.vala"
	_tmp6_ = node;
#line 391 "../src/Connection.vala"
	_tmp7_ = self->priv->_from_node;
#line 391 "../src/Connection.vala"
	if (_tmp6_ == _tmp7_) {
#line 391 "../src/Connection.vala"
		_tmp5_ = 0;
#line 2338 "Connection.c"
	} else {
#line 391 "../src/Connection.vala"
		_tmp5_ = 2;
#line 2342 "Connection.c"
	}
#line 391 "../src/Connection.vala"
	_tmp8_ = self->priv->_curve;
#line 391 "../src/Connection.vala"
	bezier_get_point (_tmp8_, _tmp5_, &_tmp9_, &_tmp10_);
#line 391 "../src/Connection.vala"
	nx = _tmp9_;
#line 391 "../src/Connection.vala"
	ny = _tmp10_;
#line 392 "../src/Connection.vala"
	self->priv->_dragx = (nx + x) / 2;
#line 393 "../src/Connection.vala"
	self->priv->_dragy = (ny + y) / 2;
#line 394 "../src/Connection.vala"
	connection_position_title (self);
#line 395 "../src/Connection.vala"
	_tmp11_ = self->priv->_curve;
#line 395 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp11_, self->priv->_dragx, self->priv->_dragy);
#line 396 "../src/Connection.vala"
	_tmp12_ = node;
#line 396 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp12_);
#line 386 "../src/Connection.vala"
	_g_object_unref0 (node);
#line 2368 "Connection.c"
}

static void
connection_end_moved (Connection* self,
                      Node* node,
                      gdouble diffx,
                      gdouble diffy)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	Node* _tmp5_;
	Bezier* _tmp6_;
	Bezier* _tmp7_;
	Node* _tmp8_;
	Node* _tmp9_;
#line 400 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 400 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 402 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 402 "../src/Connection.vala"
	x = _tmp0_;
#line 402 "../src/Connection.vala"
	y = _tmp1_;
#line 402 "../src/Connection.vala"
	w = _tmp2_;
#line 402 "../src/Connection.vala"
	h = _tmp3_;
#line 403 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 403 "../src/Connection.vala"
	if (_tmp5_ == node) {
#line 403 "../src/Connection.vala"
		_tmp4_ = 0;
#line 2411 "Connection.c"
	} else {
#line 403 "../src/Connection.vala"
		_tmp4_ = 2;
#line 2415 "Connection.c"
	}
#line 403 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 403 "../src/Connection.vala"
	bezier_set_point (_tmp6_, _tmp4_, x + (w / 2), y + (h / 2));
#line 404 "../src/Connection.vala"
	self->priv->_dragx = self->priv->_dragx + (diffx / 2);
#line 405 "../src/Connection.vala"
	self->priv->_dragy = self->priv->_dragy + (diffy / 2);
#line 406 "../src/Connection.vala"
	connection_position_title (self);
#line 407 "../src/Connection.vala"
	_tmp7_ = self->priv->_curve;
#line 407 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp7_, self->priv->_dragx, self->priv->_dragy);
#line 408 "../src/Connection.vala"
	_tmp8_ = self->priv->_from_node;
#line 408 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp8_);
#line 409 "../src/Connection.vala"
	_tmp9_ = self->priv->_to_node;
#line 409 "../src/Connection.vala"
	if (_tmp9_ != NULL) {
#line 2439 "Connection.c"
		Node* _tmp10_;
#line 410 "../src/Connection.vala"
		_tmp10_ = self->priv->_to_node;
#line 410 "../src/Connection.vala"
		connection_set_connect_point (self, _tmp10_);
#line 2445 "Connection.c"
	}
}

static void
connection_end_resized (Connection* self,
                        Node* node,
                        gdouble diffw,
                        gdouble diffh)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	Node* _tmp5_;
	Bezier* _tmp6_;
	Bezier* _tmp7_;
	Node* _tmp8_;
	Node* _tmp9_;
#line 415 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 417 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 417 "../src/Connection.vala"
	x = _tmp0_;
#line 417 "../src/Connection.vala"
	y = _tmp1_;
#line 417 "../src/Connection.vala"
	w = _tmp2_;
#line 417 "../src/Connection.vala"
	h = _tmp3_;
#line 418 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 418 "../src/Connection.vala"
	if (_tmp5_ == node) {
#line 418 "../src/Connection.vala"
		_tmp4_ = 0;
#line 2489 "Connection.c"
	} else {
#line 418 "../src/Connection.vala"
		_tmp4_ = 2;
#line 2493 "Connection.c"
	}
#line 418 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 418 "../src/Connection.vala"
	bezier_set_point (_tmp6_, _tmp4_, x + (w / 2), y + (h / 2));
#line 419 "../src/Connection.vala"
	self->priv->_dragx = self->priv->_dragx + (diffw / 2);
#line 420 "../src/Connection.vala"
	self->priv->_dragy = self->priv->_dragy + (diffh / 2);
#line 421 "../src/Connection.vala"
	connection_position_title (self);
#line 422 "../src/Connection.vala"
	_tmp7_ = self->priv->_curve;
#line 422 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp7_, self->priv->_dragx, self->priv->_dragy);
#line 423 "../src/Connection.vala"
	_tmp8_ = self->priv->_from_node;
#line 423 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp8_);
#line 424 "../src/Connection.vala"
	_tmp9_ = self->priv->_to_node;
#line 424 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp9_);
#line 2517 "Connection.c"
}

gboolean
connection_attached_to_node (Connection* self,
                             Node* node)
{
	gboolean _tmp0_ = FALSE;
	Node* _tmp1_;
	gboolean result;
#line 428 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 428 "../src/Connection.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 429 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 429 "../src/Connection.vala"
	if (_tmp1_ == node) {
#line 429 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 2537 "Connection.c"
	} else {
		Node* _tmp2_;
#line 429 "../src/Connection.vala"
		_tmp2_ = self->priv->_to_node;
#line 429 "../src/Connection.vala"
		_tmp0_ = _tmp2_ == node;
#line 2544 "Connection.c"
	}
#line 429 "../src/Connection.vala"
	result = _tmp0_;
#line 429 "../src/Connection.vala"
	return result;
#line 2550 "Connection.c"
}

static void
connection_set_connect_point (Connection* self,
                              Node* node)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble bw = 0.0;
	Style* _tmp0_;
	Style* _tmp1_;
	gint* _tmp2_;
	gint* _tmp3_;
	gdouble extra = 0.0;
	Style* _tmp4_;
	Style* _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gdouble margin = 0.0;
	Style* _tmp8_;
	Style* _tmp9_;
	gint* _tmp10_;
	gint* _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	Bezier* _tmp16_;
	Node* _tmp17_;
#line 433 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 436 "../src/Connection.vala"
	_tmp0_ = node_get_style (node);
#line 436 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 436 "../src/Connection.vala"
	_tmp2_ = style_get_node_borderwidth (_tmp1_);
#line 436 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 436 "../src/Connection.vala"
	bw = *_tmp3_;
#line 437 "../src/Connection.vala"
	_tmp4_ = connection_get_style (self);
#line 437 "../src/Connection.vala"
	_tmp5_ = _tmp4_;
#line 437 "../src/Connection.vala"
	_tmp6_ = style_get_connection_line_width (_tmp5_);
#line 437 "../src/Connection.vala"
	_tmp7_ = _tmp6_;
#line 437 "../src/Connection.vala"
	extra = bw + ((*_tmp7_) / 2);
#line 438 "../src/Connection.vala"
	_tmp8_ = node_get_style (node);
#line 438 "../src/Connection.vala"
	_tmp9_ = _tmp8_;
#line 438 "../src/Connection.vala"
	_tmp10_ = style_get_node_margin (_tmp9_);
#line 438 "../src/Connection.vala"
	_tmp11_ = _tmp10_;
#line 438 "../src/Connection.vala"
	margin = *_tmp11_;
#line 440 "../src/Connection.vala"
	node_bbox (node, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 440 "../src/Connection.vala"
	x = _tmp12_;
#line 440 "../src/Connection.vala"
	y = _tmp13_;
#line 440 "../src/Connection.vala"
	w = _tmp14_;
#line 440 "../src/Connection.vala"
	h = _tmp15_;
#line 443 "../src/Connection.vala"
	x += margin;
#line 444 "../src/Connection.vala"
	y += margin;
#line 445 "../src/Connection.vala"
	w -= margin * 2;
#line 446 "../src/Connection.vala"
	h -= margin * 2;
#line 448 "../src/Connection.vala"
	_tmp16_ = self->priv->_curve;
#line 448 "../src/Connection.vala"
	_tmp17_ = self->priv->_from_node;
#line 448 "../src/Connection.vala"
	bezier_set_connect_point (_tmp16_, node == _tmp17_, y - extra, (y + h) + extra, x - extra, (x + w) + extra);
#line 2640 "Connection.c"
}

gboolean
connection_on_curve (Connection* self,
                     gdouble x,
                     gdouble y)
{
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	Bezier* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Bezier* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	Bezier* curve = NULL;
	Bezier* _tmp6_;
	gboolean result;
#line 453 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 455 "../src/Connection.vala"
	_tmp0_ = self->priv->_curve;
#line 455 "../src/Connection.vala"
	bezier_get_from_point (_tmp0_, &_tmp1_, &_tmp2_);
#line 455 "../src/Connection.vala"
	fx = _tmp1_;
#line 455 "../src/Connection.vala"
	fy = _tmp2_;
#line 456 "../src/Connection.vala"
	_tmp3_ = self->priv->_curve;
#line 456 "../src/Connection.vala"
	bezier_get_to_point (_tmp3_, &_tmp4_, &_tmp5_);
#line 456 "../src/Connection.vala"
	tx = _tmp4_;
#line 456 "../src/Connection.vala"
	ty = _tmp5_;
#line 457 "../src/Connection.vala"
	_tmp6_ = bezier_new_with_endpoints (fx, fy, tx, ty);
#line 457 "../src/Connection.vala"
	curve = _tmp6_;
#line 458 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (curve, self->priv->_dragx, self->priv->_dragy);
#line 459 "../src/Connection.vala"
	result = bezier_within_range (curve, x, y);
#line 459 "../src/Connection.vala"
	_bezier_unref0 (curve);
#line 459 "../src/Connection.vala"
	return result;
#line 2691 "Connection.c"
}

static gboolean
connection_within_handle (Connection* self,
                          gdouble hx,
                          gdouble hy,
                          gdouble x,
                          gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 463 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 464 "../src/Connection.vala"
	if ((hx - self->priv->RADIUS) <= x) {
#line 464 "../src/Connection.vala"
		_tmp2_ = x <= (hx + self->priv->RADIUS);
#line 2711 "Connection.c"
	} else {
#line 464 "../src/Connection.vala"
		_tmp2_ = FALSE;
#line 2715 "Connection.c"
	}
#line 464 "../src/Connection.vala"
	if (_tmp2_) {
#line 464 "../src/Connection.vala"
		_tmp1_ = (hy - self->priv->RADIUS) <= y;
#line 2721 "Connection.c"
	} else {
#line 464 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 2725 "Connection.c"
	}
#line 464 "../src/Connection.vala"
	if (_tmp1_) {
#line 464 "../src/Connection.vala"
		_tmp0_ = y <= (hy + self->priv->RADIUS);
#line 2731 "Connection.c"
	} else {
#line 464 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 2735 "Connection.c"
	}
#line 464 "../src/Connection.vala"
	result = _tmp0_;
#line 464 "../src/Connection.vala"
	return result;
#line 2741 "Connection.c"
}

gboolean
connection_within_drag_handle (Connection* self,
                               gdouble x,
                               gdouble y)
{
	ConnMode _tmp0_;
	ConnMode _tmp1_;
	gboolean result;
#line 468 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 469 "../src/Connection.vala"
	_tmp0_ = connection_get_mode (self);
#line 469 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 469 "../src/Connection.vala"
	if (_tmp1_ == CONN_MODE_SELECTED) {
#line 2760 "Connection.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		const gchar* _tmp4_;
#line 470 "../src/Connection.vala"
		_tmp4_ = self->priv->_sticker;
#line 470 "../src/Connection.vala"
		if (_tmp4_ == NULL) {
#line 2768 "Connection.c"
			CanvasText* _tmp5_;
			CanvasText* _tmp6_;
#line 470 "../src/Connection.vala"
			_tmp5_ = connection_get_title (self);
#line 470 "../src/Connection.vala"
			_tmp6_ = _tmp5_;
#line 470 "../src/Connection.vala"
			_tmp3_ = _tmp6_ == NULL;
#line 2777 "Connection.c"
		} else {
#line 470 "../src/Connection.vala"
			_tmp3_ = FALSE;
#line 2781 "Connection.c"
		}
#line 470 "../src/Connection.vala"
		if (_tmp3_) {
#line 2785 "Connection.c"
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 470 "../src/Connection.vala"
			_tmp7_ = connection_get_note (self);
#line 470 "../src/Connection.vala"
			_tmp8_ = _tmp7_;
#line 470 "../src/Connection.vala"
			_tmp9_ = strlen (_tmp8_);
#line 470 "../src/Connection.vala"
			_tmp10_ = _tmp9_;
#line 470 "../src/Connection.vala"
			_tmp2_ = _tmp10_ == 0;
#line 2800 "Connection.c"
		} else {
#line 470 "../src/Connection.vala"
			_tmp2_ = FALSE;
#line 2804 "Connection.c"
		}
#line 470 "../src/Connection.vala"
		if (_tmp2_) {
#line 471 "../src/Connection.vala"
			result = connection_within_handle (self, self->priv->_dragx, self->priv->_dragy, x, y);
#line 471 "../src/Connection.vala"
			return result;
#line 2812 "Connection.c"
		} else {
			gdouble tx = 0.0;
			gdouble ty = 0.0;
			gdouble tw = 0.0;
			gdouble th = 0.0;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_ = 0.0;
			gdouble _tmp13_ = 0.0;
			gdouble _tmp14_ = 0.0;
			Style* _tmp15_;
			gint* _tmp16_;
			gint* _tmp17_;
#line 474 "../src/Connection.vala"
			connection_title_bbox (self, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 474 "../src/Connection.vala"
			tx = _tmp11_;
#line 474 "../src/Connection.vala"
			ty = _tmp12_;
#line 474 "../src/Connection.vala"
			tw = _tmp13_;
#line 474 "../src/Connection.vala"
			th = _tmp14_;
#line 475 "../src/Connection.vala"
			_tmp15_ = self->priv->_style;
#line 475 "../src/Connection.vala"
			_tmp16_ = style_get_connection_padding (_tmp15_);
#line 475 "../src/Connection.vala"
			_tmp17_ = _tmp16_;
#line 475 "../src/Connection.vala"
			result = connection_within_handle (self, self->priv->_dragx, (self->priv->_dragy + (th / 2)) + (*_tmp17_), x, y);
#line 475 "../src/Connection.vala"
			return result;
#line 2845 "Connection.c"
		}
	}
#line 478 "../src/Connection.vala"
	result = FALSE;
#line 478 "../src/Connection.vala"
	return result;
#line 2852 "Connection.c"
}

gboolean
connection_within_from_handle (Connection* self,
                               gdouble x,
                               gdouble y)
{
	gboolean result;
#line 482 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 483 "../src/Connection.vala"
	result = connection_within_endpoint_handle (self, TRUE, x, y);
#line 483 "../src/Connection.vala"
	return result;
#line 2867 "Connection.c"
}

gboolean
connection_within_to_handle (Connection* self,
                             gdouble x,
                             gdouble y)
{
	gboolean result;
#line 487 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 488 "../src/Connection.vala"
	result = connection_within_endpoint_handle (self, FALSE, x, y);
#line 488 "../src/Connection.vala"
	return result;
#line 2882 "Connection.c"
}

static gboolean
connection_within_endpoint_handle (Connection* self,
                                   gboolean from,
                                   gdouble x,
                                   gdouble y)
{
	ConnMode _tmp0_;
	ConnMode _tmp1_;
	gboolean result;
#line 492 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 493 "../src/Connection.vala"
	_tmp0_ = connection_get_mode (self);
#line 493 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 493 "../src/Connection.vala"
	if (_tmp1_ == CONN_MODE_SELECTED) {
#line 2902 "Connection.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
#line 495 "../src/Connection.vala"
		if (from) {
#line 2907 "Connection.c"
			Bezier* _tmp2_;
			gdouble _tmp3_ = 0.0;
			gdouble _tmp4_ = 0.0;
#line 496 "../src/Connection.vala"
			_tmp2_ = self->priv->_curve;
#line 496 "../src/Connection.vala"
			bezier_get_from_point (_tmp2_, &_tmp3_, &_tmp4_);
#line 496 "../src/Connection.vala"
			px = _tmp3_;
#line 496 "../src/Connection.vala"
			py = _tmp4_;
#line 2919 "Connection.c"
		} else {
			Bezier* _tmp5_;
			gdouble _tmp6_ = 0.0;
			gdouble _tmp7_ = 0.0;
#line 498 "../src/Connection.vala"
			_tmp5_ = self->priv->_curve;
#line 498 "../src/Connection.vala"
			bezier_get_to_point (_tmp5_, &_tmp6_, &_tmp7_);
#line 498 "../src/Connection.vala"
			px = _tmp6_;
#line 498 "../src/Connection.vala"
			py = _tmp7_;
#line 2932 "Connection.c"
		}
#line 500 "../src/Connection.vala"
		result = connection_within_handle (self, px, py, x, y);
#line 500 "../src/Connection.vala"
		return result;
#line 2938 "Connection.c"
	}
#line 502 "../src/Connection.vala"
	result = FALSE;
#line 502 "../src/Connection.vala"
	return result;
#line 2944 "Connection.c"
}

gboolean
connection_within_title_box (Connection* self,
                             gdouble x,
                             gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GdkPixbuf* _tmp2_;
	gdouble bx = 0.0;
	gdouble by = 0.0;
	gdouble bw = 0.0;
	gdouble bh = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gboolean result;
#line 505 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 506 "../src/Connection.vala"
	_tmp2_ = self->priv->_sticker_buf;
#line 506 "../src/Connection.vala"
	if (_tmp2_ == NULL) {
#line 2970 "Connection.c"
		CanvasText* _tmp3_;
#line 506 "../src/Connection.vala"
		_tmp3_ = self->priv->_title;
#line 506 "../src/Connection.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 2976 "Connection.c"
	} else {
#line 506 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 2980 "Connection.c"
	}
#line 506 "../src/Connection.vala"
	if (_tmp1_) {
#line 2984 "Connection.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 506 "../src/Connection.vala"
		_tmp4_ = connection_get_note (self);
#line 506 "../src/Connection.vala"
		_tmp5_ = _tmp4_;
#line 506 "../src/Connection.vala"
		_tmp6_ = strlen (_tmp5_);
#line 506 "../src/Connection.vala"
		_tmp7_ = _tmp6_;
#line 506 "../src/Connection.vala"
		_tmp0_ = _tmp7_ == 0;
#line 2999 "Connection.c"
	} else {
#line 506 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 3003 "Connection.c"
	}
#line 506 "../src/Connection.vala"
	if (_tmp0_) {
#line 506 "../src/Connection.vala"
		result = FALSE;
#line 506 "../src/Connection.vala"
		return result;
#line 3011 "Connection.c"
	}
#line 508 "../src/Connection.vala"
	connection_title_bbox (self, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 508 "../src/Connection.vala"
	bx = _tmp8_;
#line 508 "../src/Connection.vala"
	by = _tmp9_;
#line 508 "../src/Connection.vala"
	bw = _tmp10_;
#line 508 "../src/Connection.vala"
	bh = _tmp11_;
#line 509 "../src/Connection.vala"
	result = utils_is_within_bounds (x, y, bx, by, bw, bh);
#line 509 "../src/Connection.vala"
	return result;
#line 3027 "Connection.c"
}

gboolean
connection_within_title (Connection* self,
                         gdouble x,
                         gdouble y)
{
	gboolean _tmp0_ = FALSE;
	CanvasText* _tmp1_;
	gboolean result;
#line 513 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 514 "../src/Connection.vala"
	_tmp1_ = self->priv->_title;
#line 514 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 3044 "Connection.c"
		CanvasText* _tmp2_;
#line 514 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 514 "../src/Connection.vala"
		_tmp0_ = canvas_text_is_within (_tmp2_, x, y);
#line 3050 "Connection.c"
	} else {
#line 514 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 3054 "Connection.c"
	}
#line 514 "../src/Connection.vala"
	result = _tmp0_;
#line 514 "../src/Connection.vala"
	return result;
#line 3060 "Connection.c"
}

gboolean
connection_within_note (Connection* self,
                        gdouble x,
                        gdouble y)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gboolean result;
#line 518 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 519 "../src/Connection.vala"
	_tmp0_ = connection_get_note (self);
#line 519 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 519 "../src/Connection.vala"
	_tmp2_ = strlen (_tmp1_);
#line 519 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 519 "../src/Connection.vala"
	if (_tmp3_ == 0) {
#line 519 "../src/Connection.vala"
		result = FALSE;
#line 519 "../src/Connection.vala"
		return result;
#line 3097 "Connection.c"
	}
#line 521 "../src/Connection.vala"
	connection_note_bbox (self, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 521 "../src/Connection.vala"
	nx = _tmp4_;
#line 521 "../src/Connection.vala"
	ny = _tmp5_;
#line 521 "../src/Connection.vala"
	nw = _tmp6_;
#line 521 "../src/Connection.vala"
	nh = _tmp7_;
#line 522 "../src/Connection.vala"
	result = utils_is_within_bounds (x, y, nx, ny, nw, nh);
#line 522 "../src/Connection.vala"
	return result;
#line 3113 "Connection.c"
}

gboolean
connection_within_sticker (Connection* self,
                           gdouble x,
                           gdouble y)
{
	GdkPixbuf* _tmp0_;
	gdouble sx = 0.0;
	gdouble sy = 0.0;
	gdouble sw = 0.0;
	gdouble sh = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gboolean result;
#line 526 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 527 "../src/Connection.vala"
	_tmp0_ = self->priv->_sticker_buf;
#line 527 "../src/Connection.vala"
	if (_tmp0_ == NULL) {
#line 527 "../src/Connection.vala"
		result = FALSE;
#line 527 "../src/Connection.vala"
		return result;
#line 3141 "Connection.c"
	}
#line 529 "../src/Connection.vala"
	connection_sticker_bbox (self, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 529 "../src/Connection.vala"
	sx = _tmp1_;
#line 529 "../src/Connection.vala"
	sy = _tmp2_;
#line 529 "../src/Connection.vala"
	sw = _tmp3_;
#line 529 "../src/Connection.vala"
	sh = _tmp4_;
#line 530 "../src/Connection.vala"
	result = utils_is_within_bounds (x, y, sw, sy, sw, sh);
#line 530 "../src/Connection.vala"
	return result;
#line 3157 "Connection.c"
}

static void
connection_title_bbox (Connection* self,
                       gdouble* x,
                       gdouble* y,
                       gdouble* w,
                       gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gint* _tmp0_ = NULL;
	Style* _tmp1_;
	Style* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gint* _tmp5_;
	gint* padding = NULL;
	gint* _tmp8_;
	gint width = 0;
	gint height = 0;
#line 534 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 535 "../src/Connection.vala"
	_tmp1_ = connection_get_style (self);
#line 535 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 535 "../src/Connection.vala"
	_tmp3_ = style_get_connection_padding (_tmp2_);
#line 535 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 535 "../src/Connection.vala"
	_tmp5_ = __int_dup0 (_tmp4_);
#line 535 "../src/Connection.vala"
	_tmp0_ = _tmp5_;
#line 535 "../src/Connection.vala"
	if (_tmp0_ == NULL) {
#line 3197 "Connection.c"
		gint _tmp6_;
		gint* _tmp7_;
#line 535 "../src/Connection.vala"
		_tmp6_ = 0;
#line 535 "../src/Connection.vala"
		_tmp7_ = __int_dup0 (&_tmp6_);
#line 535 "../src/Connection.vala"
		_g_free0 (_tmp0_);
#line 535 "../src/Connection.vala"
		_tmp0_ = _tmp7_;
#line 3208 "Connection.c"
	}
#line 535 "../src/Connection.vala"
	_tmp8_ = _tmp0_;
#line 535 "../src/Connection.vala"
	_tmp0_ = NULL;
#line 535 "../src/Connection.vala"
	padding = _tmp8_;
#line 536 "../src/Connection.vala"
	width = connection_get_width (self);
#line 537 "../src/Connection.vala"
	height = connection_get_height (self);
#line 539 "../src/Connection.vala"
	_vala_x = self->priv->_dragx - ((width / 2) + (*padding));
#line 540 "../src/Connection.vala"
	_vala_y = self->priv->_dragy - ((height / 2) + (*padding));
#line 541 "../src/Connection.vala"
	_vala_w = (gdouble) (width + ((*padding) * 2));
#line 542 "../src/Connection.vala"
	_vala_h = (gdouble) (height + ((*padding) * 2));
#line 534 "../src/Connection.vala"
	_g_free0 (padding);
#line 534 "../src/Connection.vala"
	_g_free0 (_tmp0_);
#line 534 "../src/Connection.vala"
	if (x) {
#line 534 "../src/Connection.vala"
		*x = _vala_x;
#line 3236 "Connection.c"
	}
#line 534 "../src/Connection.vala"
	if (y) {
#line 534 "../src/Connection.vala"
		*y = _vala_y;
#line 3242 "Connection.c"
	}
#line 534 "../src/Connection.vala"
	if (w) {
#line 534 "../src/Connection.vala"
		*w = _vala_w;
#line 3248 "Connection.c"
	}
#line 534 "../src/Connection.vala"
	if (h) {
#line 534 "../src/Connection.vala"
		*h = _vala_h;
#line 3254 "Connection.c"
	}
}

static void
connection_note_bbox (Connection* self,
                      gdouble* x,
                      gdouble* y,
                      gdouble* w,
                      gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gint width = 0;
	gint nwidth = 0;
	gint nheight = 0;
#line 546 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/Connection.vala"
	width = connection_get_width (self);
#line 548 "../src/Connection.vala"
	nwidth = connection_note_width (self, FALSE);
#line 549 "../src/Connection.vala"
	nheight = connection_note_height (self);
#line 551 "../src/Connection.vala"
	_vala_x = (self->priv->_dragx + (width / 2)) - nwidth;
#line 552 "../src/Connection.vala"
	_vala_y = self->priv->_dragy - (nheight / 2);
#line 553 "../src/Connection.vala"
	_vala_w = (gdouble) nwidth;
#line 554 "../src/Connection.vala"
	_vala_h = (gdouble) nheight;
#line 546 "../src/Connection.vala"
	if (x) {
#line 546 "../src/Connection.vala"
		*x = _vala_x;
#line 3292 "Connection.c"
	}
#line 546 "../src/Connection.vala"
	if (y) {
#line 546 "../src/Connection.vala"
		*y = _vala_y;
#line 3298 "Connection.c"
	}
#line 546 "../src/Connection.vala"
	if (w) {
#line 546 "../src/Connection.vala"
		*w = _vala_w;
#line 3304 "Connection.c"
	}
#line 546 "../src/Connection.vala"
	if (h) {
#line 546 "../src/Connection.vala"
		*h = _vala_h;
#line 3310 "Connection.c"
	}
}

static void
connection_sticker_bbox (Connection* self,
                         gdouble* x,
                         gdouble* y,
                         gdouble* w,
                         gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gint width = 0;
	gint swidth = 0;
	gint sheight = 0;
#line 558 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 559 "../src/Connection.vala"
	width = connection_get_width (self);
#line 560 "../src/Connection.vala"
	swidth = connection_sticker_width (self, FALSE);
#line 561 "../src/Connection.vala"
	sheight = connection_sticker_height (self);
#line 563 "../src/Connection.vala"
	_vala_x = self->priv->_dragx - (width / 2);
#line 564 "../src/Connection.vala"
	_vala_y = self->priv->_dragy - (sheight / 2);
#line 565 "../src/Connection.vala"
	_vala_w = (gdouble) swidth;
#line 566 "../src/Connection.vala"
	_vala_h = (gdouble) sheight;
#line 558 "../src/Connection.vala"
	if (x) {
#line 558 "../src/Connection.vala"
		*x = _vala_x;
#line 3348 "Connection.c"
	}
#line 558 "../src/Connection.vala"
	if (y) {
#line 558 "../src/Connection.vala"
		*y = _vala_y;
#line 3354 "Connection.c"
	}
#line 558 "../src/Connection.vala"
	if (w) {
#line 558 "../src/Connection.vala"
		*w = _vala_w;
#line 3360 "Connection.c"
	}
#line 558 "../src/Connection.vala"
	if (h) {
#line 558 "../src/Connection.vala"
		*h = _vala_h;
#line 3366 "Connection.c"
	}
}

void
connection_move_drag_handle (Connection* self,
                             gdouble x,
                             gdouble y)
{
	CanvasText* _tmp0_;
	CanvasText* _tmp1_;
	Bezier* _tmp6_;
	Node* _tmp7_;
	Node* _tmp8_;
#line 570 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/Connection.vala"
	connection_set_mode (self, CONN_MODE_ADJUSTING);
#line 572 "../src/Connection.vala"
	connection_position_title (self);
#line 573 "../src/Connection.vala"
	self->priv->_dragx = x;
#line 574 "../src/Connection.vala"
	self->priv->_dragy = y;
#line 575 "../src/Connection.vala"
	_tmp0_ = connection_get_title (self);
#line 575 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 575 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 3396 "Connection.c"
		gdouble tx = 0.0;
		gdouble ty = 0.0;
		gdouble tw = 0.0;
		gdouble th = 0.0;
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
#line 577 "../src/Connection.vala"
		connection_title_bbox (self, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 577 "../src/Connection.vala"
		tx = _tmp2_;
#line 577 "../src/Connection.vala"
		ty = _tmp3_;
#line 577 "../src/Connection.vala"
		tw = _tmp4_;
#line 577 "../src/Connection.vala"
		th = _tmp5_;
#line 578 "../src/Connection.vala"
		self->priv->_dragy = self->priv->_dragy - (th / 2);
#line 3417 "Connection.c"
	}
#line 580 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 580 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp6_, self->priv->_dragx, self->priv->_dragy);
#line 581 "../src/Connection.vala"
	_tmp7_ = self->priv->_from_node;
#line 581 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp7_);
#line 582 "../src/Connection.vala"
	_tmp8_ = self->priv->_to_node;
#line 582 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp8_);
#line 3431 "Connection.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 3444 "Connection.c"
}

static void
connection_load (Connection* self,
                 DrawArea* da,
                 xmlNode* node,
                 GArray* nodes)
{
	gchar* f = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* t = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* x = NULL;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* y = NULL;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* n = NULL;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* c = NULL;
	gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* sk = NULL;
	gchar* _tmp26_;
	const gchar* _tmp27_;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fw = 0.0;
	gdouble fh = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble tw = 0.0;
	gdouble th = 0.0;
	Node* _tmp29_;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_ = 0.0;
	Node* _tmp34_;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_ = 0.0;
	Bezier* _tmp39_;
	Bezier* _tmp40_;
	Node* _tmp41_;
	Node* _tmp42_;
#line 586 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 586 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 586 "../src/Connection.vala"
	g_return_if_fail (nodes != NULL);
#line 588 "../src/Connection.vala"
	_tmp0_ = (gchar*) xmlGetProp (node, (xmlChar*) "from_id");
#line 588 "../src/Connection.vala"
	f = _tmp0_;
#line 589 "../src/Connection.vala"
	_tmp1_ = f;
#line 589 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 3510 "Connection.c"
		const gchar* _tmp2_;
		Node* _tmp3_;
		Node* _tmp4_;
#line 590 "../src/Connection.vala"
		_tmp2_ = f;
#line 590 "../src/Connection.vala"
		_tmp3_ = draw_area_get_node (da, nodes, atoi (_tmp2_));
#line 590 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 590 "../src/Connection.vala"
		self->priv->_from_node = _tmp3_;
#line 591 "../src/Connection.vala"
		_tmp4_ = self->priv->_from_node;
#line 591 "../src/Connection.vala"
		connection_connect_node (self, _tmp4_);
#line 3526 "Connection.c"
	}
#line 594 "../src/Connection.vala"
	_tmp5_ = (gchar*) xmlGetProp (node, (xmlChar*) "to_id");
#line 594 "../src/Connection.vala"
	t = _tmp5_;
#line 595 "../src/Connection.vala"
	_tmp6_ = t;
#line 595 "../src/Connection.vala"
	if (_tmp6_ != NULL) {
#line 3536 "Connection.c"
		const gchar* _tmp7_;
		Node* _tmp8_;
		Node* _tmp9_;
#line 596 "../src/Connection.vala"
		_tmp7_ = t;
#line 596 "../src/Connection.vala"
		_tmp8_ = draw_area_get_node (da, nodes, atoi (_tmp7_));
#line 596 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 596 "../src/Connection.vala"
		self->priv->_to_node = _tmp8_;
#line 597 "../src/Connection.vala"
		_tmp9_ = self->priv->_to_node;
#line 597 "../src/Connection.vala"
		connection_connect_node (self, _tmp9_);
#line 3552 "Connection.c"
	}
#line 600 "../src/Connection.vala"
	_tmp10_ = (gchar*) xmlGetProp (node, (xmlChar*) "drag_x");
#line 600 "../src/Connection.vala"
	x = _tmp10_;
#line 601 "../src/Connection.vala"
	_tmp11_ = x;
#line 601 "../src/Connection.vala"
	if (_tmp11_ != NULL) {
#line 3562 "Connection.c"
		const gchar* _tmp12_;
#line 602 "../src/Connection.vala"
		_tmp12_ = x;
#line 602 "../src/Connection.vala"
		self->priv->_dragx = double_parse (_tmp12_);
#line 3568 "Connection.c"
	}
#line 605 "../src/Connection.vala"
	_tmp13_ = (gchar*) xmlGetProp (node, (xmlChar*) "drag_y");
#line 605 "../src/Connection.vala"
	y = _tmp13_;
#line 606 "../src/Connection.vala"
	_tmp14_ = y;
#line 606 "../src/Connection.vala"
	if (_tmp14_ != NULL) {
#line 3578 "Connection.c"
		const gchar* _tmp15_;
#line 607 "../src/Connection.vala"
		_tmp15_ = y;
#line 607 "../src/Connection.vala"
		self->priv->_dragy = double_parse (_tmp15_);
#line 3584 "Connection.c"
	}
#line 610 "../src/Connection.vala"
	_tmp16_ = (gchar*) xmlGetProp (node, (xmlChar*) "note");
#line 610 "../src/Connection.vala"
	n = _tmp16_;
#line 611 "../src/Connection.vala"
	_tmp17_ = n;
#line 611 "../src/Connection.vala"
	if (_tmp17_ != NULL) {
#line 3594 "Connection.c"
		const gchar* _tmp18_;
#line 612 "../src/Connection.vala"
		_tmp18_ = n;
#line 612 "../src/Connection.vala"
		connection_set_note (self, _tmp18_);
#line 3600 "Connection.c"
	}
#line 615 "../src/Connection.vala"
	_tmp19_ = (gchar*) xmlGetProp (node, (xmlChar*) "color");
#line 615 "../src/Connection.vala"
	c = _tmp19_;
#line 616 "../src/Connection.vala"
	_tmp20_ = c;
#line 616 "../src/Connection.vala"
	if (_tmp20_ != NULL) {
#line 3610 "Connection.c"
		Theme* _tmp21_;
		Theme* _tmp22_;
		GdkRGBA* _tmp23_;
		GdkRGBA* _tmp24_;
		const gchar* _tmp25_;
#line 617 "../src/Connection.vala"
		_tmp21_ = draw_area_get_theme (da);
#line 617 "../src/Connection.vala"
		_tmp22_ = _tmp21_;
#line 617 "../src/Connection.vala"
		_tmp23_ = theme_get_color (_tmp22_, "connection_background");
#line 617 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (self->priv->_color);
#line 617 "../src/Connection.vala"
		self->priv->_color = _tmp23_;
#line 617 "../src/Connection.vala"
		_g_object_unref0 (_tmp22_);
#line 618 "../src/Connection.vala"
		_tmp24_ = self->priv->_color;
#line 618 "../src/Connection.vala"
		_tmp25_ = c;
#line 618 "../src/Connection.vala"
		gdk_rgba_parse (_tmp24_, _tmp25_);
#line 3634 "Connection.c"
	}
#line 621 "../src/Connection.vala"
	_tmp26_ = (gchar*) xmlGetProp (node, (xmlChar*) "sticker");
#line 621 "../src/Connection.vala"
	sk = _tmp26_;
#line 622 "../src/Connection.vala"
	_tmp27_ = sk;
#line 622 "../src/Connection.vala"
	if (_tmp27_ != NULL) {
#line 3644 "Connection.c"
		const gchar* _tmp28_;
#line 623 "../src/Connection.vala"
		_tmp28_ = sk;
#line 623 "../src/Connection.vala"
		connection_set_sticker (self, _tmp28_);
#line 3650 "Connection.c"
	}
#line 629 "../src/Connection.vala"
	_tmp29_ = self->priv->_from_node;
#line 629 "../src/Connection.vala"
	node_bbox (_tmp29_, &_tmp30_, &_tmp31_, &_tmp32_, &_tmp33_);
#line 629 "../src/Connection.vala"
	fx = _tmp30_;
#line 629 "../src/Connection.vala"
	fy = _tmp31_;
#line 629 "../src/Connection.vala"
	fw = _tmp32_;
#line 629 "../src/Connection.vala"
	fh = _tmp33_;
#line 630 "../src/Connection.vala"
	_tmp34_ = self->priv->_to_node;
#line 630 "../src/Connection.vala"
	node_bbox (_tmp34_, &_tmp35_, &_tmp36_, &_tmp37_, &_tmp38_);
#line 630 "../src/Connection.vala"
	tx = _tmp35_;
#line 630 "../src/Connection.vala"
	ty = _tmp36_;
#line 630 "../src/Connection.vala"
	tw = _tmp37_;
#line 630 "../src/Connection.vala"
	th = _tmp38_;
#line 631 "../src/Connection.vala"
	_tmp39_ = bezier_new_with_endpoints (fx + (fw / 2), fy + (fh / 2), tx + (tw / 2), ty + (th / 2));
#line 631 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 631 "../src/Connection.vala"
	self->priv->_curve = _tmp39_;
#line 632 "../src/Connection.vala"
	_tmp40_ = self->priv->_curve;
#line 632 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp40_, self->priv->_dragx, self->priv->_dragy);
#line 633 "../src/Connection.vala"
	_tmp41_ = self->priv->_from_node;
#line 633 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp41_);
#line 634 "../src/Connection.vala"
	_tmp42_ = self->priv->_to_node;
#line 634 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp42_);
#line 3694 "Connection.c"
	{
		xmlNode* it = NULL;
		xmlNode* _tmp43_;
#line 637 "../src/Connection.vala"
		_tmp43_ = node->children;
#line 637 "../src/Connection.vala"
		it = _tmp43_;
#line 3702 "Connection.c"
		{
			gboolean _tmp44_ = FALSE;
#line 637 "../src/Connection.vala"
			_tmp44_ = TRUE;
#line 637 "../src/Connection.vala"
			while (TRUE) {
#line 3709 "Connection.c"
				xmlNode* _tmp47_;
				xmlNode* _tmp48_;
#line 637 "../src/Connection.vala"
				if (!_tmp44_) {
#line 3714 "Connection.c"
					xmlNode* _tmp45_;
					xmlNode* _tmp46_;
#line 637 "../src/Connection.vala"
					_tmp45_ = it;
#line 637 "../src/Connection.vala"
					_tmp46_ = _tmp45_->next;
#line 637 "../src/Connection.vala"
					it = _tmp46_;
#line 3723 "Connection.c"
				}
#line 637 "../src/Connection.vala"
				_tmp44_ = FALSE;
#line 637 "../src/Connection.vala"
				_tmp47_ = it;
#line 637 "../src/Connection.vala"
				if (!(_tmp47_ != NULL)) {
#line 637 "../src/Connection.vala"
					break;
#line 3733 "Connection.c"
				}
#line 638 "../src/Connection.vala"
				_tmp48_ = it;
#line 638 "../src/Connection.vala"
				if (_tmp48_->type == XML_ELEMENT_NODE) {
#line 3739 "Connection.c"
					xmlNode* _tmp49_;
					const gchar* _tmp50_;
					const gchar* _tmp51_;
					GQuark _tmp53_ = 0U;
#line 639 "../src/Connection.vala"
					static GQuark _tmp52_label0 = 0;
#line 639 "../src/Connection.vala"
					static GQuark _tmp52_label1 = 0;
#line 639 "../src/Connection.vala"
					static GQuark _tmp52_label2 = 0;
#line 639 "../src/Connection.vala"
					_tmp49_ = it;
#line 639 "../src/Connection.vala"
					_tmp50_ = _tmp49_->name;
#line 639 "../src/Connection.vala"
					_tmp51_ = _tmp50_;
#line 639 "../src/Connection.vala"
					_tmp53_ = (NULL == _tmp51_) ? 0 : g_quark_from_string (_tmp51_);
#line 639 "../src/Connection.vala"
					if (_tmp53_ == ((0 != _tmp52_label0) ? _tmp52_label0 : (_tmp52_label0 = g_quark_from_static_string ("style")))) {
#line 639 "../src/Connection.vala"
						switch (0) {
#line 3762 "Connection.c"
							default:
							{
								Style* _tmp54_;
								Style* _tmp55_;
								xmlNode* _tmp56_;
#line 640 "../src/Connection.vala"
								_tmp54_ = connection_get_style (self);
#line 640 "../src/Connection.vala"
								_tmp55_ = _tmp54_;
#line 640 "../src/Connection.vala"
								_tmp56_ = it;
#line 640 "../src/Connection.vala"
								style_load_connection (_tmp55_, _tmp56_);
#line 640 "../src/Connection.vala"
								break;
#line 3778 "Connection.c"
							}
						}
					} else if (_tmp53_ == ((0 != _tmp52_label1) ? _tmp52_label1 : (_tmp52_label1 = g_quark_from_static_string ("title")))) {
#line 639 "../src/Connection.vala"
						switch (0) {
#line 3784 "Connection.c"
							default:
							{
								gboolean _tmp57_ = FALSE;
								xmlNode* _tmp58_;
								xmlNode* _tmp59_;
#line 642 "../src/Connection.vala"
								_tmp58_ = it;
#line 642 "../src/Connection.vala"
								_tmp59_ = _tmp58_->children;
#line 642 "../src/Connection.vala"
								if (_tmp59_ != NULL) {
#line 3796 "Connection.c"
									xmlNode* _tmp60_;
									xmlNode* _tmp61_;
#line 642 "../src/Connection.vala"
									_tmp60_ = it;
#line 642 "../src/Connection.vala"
									_tmp61_ = _tmp60_->children;
#line 642 "../src/Connection.vala"
									_tmp57_ = _tmp61_->type == XML_TEXT_NODE;
#line 3805 "Connection.c"
								} else {
#line 642 "../src/Connection.vala"
									_tmp57_ = FALSE;
#line 3809 "Connection.c"
								}
#line 642 "../src/Connection.vala"
								if (_tmp57_) {
#line 3813 "Connection.c"
									xmlNode* _tmp62_;
									xmlNode* _tmp63_;
									gchar* _tmp64_;
									gchar* _tmp65_;
#line 643 "../src/Connection.vala"
									_tmp62_ = it;
#line 643 "../src/Connection.vala"
									_tmp63_ = _tmp62_->children;
#line 643 "../src/Connection.vala"
									_tmp64_ = (gchar*) xmlNodeGetContent (_tmp63_);
#line 643 "../src/Connection.vala"
									_tmp65_ = _tmp64_;
#line 643 "../src/Connection.vala"
									connection_change_title (self, da, _tmp65_, FALSE);
#line 643 "../src/Connection.vala"
									_g_free0 (_tmp65_);
#line 3830 "Connection.c"
								}
#line 645 "../src/Connection.vala"
								break;
#line 3834 "Connection.c"
							}
						}
					} else if (_tmp53_ == ((0 != _tmp52_label2) ? _tmp52_label2 : (_tmp52_label2 = g_quark_from_static_string ("note")))) {
#line 639 "../src/Connection.vala"
						switch (0) {
#line 3840 "Connection.c"
							default:
							{
								gboolean _tmp66_ = FALSE;
								xmlNode* _tmp67_;
								xmlNode* _tmp68_;
#line 647 "../src/Connection.vala"
								_tmp67_ = it;
#line 647 "../src/Connection.vala"
								_tmp68_ = _tmp67_->children;
#line 647 "../src/Connection.vala"
								if (_tmp68_ != NULL) {
#line 3852 "Connection.c"
									xmlNode* _tmp69_;
									xmlNode* _tmp70_;
#line 647 "../src/Connection.vala"
									_tmp69_ = it;
#line 647 "../src/Connection.vala"
									_tmp70_ = _tmp69_->children;
#line 647 "../src/Connection.vala"
									_tmp66_ = _tmp70_->type == XML_TEXT_NODE;
#line 3861 "Connection.c"
								} else {
#line 647 "../src/Connection.vala"
									_tmp66_ = FALSE;
#line 3865 "Connection.c"
								}
#line 647 "../src/Connection.vala"
								if (_tmp66_) {
#line 3869 "Connection.c"
									xmlNode* _tmp71_;
									xmlNode* _tmp72_;
									gchar* _tmp73_;
									gchar* _tmp74_;
#line 648 "../src/Connection.vala"
									_tmp71_ = it;
#line 648 "../src/Connection.vala"
									_tmp72_ = _tmp71_->children;
#line 648 "../src/Connection.vala"
									_tmp73_ = (gchar*) xmlNodeGetContent (_tmp72_);
#line 648 "../src/Connection.vala"
									_tmp74_ = _tmp73_;
#line 648 "../src/Connection.vala"
									connection_set_note (self, _tmp74_);
#line 648 "../src/Connection.vala"
									_g_free0 (_tmp74_);
#line 3886 "Connection.c"
								}
#line 650 "../src/Connection.vala"
								break;
#line 3890 "Connection.c"
							}
						}
					}
				}
			}
		}
	}
#line 586 "../src/Connection.vala"
	_g_free0 (sk);
#line 586 "../src/Connection.vala"
	_g_free0 (c);
#line 586 "../src/Connection.vala"
	_g_free0 (n);
#line 586 "../src/Connection.vala"
	_g_free0 (y);
#line 586 "../src/Connection.vala"
	_g_free0 (x);
#line 586 "../src/Connection.vala"
	_g_free0 (t);
#line 586 "../src/Connection.vala"
	_g_free0 (f);
#line 3912 "Connection.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 3943 "Connection.c"
}

void
connection_save (Connection* self,
                 xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	Node* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	xmlNode* _tmp5_;
	Node* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	xmlNode* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	xmlNode* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GdkRGBA* _tmp15_;
	const gchar* _tmp21_;
	Style* _tmp24_;
	Style* _tmp25_;
	xmlNode* _tmp26_;
	const gchar* _tmp27_ = NULL;
	CanvasText* _tmp28_;
	CanvasText* _tmp29_;
	xmlNode* _tmp36_;
	xmlNode* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	xmlNode* _tmp40_;
#line 658 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 660 "../src/Connection.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "connection");
#line 660 "../src/Connection.vala"
	n = _tmp0_;
#line 661 "../src/Connection.vala"
	_tmp1_ = n;
#line 661 "../src/Connection.vala"
	_tmp2_ = self->priv->_from_node;
#line 661 "../src/Connection.vala"
	_tmp3_ = g_strdup_printf ("%i", node_id (_tmp2_));
#line 661 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 661 "../src/Connection.vala"
	xmlSetProp (_tmp1_, (xmlChar*) "from_id", (xmlChar*) _tmp4_);
#line 661 "../src/Connection.vala"
	_g_free0 (_tmp4_);
#line 662 "../src/Connection.vala"
	_tmp5_ = n;
#line 662 "../src/Connection.vala"
	_tmp6_ = self->priv->_to_node;
#line 662 "../src/Connection.vala"
	_tmp7_ = g_strdup_printf ("%i", node_id (_tmp6_));
#line 662 "../src/Connection.vala"
	_tmp8_ = _tmp7_;
#line 662 "../src/Connection.vala"
	xmlSetProp (_tmp5_, (xmlChar*) "to_id", (xmlChar*) _tmp8_);
#line 662 "../src/Connection.vala"
	_g_free0 (_tmp8_);
#line 663 "../src/Connection.vala"
	_tmp9_ = n;
#line 663 "../src/Connection.vala"
	_tmp10_ = double_to_string (self->priv->_dragx);
#line 663 "../src/Connection.vala"
	_tmp11_ = _tmp10_;
#line 663 "../src/Connection.vala"
	xmlSetProp (_tmp9_, (xmlChar*) "drag_x", (xmlChar*) _tmp11_);
#line 663 "../src/Connection.vala"
	_g_free0 (_tmp11_);
#line 664 "../src/Connection.vala"
	_tmp12_ = n;
#line 664 "../src/Connection.vala"
	_tmp13_ = double_to_string (self->priv->_dragy);
#line 664 "../src/Connection.vala"
	_tmp14_ = _tmp13_;
#line 664 "../src/Connection.vala"
	xmlSetProp (_tmp12_, (xmlChar*) "drag_y", (xmlChar*) _tmp14_);
#line 664 "../src/Connection.vala"
	_g_free0 (_tmp14_);
#line 666 "../src/Connection.vala"
	_tmp15_ = self->priv->_color;
#line 666 "../src/Connection.vala"
	if (_tmp15_ != NULL) {
#line 4033 "Connection.c"
		xmlNode* _tmp16_;
		GdkRGBA* _tmp17_;
		GdkRGBA _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 667 "../src/Connection.vala"
		_tmp16_ = n;
#line 667 "../src/Connection.vala"
		_tmp17_ = self->priv->_color;
#line 667 "../src/Connection.vala"
		_tmp18_ = *_tmp17_;
#line 667 "../src/Connection.vala"
		_tmp19_ = utils_color_from_rgba (&_tmp18_);
#line 667 "../src/Connection.vala"
		_tmp20_ = _tmp19_;
#line 667 "../src/Connection.vala"
		xmlSetProp (_tmp16_, (xmlChar*) "color", (xmlChar*) _tmp20_);
#line 667 "../src/Connection.vala"
		_g_free0 (_tmp20_);
#line 4053 "Connection.c"
	}
#line 670 "../src/Connection.vala"
	_tmp21_ = self->priv->_sticker;
#line 670 "../src/Connection.vala"
	if (_tmp21_ != NULL) {
#line 4059 "Connection.c"
		xmlNode* _tmp22_;
		const gchar* _tmp23_;
#line 671 "../src/Connection.vala"
		_tmp22_ = n;
#line 671 "../src/Connection.vala"
		_tmp23_ = self->priv->_sticker;
#line 671 "../src/Connection.vala"
		xmlSetProp (_tmp22_, (xmlChar*) "sticker", (xmlChar*) _tmp23_);
#line 4068 "Connection.c"
	}
#line 675 "../src/Connection.vala"
	_tmp24_ = connection_get_style (self);
#line 675 "../src/Connection.vala"
	_tmp25_ = _tmp24_;
#line 675 "../src/Connection.vala"
	_tmp26_ = n;
#line 675 "../src/Connection.vala"
	style_save_connection (_tmp25_, _tmp26_);
#line 677 "../src/Connection.vala"
	_tmp28_ = connection_get_title (self);
#line 677 "../src/Connection.vala"
	_tmp29_ = _tmp28_;
#line 677 "../src/Connection.vala"
	if (_tmp29_ != NULL) {
#line 4084 "Connection.c"
		CanvasText* _tmp30_;
		CanvasText* _tmp31_;
		FormattedText* _tmp32_;
		FormattedText* _tmp33_;
		const gchar* _tmp34_;
		const gchar* _tmp35_;
#line 677 "../src/Connection.vala"
		_tmp30_ = connection_get_title (self);
#line 677 "../src/Connection.vala"
		_tmp31_ = _tmp30_;
#line 677 "../src/Connection.vala"
		_tmp32_ = canvas_text_get_text (_tmp31_);
#line 677 "../src/Connection.vala"
		_tmp33_ = _tmp32_;
#line 677 "../src/Connection.vala"
		_tmp34_ = formatted_text_get_text (_tmp33_);
#line 677 "../src/Connection.vala"
		_tmp35_ = _tmp34_;
#line 677 "../src/Connection.vala"
		_tmp27_ = _tmp35_;
#line 4105 "Connection.c"
	} else {
#line 677 "../src/Connection.vala"
		_tmp27_ = "";
#line 4109 "Connection.c"
	}
#line 677 "../src/Connection.vala"
	_tmp36_ = n;
#line 677 "../src/Connection.vala"
	xmlNewTextChild (_tmp36_, NULL, (xmlChar*) "title", (xmlChar*) _tmp27_);
#line 678 "../src/Connection.vala"
	_tmp37_ = n;
#line 678 "../src/Connection.vala"
	_tmp38_ = connection_get_note (self);
#line 678 "../src/Connection.vala"
	_tmp39_ = _tmp38_;
#line 678 "../src/Connection.vala"
	xmlNewTextChild (_tmp37_, NULL, (xmlChar*) "note", (xmlChar*) _tmp39_);
#line 680 "../src/Connection.vala"
	_tmp40_ = n;
#line 680 "../src/Connection.vala"
	xmlAddChild (parent, _tmp40_);
#line 4127 "Connection.c"
}

void
connection_get_match_items (Connection* self,
                            const gchar* tabname,
                            const gchar* pattern,
                            gboolean* search_opts,
                            gint search_opts_length1,
                            GtkListStore** matches)
{
	gchar* tab = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp21_;
#line 688 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 688 "../src/Connection.vala"
	g_return_if_fail (tabname != NULL);
#line 688 "../src/Connection.vala"
	g_return_if_fail (pattern != NULL);
#line 688 "../src/Connection.vala"
	g_return_if_fail (*matches != NULL);
#line 689 "../src/Connection.vala"
	_tmp0_ = utils_rootname (tabname);
#line 689 "../src/Connection.vala"
	tab = _tmp0_;
#line 690 "../src/Connection.vala"
	_tmp2_ = search_opts[2];
#line 690 "../src/Connection.vala"
	if (_tmp2_) {
#line 4159 "Connection.c"
		CanvasText* _tmp3_;
		CanvasText* _tmp4_;
#line 690 "../src/Connection.vala"
		_tmp3_ = connection_get_title (self);
#line 690 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 690 "../src/Connection.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 4168 "Connection.c"
	} else {
#line 690 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 4172 "Connection.c"
	}
#line 690 "../src/Connection.vala"
	if (_tmp1_) {
#line 4176 "Connection.c"
		gchar* str = NULL;
		CanvasText* _tmp5_;
		CanvasText* _tmp6_;
		FormattedText* _tmp7_;
		FormattedText* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
#line 691 "../src/Connection.vala"
		_tmp5_ = connection_get_title (self);
#line 691 "../src/Connection.vala"
		_tmp6_ = _tmp5_;
#line 691 "../src/Connection.vala"
		_tmp7_ = canvas_text_get_text (_tmp6_);
#line 691 "../src/Connection.vala"
		_tmp8_ = _tmp7_;
#line 691 "../src/Connection.vala"
		_tmp9_ = formatted_text_get_text (_tmp8_);
#line 691 "../src/Connection.vala"
		_tmp10_ = _tmp9_;
#line 691 "../src/Connection.vala"
		_tmp11_ = utils_match_string (pattern, _tmp10_);
#line 691 "../src/Connection.vala"
		str = _tmp11_;
#line 692 "../src/Connection.vala"
		_tmp12_ = str;
#line 692 "../src/Connection.vala"
		_tmp13_ = strlen (_tmp12_);
#line 692 "../src/Connection.vala"
		_tmp14_ = _tmp13_;
#line 692 "../src/Connection.vala"
		if (_tmp14_ > 0) {
#line 4212 "Connection.c"
			GtkTreeIter it = {0};
			GtkTreeIter _tmp15_ = {0};
			GtkTreeIter _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
#line 694 "../src/Connection.vala"
			gtk_list_store_append (*matches, &_tmp15_);
#line 694 "../src/Connection.vala"
			it = _tmp15_;
#line 695 "../src/Connection.vala"
			_tmp16_ = it;
#line 695 "../src/Connection.vala"
			_tmp17_ = g_strdup_printf ("<b><i>%s:</i></b>", _ ("Connection Title"));
#line 695 "../src/Connection.vala"
			_tmp18_ = _tmp17_;
#line 695 "../src/Connection.vala"
			_tmp19_ = str;
#line 695 "../src/Connection.vala"
			_tmp20_ = tab;
#line 695 "../src/Connection.vala"
			gtk_list_store_set (*matches, &_tmp16_, 0, _tmp18_, 1, _tmp19_, 2, NULL, 3, self, 4, tabname, 5, _tmp20_, -1, -1);
#line 695 "../src/Connection.vala"
			_g_free0 (_tmp18_);
#line 4238 "Connection.c"
		}
#line 690 "../src/Connection.vala"
		_g_free0 (str);
#line 4242 "Connection.c"
	}
#line 698 "../src/Connection.vala"
	_tmp21_ = search_opts[3];
#line 698 "../src/Connection.vala"
	if (_tmp21_) {
#line 4248 "Connection.c"
		gchar* str = NULL;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 699 "../src/Connection.vala"
		_tmp22_ = connection_get_note (self);
#line 699 "../src/Connection.vala"
		_tmp23_ = _tmp22_;
#line 699 "../src/Connection.vala"
		_tmp24_ = utils_match_string (pattern, _tmp23_);
#line 699 "../src/Connection.vala"
		str = _tmp24_;
#line 700 "../src/Connection.vala"
		_tmp25_ = str;
#line 700 "../src/Connection.vala"
		_tmp26_ = strlen (_tmp25_);
#line 700 "../src/Connection.vala"
		_tmp27_ = _tmp26_;
#line 700 "../src/Connection.vala"
		if (_tmp27_ > 0) {
#line 4272 "Connection.c"
			GtkTreeIter it = {0};
			GtkTreeIter _tmp28_ = {0};
			GtkTreeIter _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 702 "../src/Connection.vala"
			gtk_list_store_append (*matches, &_tmp28_);
#line 702 "../src/Connection.vala"
			it = _tmp28_;
#line 703 "../src/Connection.vala"
			_tmp29_ = it;
#line 703 "../src/Connection.vala"
			_tmp30_ = g_strdup_printf ("<b><i>%s:</i></b>", _ ("Connection Note"));
#line 703 "../src/Connection.vala"
			_tmp31_ = _tmp30_;
#line 703 "../src/Connection.vala"
			_tmp32_ = str;
#line 703 "../src/Connection.vala"
			_tmp33_ = tab;
#line 703 "../src/Connection.vala"
			gtk_list_store_set (*matches, &_tmp29_, 0, _tmp31_, 1, _tmp32_, 2, NULL, 3, self, 4, tabname, 5, _tmp33_, -1, -1);
#line 703 "../src/Connection.vala"
			_g_free0 (_tmp31_);
#line 4298 "Connection.c"
		}
#line 698 "../src/Connection.vala"
		_g_free0 (str);
#line 4302 "Connection.c"
	}
#line 688 "../src/Connection.vala"
	_g_free0 (tab);
#line 4306 "Connection.c"
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
#line 720 "../src/Connection.vala"
	return g_boxed_copy (gdk_rgba_get_type (), self);
#line 4314 "Connection.c"
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
#line 720 "../src/Connection.vala"
	return self ? _vala_GdkRGBA_copy (self) : NULL;
#line 4322 "Connection.c"
}

static void
connection_real_draw (Connection* self,
                      cairo_t* ctx,
                      Theme* theme)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
	gdouble start_x = 0.0;
	gdouble start_y = 0.0;
	gdouble end_x = 0.0;
	gdouble end_y = 0.0;
	gdouble dragx = 0.0;
	gdouble dragy = 0.0;
	GdkRGBA* _tmp19_ = NULL;
	GdkRGBA* _tmp20_;
	GdkRGBA ccolor = {0};
	GdkRGBA* _tmp24_ = NULL;
	ConnMode _tmp25_;
	ConnMode _tmp26_;
	GdkRGBA bg = {0};
	Node* _tmp29_;
	Node* _tmp33_;
	gdouble cx = 0.0;
	gdouble cy = 0.0;
	Style* _tmp37_;
	Style* _tmp38_;
	GdkRGBA _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
	gdouble _tmp42_ = 0.0;
	gdouble _tmp43_ = 0.0;
	gdouble _tmp44_ = 0.0;
	gdouble _tmp45_ = 0.0;
	gdouble* _tmp46_;
	gdouble* _tmp47_;
	gint _tmp47__length1;
	ConnMode _tmp48_;
	ConnMode _tmp49_;
	ConnMode _tmp76_;
	ConnMode _tmp77_;
	gboolean _tmp98_ = FALSE;
	gboolean _tmp99_ = FALSE;
	const gchar* _tmp100_;
#line 708 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 708 "../src/Connection.vala"
	g_return_if_fail (theme != NULL);
#line 711 "../src/Connection.vala"
	_tmp3_ = self->priv->_from_node;
#line 711 "../src/Connection.vala"
	if (_tmp3_ != NULL) {
#line 4382 "Connection.c"
		Node* _tmp4_;
#line 711 "../src/Connection.vala"
		_tmp4_ = self->priv->_from_node;
#line 711 "../src/Connection.vala"
		_tmp2_ = !node_is_root (_tmp4_);
#line 4388 "Connection.c"
	} else {
#line 711 "../src/Connection.vala"
		_tmp2_ = FALSE;
#line 4392 "Connection.c"
	}
#line 711 "../src/Connection.vala"
	if (_tmp2_) {
#line 4396 "Connection.c"
		Node* _tmp5_;
		Node* _tmp6_;
		Node* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 711 "../src/Connection.vala"
		_tmp5_ = self->priv->_from_node;
#line 711 "../src/Connection.vala"
		_tmp6_ = node_get_parent (_tmp5_);
#line 711 "../src/Connection.vala"
		_tmp7_ = _tmp6_;
#line 711 "../src/Connection.vala"
		_tmp8_ = node_get_folded (_tmp7_);
#line 711 "../src/Connection.vala"
		_tmp9_ = _tmp8_;
#line 711 "../src/Connection.vala"
		_tmp1_ = _tmp9_;
#line 4414 "Connection.c"
	} else {
#line 711 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 4418 "Connection.c"
	}
#line 711 "../src/Connection.vala"
	if (_tmp1_) {
#line 711 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 4424 "Connection.c"
	} else {
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		Node* _tmp12_;
#line 712 "../src/Connection.vala"
		_tmp12_ = self->priv->_to_node;
#line 712 "../src/Connection.vala"
		if (_tmp12_ != NULL) {
#line 4433 "Connection.c"
			Node* _tmp13_;
#line 712 "../src/Connection.vala"
			_tmp13_ = self->priv->_to_node;
#line 712 "../src/Connection.vala"
			_tmp11_ = !node_is_root (_tmp13_);
#line 4439 "Connection.c"
		} else {
#line 712 "../src/Connection.vala"
			_tmp11_ = FALSE;
#line 4443 "Connection.c"
		}
#line 712 "../src/Connection.vala"
		if (_tmp11_) {
#line 4447 "Connection.c"
			Node* _tmp14_;
			Node* _tmp15_;
			Node* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 712 "../src/Connection.vala"
			_tmp14_ = self->priv->_to_node;
#line 712 "../src/Connection.vala"
			_tmp15_ = node_get_parent (_tmp14_);
#line 712 "../src/Connection.vala"
			_tmp16_ = _tmp15_;
#line 712 "../src/Connection.vala"
			_tmp17_ = node_get_folded (_tmp16_);
#line 712 "../src/Connection.vala"
			_tmp18_ = _tmp17_;
#line 712 "../src/Connection.vala"
			_tmp10_ = _tmp18_;
#line 4465 "Connection.c"
		} else {
#line 712 "../src/Connection.vala"
			_tmp10_ = FALSE;
#line 4469 "Connection.c"
		}
#line 712 "../src/Connection.vala"
		_tmp0_ = _tmp10_;
#line 4473 "Connection.c"
	}
#line 711 "../src/Connection.vala"
	if (_tmp0_) {
#line 713 "../src/Connection.vala"
		return;
#line 4479 "Connection.c"
	}
#line 718 "../src/Connection.vala"
	dragx = self->priv->_dragx;
#line 719 "../src/Connection.vala"
	dragy = self->priv->_dragy;
#line 720 "../src/Connection.vala"
	_tmp20_ = self->priv->_color;
#line 720 "../src/Connection.vala"
	if (_tmp20_ != NULL) {
#line 4489 "Connection.c"
		GdkRGBA* _tmp21_;
		GdkRGBA* _tmp22_;
#line 720 "../src/Connection.vala"
		_tmp21_ = self->priv->_color;
#line 720 "../src/Connection.vala"
		_tmp22_ = __vala_GdkRGBA_copy0 (_tmp21_);
#line 720 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp19_);
#line 720 "../src/Connection.vala"
		_tmp19_ = _tmp22_;
#line 4500 "Connection.c"
	} else {
		GdkRGBA* _tmp23_;
#line 720 "../src/Connection.vala"
		_tmp23_ = theme_get_color (theme, "connection_background");
#line 720 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp19_);
#line 720 "../src/Connection.vala"
		_tmp19_ = _tmp23_;
#line 4509 "Connection.c"
	}
#line 720 "../src/Connection.vala"
	ccolor = *_tmp19_;
#line 721 "../src/Connection.vala"
	_tmp25_ = connection_get_mode (self);
#line 721 "../src/Connection.vala"
	_tmp26_ = _tmp25_;
#line 721 "../src/Connection.vala"
	if (_tmp26_ == CONN_MODE_NONE) {
#line 4519 "Connection.c"
		GdkRGBA* _tmp27_;
#line 721 "../src/Connection.vala"
		_tmp27_ = theme_get_color (theme, "background");
#line 721 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp24_);
#line 721 "../src/Connection.vala"
		_tmp24_ = _tmp27_;
#line 4527 "Connection.c"
	} else {
		GdkRGBA* _tmp28_;
#line 721 "../src/Connection.vala"
		_tmp28_ = theme_get_color (theme, "nodesel_background");
#line 721 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp24_);
#line 721 "../src/Connection.vala"
		_tmp24_ = _tmp28_;
#line 4536 "Connection.c"
	}
#line 721 "../src/Connection.vala"
	bg = *_tmp24_;
#line 723 "../src/Connection.vala"
	_tmp29_ = self->priv->_from_node;
#line 723 "../src/Connection.vala"
	if (_tmp29_ == NULL) {
#line 724 "../src/Connection.vala"
		start_x = self->priv->_posx;
#line 725 "../src/Connection.vala"
		start_y = self->priv->_posy;
#line 4548 "Connection.c"
	} else {
		Bezier* _tmp30_;
		gdouble _tmp31_ = 0.0;
		gdouble _tmp32_ = 0.0;
#line 727 "../src/Connection.vala"
		_tmp30_ = self->priv->_curve;
#line 727 "../src/Connection.vala"
		bezier_get_from_point (_tmp30_, &_tmp31_, &_tmp32_);
#line 727 "../src/Connection.vala"
		start_x = _tmp31_;
#line 727 "../src/Connection.vala"
		start_y = _tmp32_;
#line 4561 "Connection.c"
	}
#line 730 "../src/Connection.vala"
	_tmp33_ = self->priv->_to_node;
#line 730 "../src/Connection.vala"
	if (_tmp33_ == NULL) {
#line 731 "../src/Connection.vala"
		end_x = self->priv->_posx;
#line 732 "../src/Connection.vala"
		end_y = self->priv->_posy;
#line 4571 "Connection.c"
	} else {
		Bezier* _tmp34_;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
#line 734 "../src/Connection.vala"
		_tmp34_ = self->priv->_curve;
#line 734 "../src/Connection.vala"
		bezier_get_to_point (_tmp34_, &_tmp35_, &_tmp36_);
#line 734 "../src/Connection.vala"
		end_x = _tmp35_;
#line 734 "../src/Connection.vala"
		end_y = _tmp36_;
#line 4584 "Connection.c"
	}
#line 741 "../src/Connection.vala"
	cx = dragx - (((start_x + end_x) * 0.5) - dragx);
#line 742 "../src/Connection.vala"
	cy = dragy - (((start_y + end_y) * 0.5) - dragy);
#line 745 "../src/Connection.vala"
	cairo_save (ctx);
#line 746 "../src/Connection.vala"
	_tmp37_ = connection_get_style (self);
#line 746 "../src/Connection.vala"
	_tmp38_ = _tmp37_;
#line 746 "../src/Connection.vala"
	style_draw_connection (_tmp38_, ctx);
#line 747 "../src/Connection.vala"
	_tmp39_ = ccolor;
#line 747 "../src/Connection.vala"
	_tmp40_ = connection_get_alpha (self);
#line 747 "../src/Connection.vala"
	_tmp41_ = _tmp40_;
#line 747 "../src/Connection.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp39_, _tmp41_);
#line 750 "../src/Connection.vala"
	cairo_move_to (ctx, start_x, start_y);
#line 751 "../src/Connection.vala"
	cairo_curve_to (ctx, ((2.0 / 3.0) * cx) + ((1.0 / 3.0) * start_x), ((2.0 / 3.0) * cy) + ((1.0 / 3.0) * start_y), ((2.0 / 3.0) * cx) + ((1.0 / 3.0) * end_x), ((2.0 / 3.0) * cy) + ((1.0 / 3.0) * end_y), end_x, end_y);
#line 760 "../src/Connection.vala"
	cairo_stroke_extents (ctx, &_tmp42_, &_tmp43_, &_tmp44_, &_tmp45_);
#line 760 "../src/Connection.vala"
	x1 = _tmp42_;
#line 760 "../src/Connection.vala"
	y1 = _tmp43_;
#line 760 "../src/Connection.vala"
	x2 = _tmp44_;
#line 760 "../src/Connection.vala"
	y2 = _tmp45_;
#line 761 "../src/Connection.vala"
	connection_set_extent_x1 (self, x1);
#line 762 "../src/Connection.vala"
	connection_set_extent_y1 (self, y1);
#line 763 "../src/Connection.vala"
	connection_set_extent_x2 (self, x2);
#line 764 "../src/Connection.vala"
	connection_set_extent_y2 (self, y2);
#line 766 "../src/Connection.vala"
	cairo_stroke (ctx);
#line 768 "../src/Connection.vala"
	_tmp46_ = g_new0 (gdouble, 0);
#line 768 "../src/Connection.vala"
	_tmp47_ = _tmp46_;
#line 768 "../src/Connection.vala"
	_tmp47__length1 = 0;
#line 768 "../src/Connection.vala"
	cairo_set_dash (ctx, _tmp47_, (gint) 0, (gdouble) 0);
#line 768 "../src/Connection.vala"
	_tmp47_ = (g_free (_tmp47_), NULL);
#line 771 "../src/Connection.vala"
	_tmp48_ = connection_get_mode (self);
#line 771 "../src/Connection.vala"
	_tmp49_ = _tmp48_;
#line 771 "../src/Connection.vala"
	if (_tmp49_ != CONN_MODE_SELECTED) {
#line 4646 "Connection.c"
		gboolean _tmp50_ = FALSE;
		Style* _tmp51_;
		Style* _tmp52_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		gboolean _tmp63_ = FALSE;
		Style* _tmp64_;
		Style* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
#line 772 "../src/Connection.vala"
		_tmp51_ = connection_get_style (self);
#line 772 "../src/Connection.vala"
		_tmp52_ = _tmp51_;
#line 772 "../src/Connection.vala"
		_tmp53_ = style_get_connection_arrow (_tmp52_);
#line 772 "../src/Connection.vala"
		_tmp54_ = _tmp53_;
#line 772 "../src/Connection.vala"
		if (g_strcmp0 (_tmp54_, "fromto") == 0) {
#line 772 "../src/Connection.vala"
			_tmp50_ = TRUE;
#line 4669 "Connection.c"
		} else {
			Style* _tmp55_;
			Style* _tmp56_;
			const gchar* _tmp57_;
			const gchar* _tmp58_;
#line 772 "../src/Connection.vala"
			_tmp55_ = connection_get_style (self);
#line 772 "../src/Connection.vala"
			_tmp56_ = _tmp55_;
#line 772 "../src/Connection.vala"
			_tmp57_ = style_get_connection_arrow (_tmp56_);
#line 772 "../src/Connection.vala"
			_tmp58_ = _tmp57_;
#line 772 "../src/Connection.vala"
			_tmp50_ = g_strcmp0 (_tmp58_, "both") == 0;
#line 4685 "Connection.c"
		}
#line 772 "../src/Connection.vala"
		if (_tmp50_) {
#line 4689 "Connection.c"
			Style* _tmp59_;
			Style* _tmp60_;
			gint* _tmp61_;
			gint* _tmp62_;
#line 773 "../src/Connection.vala"
			_tmp59_ = connection_get_style (self);
#line 773 "../src/Connection.vala"
			_tmp60_ = _tmp59_;
#line 773 "../src/Connection.vala"
			_tmp61_ = style_get_connection_line_width (_tmp60_);
#line 773 "../src/Connection.vala"
			_tmp62_ = _tmp61_;
#line 773 "../src/Connection.vala"
			connection_draw_arrow (ctx, *_tmp62_, end_x, end_y, cx, cy, (gdouble) 0);
#line 4704 "Connection.c"
		}
#line 775 "../src/Connection.vala"
		_tmp64_ = connection_get_style (self);
#line 775 "../src/Connection.vala"
		_tmp65_ = _tmp64_;
#line 775 "../src/Connection.vala"
		_tmp66_ = style_get_connection_arrow (_tmp65_);
#line 775 "../src/Connection.vala"
		_tmp67_ = _tmp66_;
#line 775 "../src/Connection.vala"
		if (g_strcmp0 (_tmp67_, "tofrom") == 0) {
#line 775 "../src/Connection.vala"
			_tmp63_ = TRUE;
#line 4718 "Connection.c"
		} else {
			Style* _tmp68_;
			Style* _tmp69_;
			const gchar* _tmp70_;
			const gchar* _tmp71_;
#line 775 "../src/Connection.vala"
			_tmp68_ = connection_get_style (self);
#line 775 "../src/Connection.vala"
			_tmp69_ = _tmp68_;
#line 775 "../src/Connection.vala"
			_tmp70_ = style_get_connection_arrow (_tmp69_);
#line 775 "../src/Connection.vala"
			_tmp71_ = _tmp70_;
#line 775 "../src/Connection.vala"
			_tmp63_ = g_strcmp0 (_tmp71_, "both") == 0;
#line 4734 "Connection.c"
		}
#line 775 "../src/Connection.vala"
		if (_tmp63_) {
#line 4738 "Connection.c"
			Style* _tmp72_;
			Style* _tmp73_;
			gint* _tmp74_;
			gint* _tmp75_;
#line 776 "../src/Connection.vala"
			_tmp72_ = connection_get_style (self);
#line 776 "../src/Connection.vala"
			_tmp73_ = _tmp72_;
#line 776 "../src/Connection.vala"
			_tmp74_ = style_get_connection_line_width (_tmp73_);
#line 776 "../src/Connection.vala"
			_tmp75_ = _tmp74_;
#line 776 "../src/Connection.vala"
			connection_draw_arrow (ctx, *_tmp75_, start_x, start_y, cx, cy, (gdouble) 0);
#line 4753 "Connection.c"
		}
	}
#line 781 "../src/Connection.vala"
	_tmp76_ = connection_get_mode (self);
#line 781 "../src/Connection.vala"
	_tmp77_ = _tmp76_;
#line 781 "../src/Connection.vala"
	if (_tmp77_ == CONN_MODE_SELECTED) {
#line 4762 "Connection.c"
		GdkRGBA _tmp78_;
		GdkRGBA _tmp79_;
		GdkRGBA _tmp80_;
		gdouble _tmp81_;
		gdouble _tmp82_;
		GdkRGBA _tmp83_;
		GdkRGBA _tmp84_;
		GdkRGBA _tmp85_;
		gdouble _tmp86_;
		gdouble _tmp87_;
		GdkRGBA _tmp88_;
		GdkRGBA _tmp89_;
		GdkRGBA _tmp90_;
		gdouble _tmp91_;
		gdouble _tmp92_;
		GdkRGBA _tmp93_;
		GdkRGBA _tmp94_;
		GdkRGBA _tmp95_;
		gdouble _tmp96_;
		gdouble _tmp97_;
#line 783 "../src/Connection.vala"
		_tmp78_ = bg;
#line 783 "../src/Connection.vala"
		_tmp79_ = bg;
#line 783 "../src/Connection.vala"
		_tmp80_ = bg;
#line 783 "../src/Connection.vala"
		_tmp81_ = connection_get_alpha (self);
#line 783 "../src/Connection.vala"
		_tmp82_ = _tmp81_;
#line 783 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp78_.red, _tmp79_.green, _tmp80_.blue, _tmp82_);
#line 784 "../src/Connection.vala"
		cairo_arc (ctx, start_x, start_y, (gdouble) self->priv->RADIUS, (gdouble) 0, 2 * G_PI);
#line 785 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 786 "../src/Connection.vala"
		_tmp83_ = ccolor;
#line 786 "../src/Connection.vala"
		_tmp84_ = ccolor;
#line 786 "../src/Connection.vala"
		_tmp85_ = ccolor;
#line 786 "../src/Connection.vala"
		_tmp86_ = connection_get_alpha (self);
#line 786 "../src/Connection.vala"
		_tmp87_ = _tmp86_;
#line 786 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp83_.red, _tmp84_.green, _tmp85_.blue, _tmp87_);
#line 787 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 789 "../src/Connection.vala"
		_tmp88_ = bg;
#line 789 "../src/Connection.vala"
		_tmp89_ = bg;
#line 789 "../src/Connection.vala"
		_tmp90_ = bg;
#line 789 "../src/Connection.vala"
		_tmp91_ = connection_get_alpha (self);
#line 789 "../src/Connection.vala"
		_tmp92_ = _tmp91_;
#line 789 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp88_.red, _tmp89_.green, _tmp90_.blue, _tmp92_);
#line 790 "../src/Connection.vala"
		cairo_arc (ctx, end_x, end_y, (gdouble) self->priv->RADIUS, (gdouble) 0, 2 * G_PI);
#line 791 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 792 "../src/Connection.vala"
		_tmp93_ = ccolor;
#line 792 "../src/Connection.vala"
		_tmp94_ = ccolor;
#line 792 "../src/Connection.vala"
		_tmp95_ = ccolor;
#line 792 "../src/Connection.vala"
		_tmp96_ = connection_get_alpha (self);
#line 792 "../src/Connection.vala"
		_tmp97_ = _tmp96_;
#line 792 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp93_.red, _tmp94_.green, _tmp95_.blue, _tmp97_);
#line 793 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 4843 "Connection.c"
	}
#line 798 "../src/Connection.vala"
	_tmp100_ = self->priv->_sticker;
#line 798 "../src/Connection.vala"
	if (_tmp100_ != NULL) {
#line 798 "../src/Connection.vala"
		_tmp99_ = TRUE;
#line 4851 "Connection.c"
	} else {
		CanvasText* _tmp101_;
		CanvasText* _tmp102_;
#line 798 "../src/Connection.vala"
		_tmp101_ = connection_get_title (self);
#line 798 "../src/Connection.vala"
		_tmp102_ = _tmp101_;
#line 798 "../src/Connection.vala"
		_tmp99_ = _tmp102_ != NULL;
#line 4861 "Connection.c"
	}
#line 798 "../src/Connection.vala"
	if (_tmp99_) {
#line 798 "../src/Connection.vala"
		_tmp98_ = TRUE;
#line 4867 "Connection.c"
	} else {
		const gchar* _tmp103_;
		const gchar* _tmp104_;
		gint _tmp105_;
		gint _tmp106_;
#line 798 "../src/Connection.vala"
		_tmp103_ = connection_get_note (self);
#line 798 "../src/Connection.vala"
		_tmp104_ = _tmp103_;
#line 798 "../src/Connection.vala"
		_tmp105_ = strlen (_tmp104_);
#line 798 "../src/Connection.vala"
		_tmp106_ = _tmp105_;
#line 798 "../src/Connection.vala"
		_tmp98_ = _tmp106_ > 0;
#line 4883 "Connection.c"
	}
#line 798 "../src/Connection.vala"
	if (_tmp98_) {
#line 800 "../src/Connection.vala"
		connection_draw_title (self, ctx, theme);
#line 4889 "Connection.c"
	} else {
		ConnMode _tmp107_;
		ConnMode _tmp108_;
#line 803 "../src/Connection.vala"
		_tmp107_ = connection_get_mode (self);
#line 803 "../src/Connection.vala"
		_tmp108_ = _tmp107_;
#line 803 "../src/Connection.vala"
		if (_tmp108_ != CONN_MODE_NONE) {
#line 4899 "Connection.c"
			GdkRGBA _tmp109_ = {0};
			gdouble _tmp110_;
			gdouble _tmp111_;
			ConnMode _tmp112_;
			ConnMode _tmp113_;
#line 805 "../src/Connection.vala"
			cairo_set_line_width (ctx, (gdouble) 1);
#line 806 "../src/Connection.vala"
			utils_color_from_string ("yellow", &_tmp109_);
#line 806 "../src/Connection.vala"
			_tmp110_ = connection_get_alpha (self);
#line 806 "../src/Connection.vala"
			_tmp111_ = _tmp110_;
#line 806 "../src/Connection.vala"
			utils_set_context_color_with_alpha (ctx, &_tmp109_, _tmp111_);
#line 807 "../src/Connection.vala"
			cairo_arc (ctx, dragx, dragy, (gdouble) self->priv->RADIUS, (gdouble) 0, 2 * G_PI);
#line 808 "../src/Connection.vala"
			cairo_fill_preserve (ctx);
#line 809 "../src/Connection.vala"
			_tmp112_ = connection_get_mode (self);
#line 809 "../src/Connection.vala"
			_tmp113_ = _tmp112_;
#line 809 "../src/Connection.vala"
			if (_tmp113_ == CONN_MODE_DROPPABLE) {
#line 4925 "Connection.c"
				GdkRGBA* _tmp114_;
				GdkRGBA* _tmp115_;
				gdouble _tmp116_;
				gdouble _tmp117_;
				GdkRGBA _tmp118_;
#line 810 "../src/Connection.vala"
				_tmp114_ = theme_get_color (theme, "attachable");
#line 810 "../src/Connection.vala"
				_tmp115_ = _tmp114_;
#line 810 "../src/Connection.vala"
				_tmp116_ = connection_get_alpha (self);
#line 810 "../src/Connection.vala"
				_tmp117_ = _tmp116_;
#line 810 "../src/Connection.vala"
				_tmp118_ = *_tmp115_;
#line 810 "../src/Connection.vala"
				utils_set_context_color_with_alpha (ctx, &_tmp118_, _tmp117_);
#line 810 "../src/Connection.vala"
				__vala_GdkRGBA_free0 (_tmp115_);
#line 811 "../src/Connection.vala"
				cairo_set_line_width (ctx, (gdouble) 4);
#line 4947 "Connection.c"
			} else {
				GdkRGBA _tmp119_;
				GdkRGBA _tmp120_;
				GdkRGBA _tmp121_;
				gdouble _tmp122_;
				gdouble _tmp123_;
#line 813 "../src/Connection.vala"
				_tmp119_ = ccolor;
#line 813 "../src/Connection.vala"
				_tmp120_ = ccolor;
#line 813 "../src/Connection.vala"
				_tmp121_ = ccolor;
#line 813 "../src/Connection.vala"
				_tmp122_ = connection_get_alpha (self);
#line 813 "../src/Connection.vala"
				_tmp123_ = _tmp122_;
#line 813 "../src/Connection.vala"
				cairo_set_source_rgba (ctx, _tmp119_.red, _tmp120_.green, _tmp121_.blue, _tmp123_);
#line 4966 "Connection.c"
			}
#line 815 "../src/Connection.vala"
			cairo_stroke (ctx);
#line 4970 "Connection.c"
		}
	}
#line 819 "../src/Connection.vala"
	cairo_restore (ctx);
#line 708 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (_tmp24_);
#line 708 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (_tmp19_);
#line 4979 "Connection.c"
}

void
connection_draw (Connection* self,
                 cairo_t* ctx,
                 Theme* theme)
{
	ConnectionClass* _klass_;
#line 708 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 708 "../src/Connection.vala"
	_klass_ = CONNECTION_GET_CLASS (self);
#line 708 "../src/Connection.vala"
	if (_klass_->draw) {
#line 708 "../src/Connection.vala"
		_klass_->draw (self, ctx, theme);
#line 4996 "Connection.c"
	}
}

static void
connection_draw_sticker (Connection* self,
                         cairo_t* ctx,
                         Theme* theme)
{
	GdkPixbuf* _tmp0_;
#line 824 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 824 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 824 "../src/Connection.vala"
	g_return_if_fail (theme != NULL);
#line 826 "../src/Connection.vala"
	_tmp0_ = self->priv->_sticker_buf;
#line 826 "../src/Connection.vala"
	if (_tmp0_ != NULL) {
#line 5016 "Connection.c"
		gdouble x = 0.0;
		gdouble y = 0.0;
		gdouble w = 0.0;
		gdouble h = 0.0;
		gdouble _tmp1_ = 0.0;
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		GdkPixbuf* _tmp5_;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 829 "../src/Connection.vala"
		connection_sticker_bbox (self, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 829 "../src/Connection.vala"
		x = _tmp1_;
#line 829 "../src/Connection.vala"
		y = _tmp2_;
#line 829 "../src/Connection.vala"
		w = _tmp3_;
#line 829 "../src/Connection.vala"
		h = _tmp4_;
#line 832 "../src/Connection.vala"
		_tmp5_ = self->priv->_sticker_buf;
#line 832 "../src/Connection.vala"
		gdk_cairo_set_source_pixbuf (ctx, _tmp5_, x, y);
#line 833 "../src/Connection.vala"
		_tmp6_ = connection_get_alpha (self);
#line 833 "../src/Connection.vala"
		_tmp7_ = _tmp6_;
#line 833 "../src/Connection.vala"
		cairo_paint_with_alpha (ctx, _tmp7_);
#line 5048 "Connection.c"
	}
}

static void
connection_draw_title (Connection* self,
                       cairo_t* ctx,
                       Theme* theme)
{
	GdkRGBA* _tmp0_ = NULL;
	GdkRGBA* _tmp1_;
	GdkRGBA* ccolor = NULL;
	GdkRGBA* _tmp5_;
	GdkRGBA* _tmp6_ = NULL;
	GdkRGBA* _tmp7_;
	GdkRGBA* fg = NULL;
	GdkRGBA* _tmp9_;
	gint* _tmp10_ = NULL;
	Style* _tmp11_;
	gint* _tmp12_;
	gint* _tmp13_;
	gint* _tmp14_;
	gint* padding = NULL;
	gint* _tmp17_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	gint* _tmp22_;
	gint* _tmp23_;
	gint* _tmp24_;
	gint* _tmp25_;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_;
	gdouble _tmp32_ = 0.0;
	gdouble _tmp33_;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_;
	GdkRGBA* _tmp38_;
	GdkRGBA* _tmp39_;
	GdkRGBA* _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gint* _tmp43_;
	ConnMode _tmp44_;
	ConnMode _tmp45_;
	CanvasText* _tmp52_;
	GdkRGBA* _tmp58_;
	GdkRGBA _tmp59_;
	gboolean _tmp60_ = FALSE;
	ConnMode _tmp61_;
	ConnMode _tmp62_;
#line 842 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 842 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 842 "../src/Connection.vala"
	g_return_if_fail (theme != NULL);
#line 844 "../src/Connection.vala"
	_tmp1_ = self->priv->_color;
#line 844 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 5116 "Connection.c"
		GdkRGBA* _tmp2_;
		GdkRGBA* _tmp3_;
#line 844 "../src/Connection.vala"
		_tmp2_ = self->priv->_color;
#line 844 "../src/Connection.vala"
		_tmp3_ = __vala_GdkRGBA_copy0 (_tmp2_);
#line 844 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp0_);
#line 844 "../src/Connection.vala"
		_tmp0_ = _tmp3_;
#line 5127 "Connection.c"
	} else {
		GdkRGBA* _tmp4_;
#line 844 "../src/Connection.vala"
		_tmp4_ = theme_get_color (theme, "connection_background");
#line 844 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp0_);
#line 844 "../src/Connection.vala"
		_tmp0_ = _tmp4_;
#line 5136 "Connection.c"
	}
#line 844 "../src/Connection.vala"
	_tmp5_ = __vala_GdkRGBA_copy0 (_tmp0_);
#line 844 "../src/Connection.vala"
	ccolor = _tmp5_;
#line 845 "../src/Connection.vala"
	_tmp7_ = theme_get_color (theme, "connection_foreground");
#line 845 "../src/Connection.vala"
	_tmp6_ = _tmp7_;
#line 845 "../src/Connection.vala"
	if (_tmp6_ == NULL) {
#line 5148 "Connection.c"
		GdkRGBA* _tmp8_;
#line 845 "../src/Connection.vala"
		_tmp8_ = theme_get_color (theme, "background");
#line 845 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp6_);
#line 845 "../src/Connection.vala"
		_tmp6_ = _tmp8_;
#line 5156 "Connection.c"
	}
#line 845 "../src/Connection.vala"
	_tmp9_ = _tmp6_;
#line 845 "../src/Connection.vala"
	_tmp6_ = NULL;
#line 845 "../src/Connection.vala"
	fg = _tmp9_;
#line 846 "../src/Connection.vala"
	_tmp11_ = self->priv->_style;
#line 846 "../src/Connection.vala"
	_tmp12_ = style_get_connection_padding (_tmp11_);
#line 846 "../src/Connection.vala"
	_tmp13_ = _tmp12_;
#line 846 "../src/Connection.vala"
	_tmp14_ = __int_dup0 (_tmp13_);
#line 846 "../src/Connection.vala"
	_tmp10_ = _tmp14_;
#line 846 "../src/Connection.vala"
	if (_tmp10_ == NULL) {
#line 5176 "Connection.c"
		gint _tmp15_;
		gint* _tmp16_;
#line 846 "../src/Connection.vala"
		_tmp15_ = 0;
#line 846 "../src/Connection.vala"
		_tmp16_ = __int_dup0 (&_tmp15_);
#line 846 "../src/Connection.vala"
		_g_free0 (_tmp10_);
#line 846 "../src/Connection.vala"
		_tmp10_ = _tmp16_;
#line 5187 "Connection.c"
	}
#line 846 "../src/Connection.vala"
	_tmp17_ = _tmp10_;
#line 846 "../src/Connection.vala"
	_tmp10_ = NULL;
#line 846 "../src/Connection.vala"
	padding = _tmp17_;
#line 850 "../src/Connection.vala"
	connection_title_bbox (self, &_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_);
#line 850 "../src/Connection.vala"
	x = _tmp18_;
#line 850 "../src/Connection.vala"
	y = _tmp19_;
#line 850 "../src/Connection.vala"
	w = _tmp20_;
#line 850 "../src/Connection.vala"
	h = _tmp21_;
#line 851 "../src/Connection.vala"
	_tmp22_ = padding;
#line 851 "../src/Connection.vala"
	x -= *_tmp22_;
#line 852 "../src/Connection.vala"
	_tmp23_ = padding;
#line 852 "../src/Connection.vala"
	y -= *_tmp23_;
#line 853 "../src/Connection.vala"
	_tmp24_ = padding;
#line 853 "../src/Connection.vala"
	w += (gdouble) ((*_tmp24_) * 2);
#line 854 "../src/Connection.vala"
	_tmp25_ = padding;
#line 854 "../src/Connection.vala"
	h += (gdouble) ((*_tmp25_) * 2);
#line 857 "../src/Connection.vala"
	_tmp27_ = self->priv->_extent_x1;
#line 857 "../src/Connection.vala"
	if (x < _tmp27_) {
#line 857 "../src/Connection.vala"
		_tmp26_ = x;
#line 5227 "Connection.c"
	} else {
		gdouble _tmp28_;
#line 857 "../src/Connection.vala"
		_tmp28_ = self->priv->_extent_x1;
#line 857 "../src/Connection.vala"
		_tmp26_ = _tmp28_;
#line 5234 "Connection.c"
	}
#line 857 "../src/Connection.vala"
	connection_set_extent_x1 (self, _tmp26_);
#line 858 "../src/Connection.vala"
	_tmp30_ = self->priv->_extent_y1;
#line 858 "../src/Connection.vala"
	if (y < _tmp30_) {
#line 858 "../src/Connection.vala"
		_tmp29_ = y;
#line 5244 "Connection.c"
	} else {
		gdouble _tmp31_;
#line 858 "../src/Connection.vala"
		_tmp31_ = self->priv->_extent_y1;
#line 858 "../src/Connection.vala"
		_tmp29_ = _tmp31_;
#line 5251 "Connection.c"
	}
#line 858 "../src/Connection.vala"
	connection_set_extent_y1 (self, _tmp29_);
#line 859 "../src/Connection.vala"
	_tmp33_ = self->priv->_extent_x2;
#line 859 "../src/Connection.vala"
	if ((x + w) > _tmp33_) {
#line 859 "../src/Connection.vala"
		_tmp32_ = x + w;
#line 5261 "Connection.c"
	} else {
		gdouble _tmp34_;
#line 859 "../src/Connection.vala"
		_tmp34_ = self->priv->_extent_x2;
#line 859 "../src/Connection.vala"
		_tmp32_ = _tmp34_;
#line 5268 "Connection.c"
	}
#line 859 "../src/Connection.vala"
	connection_set_extent_x2 (self, _tmp32_);
#line 860 "../src/Connection.vala"
	_tmp36_ = self->priv->_extent_y2;
#line 860 "../src/Connection.vala"
	if ((y + h) > _tmp36_) {
#line 860 "../src/Connection.vala"
		_tmp35_ = y + h;
#line 5278 "Connection.c"
	} else {
		gdouble _tmp37_;
#line 860 "../src/Connection.vala"
		_tmp37_ = self->priv->_extent_y2;
#line 860 "../src/Connection.vala"
		_tmp35_ = _tmp37_;
#line 5285 "Connection.c"
	}
#line 860 "../src/Connection.vala"
	connection_set_extent_y2 (self, _tmp35_);
#line 863 "../src/Connection.vala"
	_tmp38_ = ccolor;
#line 863 "../src/Connection.vala"
	_tmp39_ = ccolor;
#line 863 "../src/Connection.vala"
	_tmp40_ = ccolor;
#line 863 "../src/Connection.vala"
	_tmp41_ = connection_get_alpha (self);
#line 863 "../src/Connection.vala"
	_tmp42_ = _tmp41_;
#line 863 "../src/Connection.vala"
	cairo_set_source_rgba (ctx, (*_tmp38_).red, (*_tmp39_).green, (*_tmp40_).blue, _tmp42_);
#line 864 "../src/Connection.vala"
	_tmp43_ = padding;
#line 864 "../src/Connection.vala"
	granite_drawing_utilities_cairo_rounded_rectangle (ctx, x, y, w, h, (gdouble) ((*_tmp43_) * 2));
#line 865 "../src/Connection.vala"
	cairo_fill (ctx);
#line 868 "../src/Connection.vala"
	_tmp44_ = connection_get_mode (self);
#line 868 "../src/Connection.vala"
	_tmp45_ = _tmp44_;
#line 868 "../src/Connection.vala"
	if (_tmp45_ == CONN_MODE_DROPPABLE) {
#line 5313 "Connection.c"
		GdkRGBA* _tmp46_;
		GdkRGBA* _tmp47_;
		gdouble _tmp48_;
		gdouble _tmp49_;
		GdkRGBA _tmp50_;
		gint* _tmp51_;
#line 869 "../src/Connection.vala"
		_tmp46_ = theme_get_color (theme, "attachable");
#line 869 "../src/Connection.vala"
		_tmp47_ = _tmp46_;
#line 869 "../src/Connection.vala"
		_tmp48_ = connection_get_alpha (self);
#line 869 "../src/Connection.vala"
		_tmp49_ = _tmp48_;
#line 869 "../src/Connection.vala"
		_tmp50_ = *_tmp47_;
#line 869 "../src/Connection.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp50_, _tmp49_);
#line 869 "../src/Connection.vala"
		__vala_GdkRGBA_free0 (_tmp47_);
#line 870 "../src/Connection.vala"
		cairo_set_line_width (ctx, (gdouble) 4);
#line 871 "../src/Connection.vala"
		_tmp51_ = padding;
#line 871 "../src/Connection.vala"
		granite_drawing_utilities_cairo_rounded_rectangle (ctx, x, y, w, h, (gdouble) ((*_tmp51_) * 2));
#line 872 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 5342 "Connection.c"
	}
#line 876 "../src/Connection.vala"
	connection_draw_sticker (self, ctx, theme);
#line 879 "../src/Connection.vala"
	_tmp52_ = self->priv->_title;
#line 879 "../src/Connection.vala"
	if (_tmp52_ != NULL) {
#line 5350 "Connection.c"
		CanvasText* _tmp53_;
		GdkRGBA* _tmp54_;
		gdouble _tmp55_;
		gdouble _tmp56_;
		GdkRGBA _tmp57_;
#line 880 "../src/Connection.vala"
		_tmp53_ = self->priv->_title;
#line 880 "../src/Connection.vala"
		_tmp54_ = fg;
#line 880 "../src/Connection.vala"
		_tmp55_ = connection_get_alpha (self);
#line 880 "../src/Connection.vala"
		_tmp56_ = _tmp55_;
#line 880 "../src/Connection.vala"
		_tmp57_ = *_tmp54_;
#line 880 "../src/Connection.vala"
		canvas_text_draw (_tmp53_, ctx, theme, &_tmp57_, _tmp56_, FALSE);
#line 5368 "Connection.c"
	}
#line 884 "../src/Connection.vala"
	_tmp58_ = fg;
#line 884 "../src/Connection.vala"
	_tmp59_ = *_tmp58_;
#line 884 "../src/Connection.vala"
	connection_draw_note (self, ctx, &_tmp59_);
#line 887 "../src/Connection.vala"
	_tmp61_ = connection_get_mode (self);
#line 887 "../src/Connection.vala"
	_tmp62_ = _tmp61_;
#line 887 "../src/Connection.vala"
	if (_tmp62_ == CONN_MODE_SELECTED) {
#line 887 "../src/Connection.vala"
		_tmp60_ = TRUE;
#line 5384 "Connection.c"
	} else {
		ConnMode _tmp63_;
		ConnMode _tmp64_;
#line 887 "../src/Connection.vala"
		_tmp63_ = connection_get_mode (self);
#line 887 "../src/Connection.vala"
		_tmp64_ = _tmp63_;
#line 887 "../src/Connection.vala"
		_tmp60_ = _tmp64_ == CONN_MODE_ADJUSTING;
#line 5394 "Connection.c"
	}
#line 887 "../src/Connection.vala"
	if (_tmp60_) {
#line 5398 "Connection.c"
		GdkRGBA _tmp65_ = {0};
		gdouble _tmp66_;
		gdouble _tmp67_;
		gint* _tmp68_;
		GdkRGBA* _tmp69_;
		GdkRGBA* _tmp70_;
		GdkRGBA* _tmp71_;
		gdouble _tmp72_;
		gdouble _tmp73_;
#line 889 "../src/Connection.vala"
		utils_color_from_string ("yellow", &_tmp65_);
#line 889 "../src/Connection.vala"
		_tmp66_ = connection_get_alpha (self);
#line 889 "../src/Connection.vala"
		_tmp67_ = _tmp66_;
#line 889 "../src/Connection.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp65_, _tmp67_);
#line 890 "../src/Connection.vala"
		cairo_set_line_width (ctx, (gdouble) 1);
#line 891 "../src/Connection.vala"
		_tmp68_ = padding;
#line 891 "../src/Connection.vala"
		cairo_arc (ctx, self->priv->_dragx, (self->priv->_dragy + (h / 2)) + (*_tmp68_), (gdouble) self->priv->RADIUS, (gdouble) 0, 2 * G_PI);
#line 892 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 893 "../src/Connection.vala"
		_tmp69_ = ccolor;
#line 893 "../src/Connection.vala"
		_tmp70_ = ccolor;
#line 893 "../src/Connection.vala"
		_tmp71_ = ccolor;
#line 893 "../src/Connection.vala"
		_tmp72_ = connection_get_alpha (self);
#line 893 "../src/Connection.vala"
		_tmp73_ = _tmp72_;
#line 893 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, (*_tmp69_).red, (*_tmp70_).green, (*_tmp71_).blue, _tmp73_);
#line 894 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 5438 "Connection.c"
	}
#line 842 "../src/Connection.vala"
	_g_free0 (padding);
#line 842 "../src/Connection.vala"
	_g_free0 (_tmp10_);
#line 842 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (fg);
#line 842 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (_tmp6_);
#line 842 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (ccolor);
#line 842 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (_tmp0_);
#line 5452 "Connection.c"
}

static void
connection_draw_note (Connection* self,
                      cairo_t* ctx,
                      GdkRGBA* color)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 901 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 901 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 901 "../src/Connection.vala"
	g_return_if_fail (color != NULL);
#line 903 "../src/Connection.vala"
	_tmp0_ = connection_get_note (self);
#line 903 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 903 "../src/Connection.vala"
	_tmp2_ = strlen (_tmp1_);
#line 903 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 903 "../src/Connection.vala"
	if (_tmp3_ > 0) {
#line 5480 "Connection.c"
		gdouble x = 0.0;
		gdouble y = 0.0;
		gdouble w = 0.0;
		gdouble h = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		GdkRGBA _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
#line 907 "../src/Connection.vala"
		connection_note_bbox (self, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 907 "../src/Connection.vala"
		x = _tmp4_;
#line 907 "../src/Connection.vala"
		y = _tmp5_;
#line 907 "../src/Connection.vala"
		w = _tmp6_;
#line 907 "../src/Connection.vala"
		h = _tmp7_;
#line 909 "../src/Connection.vala"
		_tmp8_ = *color;
#line 909 "../src/Connection.vala"
		_tmp9_ = connection_get_alpha (self);
#line 909 "../src/Connection.vala"
		_tmp10_ = _tmp9_;
#line 909 "../src/Connection.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp8_, _tmp10_);
#line 910 "../src/Connection.vala"
		cairo_new_path (ctx);
#line 911 "../src/Connection.vala"
		cairo_set_line_width (ctx, (gdouble) 1);
#line 912 "../src/Connection.vala"
		cairo_move_to (ctx, x + 2, y);
#line 913 "../src/Connection.vala"
		cairo_line_to (ctx, x + 10, y);
#line 914 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 915 "../src/Connection.vala"
		cairo_move_to (ctx, x, y + 3);
#line 916 "../src/Connection.vala"
		cairo_line_to (ctx, x + 10, y + 3);
#line 917 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 918 "../src/Connection.vala"
		cairo_move_to (ctx, x, y + 6);
#line 919 "../src/Connection.vala"
		cairo_line_to (ctx, x + 10, y + 6);
#line 920 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 921 "../src/Connection.vala"
		cairo_move_to (ctx, x, y + 9);
#line 922 "../src/Connection.vala"
		cairo_line_to (ctx, x + 10, y + 9);
#line 923 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 5538 "Connection.c"
	}
}

void
connection_draw_arrow (cairo_t* ctx,
                       gint line_width,
                       gdouble tipx,
                       gdouble tipy,
                       gdouble tailx,
                       gdouble taily,
                       gdouble arrowLength)
{
	gdouble extlen[8] = {0};
	gdouble _tmp0_[8] = {0};
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	gdouble theta = 0.0;
	gdouble rad = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble phi2 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 933 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 935 "../src/Connection.vala"
	_tmp0_[0] = (gdouble) 12;
#line 935 "../src/Connection.vala"
	_tmp0_[1] = (gdouble) 13;
#line 935 "../src/Connection.vala"
	_tmp0_[2] = (gdouble) 14;
#line 935 "../src/Connection.vala"
	_tmp0_[3] = (gdouble) 15;
#line 935 "../src/Connection.vala"
	_tmp0_[4] = (gdouble) 16;
#line 935 "../src/Connection.vala"
	_tmp0_[5] = (gdouble) 17;
#line 935 "../src/Connection.vala"
	_tmp0_[6] = (gdouble) 18;
#line 935 "../src/Connection.vala"
	_tmp0_[7] = (gdouble) 18;
#line 935 "../src/Connection.vala"
	memcpy (extlen, _tmp0_, 8 * sizeof (gdouble));
#line 937 "../src/Connection.vala"
	if (arrowLength == ((gdouble) 0)) {
#line 5584 "Connection.c"
		gdouble _tmp1_;
#line 938 "../src/Connection.vala"
		_tmp1_ = extlen[line_width - 1];
#line 938 "../src/Connection.vala"
		arrowLength = _tmp1_;
#line 5590 "Connection.c"
	}
#line 941 "../src/Connection.vala"
	dx = tipx - tailx;
#line 942 "../src/Connection.vala"
	dy = tipy - taily;
#line 944 "../src/Connection.vala"
	theta = atan2 (dy, dx);
#line 946 "../src/Connection.vala"
	rad = 35 * (G_PI / 180);
#line 947 "../src/Connection.vala"
	x1 = tipx - (arrowLength * cos (theta + rad));
#line 948 "../src/Connection.vala"
	y1 = tipy - (arrowLength * sin (theta + rad));
#line 950 "../src/Connection.vala"
	phi2 = -35 * (G_PI / 180);
#line 951 "../src/Connection.vala"
	x2 = tipx - (arrowLength * cos (theta + phi2));
#line 952 "../src/Connection.vala"
	y2 = tipy - (arrowLength * sin (theta + phi2));
#line 955 "../src/Connection.vala"
	cairo_set_line_width (ctx, (gdouble) 1);
#line 956 "../src/Connection.vala"
	cairo_move_to (ctx, tipx, tipy);
#line 957 "../src/Connection.vala"
	cairo_line_to (ctx, x1, y1);
#line 958 "../src/Connection.vala"
	cairo_line_to (ctx, x2, y2);
#line 959 "../src/Connection.vala"
	cairo_close_path (ctx);
#line 960 "../src/Connection.vala"
	cairo_fill (ctx);
#line 5622 "Connection.c"
}

cairo_surface_t*
connection_make_arrow_icon (const gchar* type)
{
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	cairo_surface_t* result;
#line 965 "../src/Connection.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 967 "../src/Connection.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 100, 20);
#line 967 "../src/Connection.vala"
	surface = _tmp0_;
#line 968 "../src/Connection.vala"
	_tmp1_ = surface;
#line 968 "../src/Connection.vala"
	_tmp2_ = cairo_create (_tmp1_);
#line 968 "../src/Connection.vala"
	ctx = _tmp2_;
#line 970 "../src/Connection.vala"
	_tmp3_ = ctx;
#line 970 "../src/Connection.vala"
	cairo_set_source_rgba (_tmp3_, 0.5, 0.5, 0.5, (gdouble) 1);
#line 971 "../src/Connection.vala"
	_tmp4_ = ctx;
#line 971 "../src/Connection.vala"
	cairo_set_line_width (_tmp4_, (gdouble) 4);
#line 972 "../src/Connection.vala"
	_tmp5_ = ctx;
#line 972 "../src/Connection.vala"
	cairo_set_line_cap (_tmp5_, CAIRO_LINE_CAP_ROUND);
#line 973 "../src/Connection.vala"
	_tmp6_ = ctx;
#line 973 "../src/Connection.vala"
	cairo_move_to (_tmp6_, (gdouble) 15, (gdouble) 10);
#line 974 "../src/Connection.vala"
	_tmp7_ = ctx;
#line 974 "../src/Connection.vala"
	cairo_line_to (_tmp7_, (gdouble) 85, (gdouble) 10);
#line 975 "../src/Connection.vala"
	_tmp8_ = ctx;
#line 975 "../src/Connection.vala"
	cairo_stroke (_tmp8_);
#line 977 "../src/Connection.vala"
	if (g_strcmp0 (type, "fromto") == 0) {
#line 977 "../src/Connection.vala"
		_tmp9_ = TRUE;
#line 5682 "Connection.c"
	} else {
#line 977 "../src/Connection.vala"
		_tmp9_ = g_strcmp0 (type, "both") == 0;
#line 5686 "Connection.c"
	}
#line 977 "../src/Connection.vala"
	if (_tmp9_) {
#line 5690 "Connection.c"
		cairo_t* _tmp10_;
#line 978 "../src/Connection.vala"
		_tmp10_ = ctx;
#line 978 "../src/Connection.vala"
		connection_draw_arrow (_tmp10_, 4, (gdouble) 90, (gdouble) 10, (gdouble) 10, (gdouble) 10, (gdouble) 0);
#line 5696 "Connection.c"
	}
#line 980 "../src/Connection.vala"
	if (g_strcmp0 (type, "tofrom") == 0) {
#line 980 "../src/Connection.vala"
		_tmp11_ = TRUE;
#line 5702 "Connection.c"
	} else {
#line 980 "../src/Connection.vala"
		_tmp11_ = g_strcmp0 (type, "both") == 0;
#line 5706 "Connection.c"
	}
#line 980 "../src/Connection.vala"
	if (_tmp11_) {
#line 5710 "Connection.c"
		cairo_t* _tmp12_;
#line 981 "../src/Connection.vala"
		_tmp12_ = ctx;
#line 981 "../src/Connection.vala"
		connection_draw_arrow (_tmp12_, 4, (gdouble) 10, (gdouble) 10, (gdouble) 90, (gdouble) 10, (gdouble) 0);
#line 5716 "Connection.c"
	}
#line 984 "../src/Connection.vala"
	result = surface;
#line 984 "../src/Connection.vala"
	_cairo_destroy0 (ctx);
#line 984 "../src/Connection.vala"
	return result;
#line 5724 "Connection.c"
}

CanvasText*
connection_get_title (Connection* self)
{
	CanvasText* result;
	CanvasText* _tmp0_;
#line 61 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/Connection.vala"
	_tmp0_ = self->priv->_title;
#line 62 "../src/Connection.vala"
	result = _tmp0_;
#line 62 "../src/Connection.vala"
	return result;
#line 5740 "Connection.c"
}

const gchar*
connection_get_note (Connection* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 66 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/Connection.vala"
	_tmp0_ = self->priv->_note;
#line 67 "../src/Connection.vala"
	result = _tmp0_;
#line 67 "../src/Connection.vala"
	return result;
#line 5756 "Connection.c"
}

void
connection_set_note (Connection* self,
                     const gchar* value)
{
	gboolean was_empty = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
#line 69 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/Connection.vala"
	_tmp0_ = self->priv->_note;
#line 70 "../src/Connection.vala"
	_tmp1_ = strlen (_tmp0_);
#line 70 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 70 "../src/Connection.vala"
	was_empty = _tmp2_ == 0;
#line 71 "../src/Connection.vala"
	_tmp3_ = g_strdup (value);
#line 71 "../src/Connection.vala"
	_g_free0 (self->priv->_note);
#line 71 "../src/Connection.vala"
	self->priv->_note = _tmp3_;
#line 72 "../src/Connection.vala"
	_tmp4_ = self->priv->_note;
#line 72 "../src/Connection.vala"
	_tmp5_ = strlen (_tmp4_);
#line 72 "../src/Connection.vala"
	_tmp6_ = _tmp5_;
#line 72 "../src/Connection.vala"
	if (was_empty != (_tmp6_ == 0)) {
#line 73 "../src/Connection.vala"
		connection_position_title (self);
#line 5797 "Connection.c"
	}
#line 69 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_NOTE_PROPERTY]);
#line 5801 "Connection.c"
}

ConnMode
connection_get_mode (Connection* self)
{
	ConnMode result;
#line 78 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 79 "../src/Connection.vala"
	result = self->priv->_mode;
#line 79 "../src/Connection.vala"
	return result;
#line 5814 "Connection.c"
}

void
connection_set_mode (Connection* self,
                     ConnMode value)
{
#line 81 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 82 "../src/Connection.vala"
	if (self->priv->_mode != value) {
#line 83 "../src/Connection.vala"
		self->priv->_mode = value;
#line 84 "../src/Connection.vala"
		if (self->priv->_mode == CONN_MODE_EDITABLE) {
#line 5829 "Connection.c"
			CanvasText* _tmp0_;
#line 85 "../src/Connection.vala"
			_tmp0_ = self->priv->_title;
#line 85 "../src/Connection.vala"
			if (_tmp0_ != NULL) {
#line 5835 "Connection.c"
				CanvasText* _tmp1_;
				CanvasText* _tmp2_;
#line 86 "../src/Connection.vala"
				_tmp1_ = self->priv->_title;
#line 86 "../src/Connection.vala"
				canvas_text_set_edit (_tmp1_, TRUE);
#line 87 "../src/Connection.vala"
				_tmp2_ = self->priv->_title;
#line 87 "../src/Connection.vala"
				canvas_text_set_cursor_all (_tmp2_, FALSE);
#line 5846 "Connection.c"
			}
		} else {
			CanvasText* _tmp3_;
#line 89 "../src/Connection.vala"
			_tmp3_ = self->priv->_title;
#line 89 "../src/Connection.vala"
			if (_tmp3_ != NULL) {
#line 5854 "Connection.c"
				CanvasText* _tmp4_;
				CanvasText* _tmp5_;
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				CanvasText* _tmp8_;
				FormattedText* _tmp9_;
				FormattedText* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 90 "../src/Connection.vala"
				_tmp4_ = self->priv->_title;
#line 90 "../src/Connection.vala"
				canvas_text_set_edit (_tmp4_, FALSE);
#line 91 "../src/Connection.vala"
				_tmp5_ = self->priv->_title;
#line 91 "../src/Connection.vala"
				canvas_text_clear_selection (_tmp5_, NULL);
#line 92 "../src/Connection.vala"
				_tmp8_ = self->priv->_title;
#line 92 "../src/Connection.vala"
				_tmp9_ = canvas_text_get_text (_tmp8_);
#line 92 "../src/Connection.vala"
				_tmp10_ = _tmp9_;
#line 92 "../src/Connection.vala"
				_tmp11_ = formatted_text_get_text (_tmp10_);
#line 92 "../src/Connection.vala"
				_tmp12_ = _tmp11_;
#line 92 "../src/Connection.vala"
				if (g_strcmp0 (_tmp12_, "") == 0) {
#line 5884 "Connection.c"
					const gchar* _tmp13_;
#line 92 "../src/Connection.vala"
					_tmp13_ = self->priv->_sticker;
#line 92 "../src/Connection.vala"
					_tmp7_ = _tmp13_ == NULL;
#line 5890 "Connection.c"
				} else {
#line 92 "../src/Connection.vala"
					_tmp7_ = FALSE;
#line 5894 "Connection.c"
				}
#line 92 "../src/Connection.vala"
				if (_tmp7_) {
#line 5898 "Connection.c"
					const gchar* _tmp14_;
#line 92 "../src/Connection.vala"
					_tmp14_ = self->priv->_note;
#line 92 "../src/Connection.vala"
					_tmp6_ = g_strcmp0 (_tmp14_, "") == 0;
#line 5904 "Connection.c"
				} else {
#line 92 "../src/Connection.vala"
					_tmp6_ = FALSE;
#line 5908 "Connection.c"
				}
#line 92 "../src/Connection.vala"
				if (_tmp6_) {
#line 93 "../src/Connection.vala"
					_g_object_unref0 (self->priv->_title);
#line 93 "../src/Connection.vala"
					self->priv->_title = NULL;
#line 5916 "Connection.c"
				}
			}
		}
	}
#line 81 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_MODE_PROPERTY]);
#line 5923 "Connection.c"
}

Node*
connection_get_from_node (Connection* self)
{
	Node* result;
	Node* _tmp0_;
#line 100 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/Connection.vala"
	_tmp0_ = self->priv->_from_node;
#line 101 "../src/Connection.vala"
	result = _tmp0_;
#line 101 "../src/Connection.vala"
	return result;
#line 5939 "Connection.c"
}

void
connection_set_from_node (Connection* self,
                          Node* value)
{
	Node* _tmp0_;
#line 103 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/Connection.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 104 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 104 "../src/Connection.vala"
	self->priv->_from_node = _tmp0_;
#line 103 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_FROM_NODE_PROPERTY]);
#line 5957 "Connection.c"
}

Node*
connection_get_to_node (Connection* self)
{
	Node* result;
	Node* _tmp0_;
#line 108 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "../src/Connection.vala"
	_tmp0_ = self->priv->_to_node;
#line 109 "../src/Connection.vala"
	result = _tmp0_;
#line 109 "../src/Connection.vala"
	return result;
#line 5973 "Connection.c"
}

void
connection_set_to_node (Connection* self,
                        Node* value)
{
	Node* _tmp0_;
#line 111 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/Connection.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 112 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 112 "../src/Connection.vala"
	self->priv->_to_node = _tmp0_;
#line 111 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_TO_NODE_PROPERTY]);
#line 5991 "Connection.c"
}

Style*
connection_get_style (Connection* self)
{
	Style* result;
	Style* _tmp0_;
#line 116 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 117 "../src/Connection.vala"
	_tmp0_ = self->priv->_style;
#line 117 "../src/Connection.vala"
	result = _tmp0_;
#line 117 "../src/Connection.vala"
	return result;
#line 6007 "Connection.c"
}

void
connection_set_style (Connection* self,
                      Style* value)
{
	gboolean _tmp0_ = FALSE;
	Style* _tmp1_;
#line 119 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Connection.vala"
	_tmp1_ = self->priv->_style;
#line 120 "../src/Connection.vala"
	if (style_copy (_tmp1_, value)) {
#line 6022 "Connection.c"
		CanvasText* _tmp2_;
#line 120 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 120 "../src/Connection.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 6028 "Connection.c"
	} else {
#line 120 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 6032 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (_tmp0_) {
#line 6036 "Connection.c"
		CanvasText* _tmp3_;
		Style* _tmp4_;
		PangoFontDescription* _tmp5_;
		PangoFontDescription* _tmp6_;
		const gchar* _tmp7_;
		Style* _tmp8_;
		PangoFontDescription* _tmp9_;
		PangoFontDescription* _tmp10_;
		gint _tmp11_;
		CanvasText* _tmp12_;
		Style* _tmp13_;
		gint* _tmp14_;
		gint* _tmp15_;
#line 121 "../src/Connection.vala"
		_tmp3_ = self->priv->_title;
#line 121 "../src/Connection.vala"
		_tmp4_ = self->priv->_style;
#line 121 "../src/Connection.vala"
		_tmp5_ = style_get_connection_font (_tmp4_);
#line 121 "../src/Connection.vala"
		_tmp6_ = _tmp5_;
#line 121 "../src/Connection.vala"
		_tmp7_ = pango_font_description_get_family (_tmp6_);
#line 121 "../src/Connection.vala"
		_tmp8_ = self->priv->_style;
#line 121 "../src/Connection.vala"
		_tmp9_ = style_get_connection_font (_tmp8_);
#line 121 "../src/Connection.vala"
		_tmp10_ = _tmp9_;
#line 121 "../src/Connection.vala"
		_tmp11_ = pango_font_description_get_size (_tmp10_) / PANGO_SCALE;
#line 121 "../src/Connection.vala"
		canvas_text_set_font (_tmp3_, _tmp7_, &_tmp11_, 1.0);
#line 122 "../src/Connection.vala"
		_tmp12_ = self->priv->_title;
#line 122 "../src/Connection.vala"
		_tmp13_ = self->priv->_style;
#line 122 "../src/Connection.vala"
		_tmp14_ = style_get_connection_title_width (_tmp13_);
#line 122 "../src/Connection.vala"
		_tmp15_ = _tmp14_;
#line 122 "../src/Connection.vala"
		canvas_text_set_max_width (_tmp12_, *_tmp15_);
#line 123 "../src/Connection.vala"
		connection_position_title (self);
#line 6082 "Connection.c"
	}
#line 119 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_STYLE_PROPERTY]);
#line 6086 "Connection.c"
}

gdouble
connection_get_alpha (Connection* self)
{
	gdouble result;
#line 128 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 129 "../src/Connection.vala"
	result = self->priv->_alpha;
#line 129 "../src/Connection.vala"
	return result;
#line 6099 "Connection.c"
}

void
connection_set_alpha (Connection* self,
                      gdouble value)
{
#line 131 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Connection.vala"
	if (self->priv->_alpha != value) {
#line 6110 "Connection.c"
		Node* _tmp0_;
		Node* _tmp2_;
#line 133 "../src/Connection.vala"
		self->priv->_alpha = value;
#line 134 "../src/Connection.vala"
		_tmp0_ = self->priv->_from_node;
#line 134 "../src/Connection.vala"
		if (_tmp0_ != NULL) {
#line 6119 "Connection.c"
			Node* _tmp1_;
#line 135 "../src/Connection.vala"
			_tmp1_ = self->priv->_from_node;
#line 135 "../src/Connection.vala"
			node_set_alpha_only (_tmp1_, value);
#line 6125 "Connection.c"
		}
#line 137 "../src/Connection.vala"
		_tmp2_ = self->priv->_to_node;
#line 137 "../src/Connection.vala"
		if (_tmp2_ != NULL) {
#line 6131 "Connection.c"
			Node* _tmp3_;
#line 138 "../src/Connection.vala"
			_tmp3_ = self->priv->_to_node;
#line 138 "../src/Connection.vala"
			node_set_alpha_only (_tmp3_, value);
#line 6137 "Connection.c"
		}
	}
#line 131 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_ALPHA_PROPERTY]);
#line 6142 "Connection.c"
}

GdkRGBA*
connection_get_color (Connection* self)
{
	GdkRGBA* result;
	GdkRGBA* _tmp0_;
#line 144 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/Connection.vala"
	_tmp0_ = self->priv->_color;
#line 145 "../src/Connection.vala"
	result = _tmp0_;
#line 145 "../src/Connection.vala"
	return result;
#line 6158 "Connection.c"
}

void
connection_set_color (Connection* self,
                      GdkRGBA* value)
{
	GdkRGBA* _tmp0_;
#line 147 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Connection.vala"
	_tmp0_ = __vala_GdkRGBA_copy0 (value);
#line 148 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (self->priv->_color);
#line 148 "../src/Connection.vala"
	self->priv->_color = _tmp0_;
#line 147 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_COLOR_PROPERTY]);
#line 6176 "Connection.c"
}

const gchar*
connection_get_sticker (Connection* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 152 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 153 "../src/Connection.vala"
	_tmp0_ = self->priv->_sticker;
#line 153 "../src/Connection.vala"
	result = _tmp0_;
#line 153 "../src/Connection.vala"
	return result;
#line 6192 "Connection.c"
}

void
connection_set_sticker (Connection* self,
                        const gchar* value)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 155 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Connection.vala"
	_tmp0_ = self->priv->_sticker;
#line 156 "../src/Connection.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 6207 "Connection.c"
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 157 "../src/Connection.vala"
		_tmp1_ = g_strdup (value);
#line 157 "../src/Connection.vala"
		_g_free0 (self->priv->_sticker);
#line 157 "../src/Connection.vala"
		self->priv->_sticker = _tmp1_;
#line 158 "../src/Connection.vala"
		_tmp2_ = self->priv->_sticker;
#line 158 "../src/Connection.vala"
		if (_tmp2_ != NULL) {
#line 6220 "Connection.c"
			GdkPixbuf* _tmp3_ = NULL;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 159 "../src/Connection.vala"
			_tmp4_ = self->priv->_sticker;
#line 159 "../src/Connection.vala"
			_tmp5_ = g_strconcat ("/com/github/phase1geo/minder/", _tmp4_, NULL);
#line 159 "../src/Connection.vala"
			_tmp6_ = _tmp5_;
#line 159 "../src/Connection.vala"
			_tmp7_ = gdk_pixbuf_new_from_resource (_tmp6_, &_inner_error0_);
#line 159 "../src/Connection.vala"
			_tmp8_ = _tmp7_;
#line 159 "../src/Connection.vala"
			_g_free0 (_tmp6_);
#line 159 "../src/Connection.vala"
			_tmp3_ = _tmp8_;
#line 159 "../src/Connection.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/Connection.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "../src/Connection.vala"
				g_clear_error (&_inner_error0_);
#line 159 "../src/Connection.vala"
				return;
#line 6250 "Connection.c"
			}
#line 159 "../src/Connection.vala"
			_tmp9_ = _tmp3_;
#line 159 "../src/Connection.vala"
			_tmp3_ = NULL;
#line 159 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_sticker_buf);
#line 159 "../src/Connection.vala"
			self->priv->_sticker_buf = _tmp9_;
#line 158 "../src/Connection.vala"
			_g_object_unref0 (_tmp3_);
#line 6262 "Connection.c"
		} else {
#line 161 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_sticker_buf);
#line 161 "../src/Connection.vala"
			self->priv->_sticker_buf = NULL;
#line 6268 "Connection.c"
		}
#line 163 "../src/Connection.vala"
		connection_position_title (self);
#line 6272 "Connection.c"
	}
#line 155 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_STICKER_PROPERTY]);
#line 6276 "Connection.c"
}

gdouble
connection_get_extent_x1 (Connection* self)
{
	gdouble result;
#line 167 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 167 "../src/Connection.vala"
	result = self->priv->_extent_x1;
#line 167 "../src/Connection.vala"
	return result;
#line 6289 "Connection.c"
}

static void
connection_set_extent_x1 (Connection* self,
                          gdouble value)
{
	gdouble old_value;
#line 167 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/Connection.vala"
	old_value = connection_get_extent_x1 (self);
#line 167 "../src/Connection.vala"
	if (old_value != value) {
#line 167 "../src/Connection.vala"
		self->priv->_extent_x1 = value;
#line 167 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_EXTENT_X1_PROPERTY]);
#line 6307 "Connection.c"
	}
}

gdouble
connection_get_extent_y1 (Connection* self)
{
	gdouble result;
#line 168 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 168 "../src/Connection.vala"
	result = self->priv->_extent_y1;
#line 168 "../src/Connection.vala"
	return result;
#line 6321 "Connection.c"
}

static void
connection_set_extent_y1 (Connection* self,
                          gdouble value)
{
	gdouble old_value;
#line 168 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Connection.vala"
	old_value = connection_get_extent_y1 (self);
#line 168 "../src/Connection.vala"
	if (old_value != value) {
#line 168 "../src/Connection.vala"
		self->priv->_extent_y1 = value;
#line 168 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_EXTENT_Y1_PROPERTY]);
#line 6339 "Connection.c"
	}
}

gdouble
connection_get_extent_x2 (Connection* self)
{
	gdouble result;
#line 169 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 169 "../src/Connection.vala"
	result = self->priv->_extent_x2;
#line 169 "../src/Connection.vala"
	return result;
#line 6353 "Connection.c"
}

static void
connection_set_extent_x2 (Connection* self,
                          gdouble value)
{
	gdouble old_value;
#line 169 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Connection.vala"
	old_value = connection_get_extent_x2 (self);
#line 169 "../src/Connection.vala"
	if (old_value != value) {
#line 169 "../src/Connection.vala"
		self->priv->_extent_x2 = value;
#line 169 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_EXTENT_X2_PROPERTY]);
#line 6371 "Connection.c"
	}
}

gdouble
connection_get_extent_y2 (Connection* self)
{
	gdouble result;
#line 170 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 170 "../src/Connection.vala"
	result = self->priv->_extent_y2;
#line 170 "../src/Connection.vala"
	return result;
#line 6385 "Connection.c"
}

static void
connection_set_extent_y2 (Connection* self,
                          gdouble value)
{
	gdouble old_value;
#line 170 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Connection.vala"
	old_value = connection_get_extent_y2 (self);
#line 170 "../src/Connection.vala"
	if (old_value != value) {
#line 170 "../src/Connection.vala"
		self->priv->_extent_y2 = value;
#line 170 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_EXTENT_Y2_PROPERTY]);
#line 6403 "Connection.c"
	}
}

static void
connection_class_init (ConnectionClass * klass,
                       gpointer klass_data)
{
#line 40 "../src/Connection.vala"
	connection_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/Connection.vala"
	g_type_class_adjust_private_offset (klass, &Connection_private_offset);
#line 40 "../src/Connection.vala"
	((ConnectionClass *) klass)->draw = (void (*) (Connection*, cairo_t*, Theme*)) connection_real_draw;
#line 40 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_connection_get_property;
#line 40 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_connection_set_property;
#line 40 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->finalize = connection_finalize;
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_TITLE_PROPERTY, connection_properties[CONNECTION_TITLE_PROPERTY] = g_param_spec_object ("title", "title", "title", TYPE_CANVAS_TEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_NOTE_PROPERTY, connection_properties[CONNECTION_NOTE_PROPERTY] = g_param_spec_string ("note", "note", "note", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_MODE_PROPERTY, connection_properties[CONNECTION_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", TYPE_CONN_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_FROM_NODE_PROPERTY, connection_properties[CONNECTION_FROM_NODE_PROPERTY] = g_param_spec_object ("from-node", "from-node", "from-node", TYPE_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_TO_NODE_PROPERTY, connection_properties[CONNECTION_TO_NODE_PROPERTY] = g_param_spec_object ("to-node", "to-node", "to-node", TYPE_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_STYLE_PROPERTY, connection_properties[CONNECTION_STYLE_PROPERTY] = param_spec_style ("style", "style", "style", TYPE_STYLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_ALPHA_PROPERTY, connection_properties[CONNECTION_ALPHA_PROPERTY] = g_param_spec_double ("alpha", "alpha", "alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_COLOR_PROPERTY, connection_properties[CONNECTION_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_STICKER_PROPERTY, connection_properties[CONNECTION_STICKER_PROPERTY] = g_param_spec_string ("sticker", "sticker", "sticker", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_EXTENT_X1_PROPERTY, connection_properties[CONNECTION_EXTENT_X1_PROPERTY] = g_param_spec_double ("extent-x1", "extent-x1", "extent-x1", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_EXTENT_Y1_PROPERTY, connection_properties[CONNECTION_EXTENT_Y1_PROPERTY] = g_param_spec_double ("extent-y1", "extent-y1", "extent-y1", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_EXTENT_X2_PROPERTY, connection_properties[CONNECTION_EXTENT_X2_PROPERTY] = g_param_spec_double ("extent-x2", "extent-x2", "extent-x2", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 40 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_EXTENT_Y2_PROPERTY, connection_properties[CONNECTION_EXTENT_Y2_PROPERTY] = g_param_spec_double ("extent-y2", "extent-y2", "extent-y2", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6449 "Connection.c"
}

static void
connection_instance_init (Connection * self,
                          gpointer klass)
{
	Style* _tmp0_;
	gchar* _tmp1_;
#line 40 "../src/Connection.vala"
	self->priv = connection_get_instance_private (self);
#line 42 "../src/Connection.vala"
	self->priv->RADIUS = 6;
#line 43 "../src/Connection.vala"
	self->priv->_mode = CONN_MODE_NONE;
#line 44 "../src/Connection.vala"
	self->priv->_from_node = NULL;
#line 45 "../src/Connection.vala"
	self->priv->_to_node = NULL;
#line 50 "../src/Connection.vala"
	_tmp0_ = style_new ();
#line 50 "../src/Connection.vala"
	self->priv->_style = _tmp0_;
#line 52 "../src/Connection.vala"
	self->priv->_title = NULL;
#line 53 "../src/Connection.vala"
	_tmp1_ = g_strdup ("");
#line 53 "../src/Connection.vala"
	self->priv->_note = _tmp1_;
#line 54 "../src/Connection.vala"
	self->priv->_max_width = (gdouble) 100;
#line 56 "../src/Connection.vala"
	self->priv->_sticker = NULL;
#line 57 "../src/Connection.vala"
	self->priv->_sticker_buf = NULL;
#line 58 "../src/Connection.vala"
	self->priv->_alpha = 1.0;
#line 167 "../src/Connection.vala"
	self->priv->_extent_x1 = 0.0;
#line 168 "../src/Connection.vala"
	self->priv->_extent_y1 = 0.0;
#line 169 "../src/Connection.vala"
	self->priv->_extent_x2 = 0.0;
#line 170 "../src/Connection.vala"
	self->priv->_extent_y2 = 0.0;
#line 6494 "Connection.c"
}

static void
connection_finalize (GObject * obj)
{
	Connection * self;
#line 40 "../src/Connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONNECTION, Connection);
#line 44 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 45 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 50 "../src/Connection.vala"
	_style_unref0 (self->priv->_style);
#line 51 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 52 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 53 "../src/Connection.vala"
	_g_free0 (self->priv->_note);
#line 55 "../src/Connection.vala"
	__vala_GdkRGBA_free0 (self->priv->_color);
#line 56 "../src/Connection.vala"
	_g_free0 (self->priv->_sticker);
#line 57 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_sticker_buf);
#line 40 "../src/Connection.vala"
	G_OBJECT_CLASS (connection_parent_class)->finalize (obj);
#line 6523 "Connection.c"
}

static GType
connection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Connection), 0, (GInstanceInitFunc) connection_instance_init, NULL };
	GType connection_type_id;
	connection_type_id = g_type_register_static (G_TYPE_OBJECT, "Connection", &g_define_type_info, 0);
	Connection_private_offset = g_type_add_instance_private (connection_type_id, sizeof (ConnectionPrivate));
	return connection_type_id;
}

GType
connection_get_type (void)
{
	static volatile gsize connection_type_id__once = 0;
	if (g_once_init_enter (&connection_type_id__once)) {
		GType connection_type_id;
		connection_type_id = connection_get_type_once ();
		g_once_init_leave (&connection_type_id__once, connection_type_id);
	}
	return connection_type_id__once;
}

static void
_vala_connection_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Connection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONNECTION, Connection);
#line 40 "../src/Connection.vala"
	switch (property_id) {
#line 40 "../src/Connection.vala"
		case CONNECTION_TITLE_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_object (value, connection_get_title (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_NOTE_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_string (value, connection_get_note (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_MODE_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_enum (value, connection_get_mode (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_FROM_NODE_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_object (value, connection_get_from_node (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_TO_NODE_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_object (value, connection_get_to_node (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_STYLE_PROPERTY:
#line 40 "../src/Connection.vala"
		value_set_style (value, connection_get_style (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_ALPHA_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_double (value, connection_get_alpha (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_COLOR_PROPERTY:
#line 6602 "Connection.c"
		{
			GdkRGBA* boxed;
#line 40 "../src/Connection.vala"
			boxed = connection_get_color (self);
#line 40 "../src/Connection.vala"
			g_value_set_boxed (value, boxed);
#line 6609 "Connection.c"
		}
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_STICKER_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_string (value, connection_get_sticker (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_X1_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_double (value, connection_get_extent_x1 (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_Y1_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_double (value, connection_get_extent_y1 (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_X2_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_double (value, connection_get_extent_x2 (self));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_Y2_PROPERTY:
#line 40 "../src/Connection.vala"
		g_value_set_double (value, connection_get_extent_y2 (self));
#line 40 "../src/Connection.vala"
		break;
#line 6643 "Connection.c"
		default:
#line 40 "../src/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/Connection.vala"
		break;
#line 6649 "Connection.c"
	}
}

static void
_vala_connection_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Connection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONNECTION, Connection);
#line 40 "../src/Connection.vala"
	switch (property_id) {
#line 40 "../src/Connection.vala"
		case CONNECTION_NOTE_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_note (self, g_value_get_string (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_MODE_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_mode (self, g_value_get_enum (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_FROM_NODE_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_from_node (self, g_value_get_object (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_TO_NODE_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_to_node (self, g_value_get_object (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_STYLE_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_style (self, value_get_style (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_ALPHA_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_alpha (self, g_value_get_double (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_COLOR_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_color (self, g_value_get_boxed (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_STICKER_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_sticker (self, g_value_get_string (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_X1_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_extent_x1 (self, g_value_get_double (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_Y1_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_extent_y1 (self, g_value_get_double (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_X2_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_extent_x2 (self, g_value_get_double (value));
#line 40 "../src/Connection.vala"
		break;
#line 40 "../src/Connection.vala"
		case CONNECTION_EXTENT_Y2_PROPERTY:
#line 40 "../src/Connection.vala"
		connection_set_extent_y2 (self, g_value_get_double (value));
#line 40 "../src/Connection.vala"
		break;
#line 6735 "Connection.c"
		default:
#line 40 "../src/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/Connection.vala"
		break;
#line 6741 "Connection.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

